'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _styles = require('@material-ui/core/styles');

var _Card = require('@material-ui/core/Card');

var _Card2 = _interopRequireDefault(_Card);

var _CardActions = require('@material-ui/core/CardActions');

var _CardActions2 = _interopRequireDefault(_CardActions);

var _CardContent = require('@material-ui/core/CardContent');

var _CardContent2 = _interopRequireDefault(_CardContent);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _MediaButtons = require('../subsonic/components/controls/MediaButtons');

var _RemoteSenderMenu = require('../subfire/components/remotes/RemoteSenderMenu');

var _RemoteSenderMenu2 = _interopRequireDefault(_RemoteSenderMenu);

var _FlowText = require('../subsonic/components/styled/FlowText');

var _FlowText2 = _interopRequireDefault(_FlowText);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = function styles(theme) {
  return {
    card: {
      minWidth: 275
    },
    bullet: {
      display: 'inline-block',
      margin: '0 2px',
      transform: 'scale(0.8)'
    },
    title: {
      marginBottom: 16,
      fontSize: 14,
      color: theme.palette.text.secondary
    },
    pos: {
      marginBottom: 12,
      color: theme.palette.text.secondary
    }
  };
};

var DemoMain = function DemoMain(props) {
  var classes = props.classes;

  var offline = props.subsonic.offline;
  var offlineContent = '';
  if (offline) offlineContent = _react2.default.createElement(
    'span',
    null,
    _react2.default.createElement('br', null),
    'THE APP IS CURRENTLY OFFLINE',
    _react2.default.createElement('br', null)
  );
  var csProps = props;

  var rsProps = {
    remotes: props.remotes,
    subsonic: props.subsonic,
    SubsonicSource: props.SubsonicSource
  };
  //      <Button size="small" component={Link} to="/tree">Tree</Button>

  return _react2.default.createElement(
    _Card2.default,
    { className: classes.card },
    _react2.default.createElement(
      _CardContent2.default,
      null,
      _react2.default.createElement(
        _Typography2.default,
        { variant: 'h2', component: 'h2', style: { paddingBottom: 10 } },
        'SubFire Baseline Demo 2.35.0 (including Video)'
      ),
      _react2.default.createElement(
        _FlowText2.default,
        { component: 'div', variant: 'body1' },
        'This app is meant to be a basic demo of all of the core features of the SubFire Subsonic framework. It is expected that subsequent apps start by making a clone of this and change App and components and styles to suit your use-cases.',
        offlineContent,
        _react2.default.createElement('br', null),
        'It will be used as the baseline for several released or upcoming projects:',
        _react2.default.createElement(
          'ul',
          null,
          _react2.default.createElement(
            'li',
            null,
            'A new mobile player along a browser extension and mini-player mode (done).'
          ),
          _react2.default.createElement(
            'li',
            null,
            'A new TV application (that will be tablet-compatible) for FireOS and potentially Android TV. (Beta released)'
          ),
          _react2.default.createElement(
            'li',
            null,
            'A rewrite of the "toothbrush timer" (done, but needs to be updated to most recent base).'
          ),
          _react2.default.createElement(
            'li',
            null,
            'A "Dashboard" app for landscape-phones in cars, following the Android Auto specification for safety (done).'
          ),
          _react2.default.createElement(
            'li',
            null,
            'A browser-based desktop app with playlist editor (designing).'
          ),
          _react2.default.createElement(
            'li',
            null,
            'A kids-room player with limited controls, playing triggered remotely by parent/guardian in another room.'
          )
        ),
        'All of these are packaged as Progressive Web Apps for easy deployment/installation through Chrome on multiple platforms.'
      )
    ),
    _react2.default.createElement(
      _CardActions2.default,
      null,
      _react2.default.createElement(
        _Button2.default,
        { size: 'small', component: _reactRouterDom.Link, to: '/artists' },
        'Artists (ID3)'
      ),
      _react2.default.createElement(
        _Button2.default,
        { size: 'small', component: _reactRouterDom.Link, to: '/albums' },
        'Albums'
      ),
      _react2.default.createElement(
        _Button2.default,
        { size: 'small', component: _reactRouterDom.Link, to: '/indexes' },
        'Folders'
      ),
      _react2.default.createElement(
        _Button2.default,
        { size: 'small', component: _reactRouterDom.Link, to: '/search' },
        'Search'
      ),
      _react2.default.createElement(
        _Button2.default,
        { size: 'small', component: _reactRouterDom.Link, to: '/prefs' },
        'Preferences'
      )
    ),
    _react2.default.createElement(
      _CardActions2.default,
      null,
      _react2.default.createElement(
        _Button2.default,
        { size: 'small', component: _reactRouterDom.Link, to: '/radio' },
        'SubFire Radio'
      ),
      _react2.default.createElement(
        _Button2.default,
        { size: 'small', component: _reactRouterDom.Link, to: '/playlists/all' },
        'All Playlists'
      ),
      _react2.default.createElement(
        _Button2.default,
        { size: 'small', component: _reactRouterDom.Link, to: '/playlists/normal' },
        'Playlists'
      ),
      _react2.default.createElement(
        _Button2.default,
        { size: 'small', component: _reactRouterDom.Link, to: '/podcasts' },
        'Podcasts'
      ),
      _react2.default.createElement(
        _Button2.default,
        { size: 'small', component: _reactRouterDom.Link, to: '/player' },
        'Resume'
      )
    ),
    _react2.default.createElement(
      _CardActions2.default,
      null,
      _react2.default.createElement(
        _Button2.default,
        { size: 'small', component: _reactRouterDom.Link, to: '/bookmarks' },
        'Bookmarks'
      ),
      _react2.default.createElement(
        _Button2.default,
        { size: 'small', component: _reactRouterDom.Link, to: '/loading/playQueue/0' },
        'Restore Play Queue'
      ),
      _react2.default.createElement(
        _Button2.default,
        { size: 'small', component: _reactRouterDom.Link, to: '/nowPlaying' },
        'Now Playing'
      ),
      _react2.default.createElement(
        _Button2.default,
        { size: 'small', component: _reactRouterDom.Link, to: '/videos' },
        'Videos'
      ),
      _react2.default.createElement(
        _Button2.default,
        { size: 'small', component: _reactRouterDom.Link, to: '/muppet' },
        'Muppets!'
      )
    ),
    _react2.default.createElement(
      _CardActions2.default,
      null,
      _react2.default.createElement(
        _Button2.default,
        { size: 'small', component: _reactRouterDom.Link, to: '/remote' },
        'Receive'
      ),
      _react2.default.createElement(
        _Button2.default,
        { size: 'small', component: _reactRouterDom.Link, to: '/remoteControl' },
        'Remote Control'
      ),
      _react2.default.createElement(_RemoteSenderMenu2.default, _extends({ variant: 'listItem' }, rsProps)),
      _react2.default.createElement(_MediaButtons.ChromecastButton, csProps)
    )
  );
};

exports.default = (0, _styles.withStyles)(styles)(DemoMain);
module.exports = exports.default;