'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _Card = require('@material-ui/core/Card');

var _Card2 = _interopRequireDefault(_Card);

var _CardActions = require('@material-ui/core/CardActions');

var _CardActions2 = _interopRequireDefault(_CardActions);

var _CardContent = require('@material-ui/core/CardContent');

var _CardContent2 = _interopRequireDefault(_CardContent);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _SubsonicStore = require('../subsonic/stores/SubsonicStore');

var _MediaButtons = require('../subsonic/components/controls/MediaButtons');

var _RemoteReceiverToggleButton = require('../subfire/components/remotes/RemoteReceiverToggleButton');

var _RemoteReceiverToggleButton2 = _interopRequireDefault(_RemoteReceiverToggleButton);

var _Notification = require('../subsonic/components/controls/Notification');

var _Notification2 = _interopRequireDefault(_Notification);

var _SubsonicActions = require('../subsonic/actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

var _ColorActions = require('../subfire/actions/ColorActions');

var _ColorActions2 = _interopRequireDefault(_ColorActions);

var _GradientGeneratingImage = require('../subfire/components/GradientGeneratingImage');

var _GradientGeneratingImage2 = _interopRequireDefault(_GradientGeneratingImage);

var _FlexibleBackground = require('../subfire/components/FlexibleBackground');

var _FlexibleBackground2 = _interopRequireDefault(_FlexibleBackground);

var _NowPlaying = require('../subsonic/components/controls/NowPlaying');

var _NowPlaying2 = _interopRequireDefault(_NowPlaying);

var _RangeSlider = require('../subsonic/components/controls/RangeSlider');

var _RangeSlider2 = _interopRequireDefault(_RangeSlider);

var _HollowCard = require('../subsonic/components/styled/HollowCard');

var _HollowCard2 = _interopRequireDefault(_HollowCard);

var _FormatListBulleted = require('@material-ui/icons/FormatListBulleted');

var _FormatListBulleted2 = _interopRequireDefault(_FormatListBulleted);

var _SongListDrawer = require('../subsonic/components/styled/SongListDrawer');

var _SongListDrawer2 = _interopRequireDefault(_SongListDrawer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// import GradientBackground from "subfire/components/GradientBackground";
// import FuzzyImageBackground from "subfire/components/FuzzyImageBackground";

var DemoPlayer = function (_Component) {
  _inherits(DemoPlayer, _Component);

  _createClass(DemoPlayer, null, [{
    key: 'handleMediaType',
    value: function handleMediaType(currentFile) {
      var m = document.querySelector('#media_element');
      if (currentFile.isVideo) {
        m.style.visibility = 'visible';
        m.style.position = 'absolute';
        m.style.top = '60px';
        m.style.left = '0px';
        m.width = 800;
        m.height = 450;
      } else {
        m.style.visibility = 'hidden';
        m.style.position = 'absolute';
        m.style.left = '1px';
        m.style.top = '1px';
        m.width = 1;
        m.height = 1;
      }
    }
  }, {
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(props, prevState) {
      var _props$subsonic = props.subsonic,
          subsonic = _props$subsonic === undefined ? {} : _props$subsonic,
          SubsonicSource = props.SubsonicSource,
          csProps = props.csProps;
      var isConnected = subsonic.isConnected,
          currentPlaying = subsonic.currentPlaying;

      if (!isConnected) {
        return prevState;
      }
      var newState = void 0;
      if (!currentPlaying.queue.length) {
        newState = {
          showBackground: false,
          currentFile: _SubsonicStore.emptytrack,
          reason: csProps.reason
        };
      } else {
        var currentFile = currentPlaying.queue[currentPlaying.idx];
        var p = csProps;
        var showBackground = prevState.showBackground,
            isWaitingForNext = prevState.isWaitingForNext,
            coverSize = prevState.coverSize,
            coverArt = prevState.coverArt,
            mediaSrc = prevState.mediaSrc,
            mediaIcon = prevState.mediaIcon,
            reason = prevState.reason;

        if (currentFile !== prevState.currentFile) {
          console.log('next arrived', isWaitingForNext, reason, p.reason);
          isWaitingForNext = false;
          coverSize = Math.min(Math.trunc(window.innerWidth / 2), window.innerHeight - 200);
          coverArt = SubsonicSource.getCoverArtURL(currentFile.id, coverSize);
          mediaSrc = currentFile.localPath || (currentFile.src && currentFile.src.startsWith('http') ? currentFile.src : SubsonicSource.getStreamingURL(currentFile.id));
          mediaIcon = SubsonicSource.getCoverArtURL(currentFile.id, 192) + '&co=false';

          // now load castplayer
          currentFile.coverArtURL = coverArt;
          currentFile.src = mediaSrc;
          if (!window.cp.currentMedia || window.cp.currentMedia.src !== mediaSrc) {
            window.cp.playerHandler.load(currentFile, 0);
          }
          DemoPlayer.handleMediaType(currentFile);
        } else {
          if (!prevState.isWaitingForNext && reason !== p.reason && p.reason === 'playbackEnded') {
            console.log('endPlayback next...', reason, p.reason);
            isWaitingForNext = true;
            _SubsonicActions2.default.playerNext.defer();
          }
        }
        // hack - no easy way to pass this around
        if (window.bookmarkSeekTo) {
          window.castSubsonic.seekMedia(window.bookmarkSeekTo);
          delete window.bookmarkSeekTo;
        }

        if (prevState.showBackground !== p.isPlaying) {
          showBackground = p.isPlaying;
        }

        // if (p.reason !== 'normal') console.log('p', p);

        var currentMediaTimeString = p.currentMediaTimeString,
            durationString = p.durationString;


        newState = {
          currentFile: currentFile,
          coverArt: coverArt,
          mediaSrc: mediaSrc,
          mediaIcon: mediaIcon,
          coverSize: coverSize,
          showBackground: showBackground,
          isWaitingForNext: isWaitingForNext,
          currentMediaTimeString: currentMediaTimeString,
          durationString: durationString,
          reason: csProps.reason
        };
      }
      return Object.assign({}, prevState, newState);
    }
  }]);

  function DemoPlayer(props) {
    _classCallCheck(this, DemoPlayer);

    var _this = _possibleConstructorReturn(this, (DemoPlayer.__proto__ || Object.getPrototypeOf(DemoPlayer)).call(this, props));

    _this.toggleBookmark = function (currentMediaTime) {
      // console.log('toggleBookmark', currentMediaTime, this.props);
      var subsonic = _this.props.subsonic;
      var currentPlaying = subsonic.currentPlaying;

      var id = currentPlaying.queue[currentPlaying.idx].id;

      if (subsonic.bookmarksById[id]) {
        _SubsonicActions2.default.deleteBookmark(id);
      } else {
        _SubsonicActions2.default.createBookmark(id, Math.trunc(currentMediaTime * 1000));
      }
    };

    _this.handleSongDrawer = function (event) {
      _SubsonicActions2.default.toggleMenu();
    };

    _this.handleSongDrawerClose = function () {
      _SubsonicActions2.default.toggleMenu();
    };

    _this.handleSongClick = function (song, idx) {
      idx = idx * 1;
      _SubsonicActions2.default.playerSkipToIndex(idx);
      _SubsonicActions2.default.toggleMenu();
      // this.setState({songDrawerOpen: false});
    };

    _this.state = {
      // songDrawerOpen: false
    };
    // this.state = DemoPlayer.getDerivedStateFromProps(props);
    return _this;
  }

  // componentWillReceiveProps(nextProps) {
  //   this.setState(DemoPlayer.getDerivedStateFromProps(nextProps, this.state));
  // }

  // fullscreen notes
  // $('video').requestFullscreen().then(function(res,err) { console.log(res); } );
  // document.exitFullscreen().then(function(res,err) { console.log(res); } );

  // not every player will do this - if we keep an inline playing frame a-la Plex, then this needs to not happen here.
  // stop: control the player because of internal state; pause = toggle autoplay


  _createClass(DemoPlayer, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var csProps = this.props.csProps;

      if (csProps.isPlaying) {
        window.cp.playerHandler.stop();
      }
      _ColorActions2.default.resetColors();

      DemoPlayer.handleMediaType({});
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (window.cp.playerState === 'STOPPED') {
        window.cp.playerHandler.play();
      }
    }

    // seekValueChange = (seekValueState) => {
    //   console.log(seekValueState);
    // }

  }, {
    key: 'render',
    value: function render() {
      // console.log('DemoPlayer', this.props, this.state);

      var _props = this.props,
          subsonic = _props.subsonic,
          SubsonicSource = _props.SubsonicSource,
          useGradients = _props.useGradients,
          useSingleGradient = _props.useSingleGradient,
          useFuzzyImage = _props.useFuzzyImage,
          history = _props.history,
          csProps = _props.csProps;
      var _state = this.state,
          showBackground = _state.showBackground,
          currentFile = _state.currentFile,
          coverArt = _state.coverArt,
          coverSize = _state.coverSize,
          currentMediaTimeString = _state.currentMediaTimeString,
          durationString = _state.durationString;


      if (!subsonic.isConnected) {
        return _react2.default.createElement(
          _Card2.default,
          null,
          _react2.default.createElement(
            _Typography2.default,
            { component: 'div' },
            'Still Loading'
          )
        );
      }

      var currentPlaying = subsonic.currentPlaying,
          following = subsonic.following,
          isShowingMenu = subsonic.isShowingMenu;
      // console.log('following', following);

      var id = currentPlaying && currentPlaying.queue && currentPlaying.queue[currentPlaying.idx] ? currentPlaying.queue[currentPlaying.idx].id : '-1';

      if (!currentPlaying.queue.length || !currentFile) {
        var message = 'It looks like there may be a problem loading the player. If this does not go away, then please go back and try again.';
        if (following) {
          message = 'The person you are following may not be listening anymore.';
        }
        return _react2.default.createElement(
          _Card2.default,
          null,
          _react2.default.createElement(
            _CardContent2.default,
            null,
            _react2.default.createElement(
              _Typography2.default,
              { component: 'div' },
              message
            )
          ),
          _react2.default.createElement(
            _CardActions2.default,
            null,
            _react2.default.createElement(
              _Button2.default,
              null,
              _react2.default.createElement(
                'a',
                { onClick: history.goBack },
                'Go Back'
              )
            ),
            _react2.default.createElement(
              _Button2.default,
              { component: _reactRouterDom.Link, to: '/' },
              'Go Home'
            )
          ),
          _react2.default.createElement(_NowPlaying2.default, this.props)
        );
      }

      var c = currentFile;
      var background = _react2.default.createElement(_FlexibleBackground2.default, {
        showGradients: showBackground,
        single: useSingleGradient,
        selector: '.page-bg',
        image: coverArt,
        showBackground: true,
        fadeBackground: !showBackground
      });

      // const background = useGradients || useSingleGradient ? (
      //   <ColorContainer>
      //     <GradientBackground showGradients={showBackground} single={useSingleGradient} />
      //   </ColorContainer>
      // ) : useFuzzyImage ? (
      //     <FuzzyImageBackground
      //       selector=".page-bg"
      //       image={coverArt}
      //       showBackground={true}
      //       fadeBackground={!showBackground}
      //     />
      // ) : (
      //   <span />
      // );

      var nowPlaying = subsonic.following ? _react2.default.createElement(_NowPlaying2.default, this.props) : '';
      /*
      <IconButton onClick={this.handleSongDrawer}>
      <MenuIcon/>
      </IconButton>*/

      return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        _react2.default.createElement(
          _Button2.default,
          { onClick: this.handleSongDrawer },
          _react2.default.createElement(_FormatListBulleted2.default, null)
        ),
        _react2.default.createElement(_MediaButtons.PlayPauseButton, _extends({}, csProps, {
          fab: true,
          standalone: true,
          color: 'primary'
        })),
        _react2.default.createElement(_MediaButtons.PrevButton, _extends({}, csProps, {
          buttonClassName: 'button-class',
          iconClassName: 'icon-class'
        })),
        _react2.default.createElement(_MediaButtons.NextButton, csProps),
        _react2.default.createElement(_MediaButtons.SkipAlbumButton, csProps),
        _react2.default.createElement(_MediaButtons.Replay10Button, csProps),
        _react2.default.createElement(_MediaButtons.Forward30Button, csProps),
        _react2.default.createElement(_MediaButtons.BookmarkButton, _extends({}, csProps, {
          isBookmarked: subsonic.bookmarksById[id],
          action: this.toggleBookmark
        })),
        _react2.default.createElement(_MediaButtons.SavePlayQueueButton, csProps),
        _react2.default.createElement(_MediaButtons.ShuffleButton, null),
        _react2.default.createElement(_MediaButtons.ChromecastButton, csProps),
        _react2.default.createElement(_RemoteReceiverToggleButton2.default, _extends({}, csProps, this.props)),
        _react2.default.createElement(_RangeSlider2.default, _extends({}, csProps, { seekValueChange: this.seekValueChange })),
        _react2.default.createElement(_Notification2.default, _extends({}, csProps, {
          mediaIcon: this.state.mediaIcon,
          song: this.state.currentFile
        })),
        _react2.default.createElement(_SongListDrawer2.default, _extends({}, csProps, {
          open: isShowingMenu,
          classes: {},
          subsonic: subsonic,
          handleClose: this.handleSongDrawerClose,
          handleSongClick: this.handleSongClick,
          anchor: 'left'
        })),
        _react2.default.createElement(_GradientGeneratingImage2.default, {
          src: coverArt,
          size: coverSize,
          imageId: 'cover-image'
        }),
        _react2.default.createElement(
          _HollowCard2.default,
          null,
          c.title,
          '\xA0(',
          currentPlaying.idx + 1,
          '/',
          ' ',
          currentPlaying.queue.length,
          ')',
          _react2.default.createElement('br', null),
          ' ',
          c.artist,
          _react2.default.createElement('br', null),
          ' ',
          c.album,
          '\xA0(',
          c.year,
          ')',
          _react2.default.createElement('br', null),
          ' ',
          currentMediaTimeString,
          '\xA0-\xA0',
          durationString
        ),
        nowPlaying,
        background
      );
    }
  }]);

  return DemoPlayer;
}(_react.Component);

exports.default = DemoPlayer;
module.exports = exports.default;