'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('@material-ui/core/styles');

var _Grid = require('@material-ui/core/Grid');

var _Grid2 = _interopRequireDefault(_Grid);

var _CircularProgress = require('@material-ui/core/CircularProgress');

var _CircularProgress2 = _interopRequireDefault(_CircularProgress);

var _HollowCard = require('../subsonic/components/styled/HollowCard');

var _HollowCard2 = _interopRequireDefault(_HollowCard);

var _GradientGeneratingImage = require('../subfire/components/GradientGeneratingImage');

var _GradientGeneratingImage2 = _interopRequireDefault(_GradientGeneratingImage);

var _FuzzyImageBackground = require('../subfire/components/FuzzyImageBackground');

var _FuzzyImageBackground2 = _interopRequireDefault(_FuzzyImageBackground);

var _SubsonicActions = require('../subsonic/actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = function styles(theme) {
  return {
    card: {
      textAlign: 'center'
    }
  };
};

var SubsonicLoadingCard = function SubsonicLoadingCard(props) {
  // console.log(props);
  var SubsonicSource = props.SubsonicSource,
      object = props.object,
      classes = props.classes,
      _props$top = props.top,
      top = _props$top === undefined ? 0 : _props$top;
  var _window = window,
      innerWidth = _window.innerWidth,
      innerHeight = _window.innerHeight;

  var cellSize = innerWidth <= 600 ? innerWidth - 20 : Math.trunc(innerWidth / 2);
  cellSize = Math.min(cellSize, innerHeight - 100 - top);
  // load the one already loaded in the previous grid
  var artSize = innerWidth > 360 ? 170 : 164;

  var coverArt = object && (object.coverArt || object.id) ? SubsonicSource.getCoverArtURL(object.coverArt || object.id, artSize) : '';

  var loadingString = object ? object.name || object.title : "something. no really. we're loading something.";

  _SubsonicActions2.default.setLoadingTitle.defer(loadingString);

  return _react2.default.createElement(
    'div',
    { style: { paddingTop: 25 } },
    _react2.default.createElement(
      _Grid2.default,
      { container: true, spacing: 0 },
      _react2.default.createElement(_Grid2.default, { item: true, sm: 3, xs: false }),
      _react2.default.createElement(
        _Grid2.default,
        { item: true, sm: 6, xs: 12 },
        _react2.default.createElement(
          _HollowCard2.default,
          null,
          _react2.default.createElement(
            'div',
            { className: classes.card },
            'Loading...'
          ),
          _react2.default.createElement(
            'div',
            { className: classes.card },
            _react2.default.createElement(_GradientGeneratingImage2.default, {
              src: coverArt,
              imageId: 'the-loading-image',
              size: cellSize
            }),
            _react2.default.createElement(_CircularProgress2.default, { className: 'center-progress', size: 50 })
          ),
          _react2.default.createElement(
            'div',
            { className: classes.card },
            loadingString
          ),
          _react2.default.createElement(_FuzzyImageBackground2.default, {
            selector: '.page-bg',
            image: coverArt,
            showBackground: true
          })
        )
      )
    )
  );
};

exports.default = (0, _styles.withStyles)(styles)(SubsonicLoadingCard);
module.exports = exports.default;