'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _connectToStores = require('../../utils/connectToStores');

var _connectToStores2 = _interopRequireDefault(_connectToStores);

var _PreferenceActions = require('../actions/PreferenceActions');

var _PreferenceStore = require('../stores/PreferenceStore');

var _PreferenceStore2 = _interopRequireDefault(_PreferenceStore);

var _ColorContainer = require('./containers/ColorContainer');

var _ColorContainer2 = _interopRequireDefault(_ColorContainer);

var _GradientBackground = require('./GradientBackground');

var _GradientBackground2 = _interopRequireDefault(_GradientBackground);

var _FuzzyImageBackground = require('./FuzzyImageBackground');

var _FuzzyImageBackground2 = _interopRequireDefault(_FuzzyImageBackground);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FlexibleBackground = function (_React$Component) {
  _inherits(FlexibleBackground, _React$Component);

  function FlexibleBackground() {
    _classCallCheck(this, FlexibleBackground);

    return _possibleConstructorReturn(this, (FlexibleBackground.__proto__ || Object.getPrototypeOf(FlexibleBackground)).apply(this, arguments));
  }

  _createClass(FlexibleBackground, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          backgroundType = _props.backgroundType,
          showGradients = _props.showGradients;


      var background = _react2.default.createElement('span', null),
          single = false;
      switch (backgroundType) {
        case _PreferenceActions.backgroundTypes.singleGradient:
          single = true;
          background = _react2.default.createElement(
            _ColorContainer2.default,
            null,
            _react2.default.createElement(_GradientBackground2.default, { showGradients: showGradients, single: single })
          );
          break;
        case _PreferenceActions.backgroundTypes.gradients:
          background = _react2.default.createElement(
            _ColorContainer2.default,
            null,
            _react2.default.createElement(_GradientBackground2.default, { showGradients: showGradients, single: single })
          );
          break;
        case _PreferenceActions.backgroundTypes.fuzzyImage:
          var _props2 = this.props,
              selector = _props2.selector,
              image = _props2.image,
              showBackground = _props2.showBackground,
              fadeBackground = _props2.fadeBackground;

          background = _react2.default.createElement(_FuzzyImageBackground2.default, {
            selector: selector,
            image: image,
            showBackground: showBackground,
            fadeBackground: fadeBackground
          });
          break;
        default:
          console.warn('default === span for black');
      }
      return background;
    }
  }], [{
    key: 'getStores',
    value: function getStores(props) {
      return [_PreferenceStore2.default];
    }
  }, {
    key: 'getPropsFromStores',
    value: function getPropsFromStores(props) {
      return _PreferenceStore2.default.getState();
    }
  }]);

  return FlexibleBackground;
}(_react2.default.Component);

exports.default = (0, _connectToStores2.default)(FlexibleBackground);
module.exports = exports.default;