'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DialogActions = require('@material-ui/core/DialogActions');

var _DialogActions2 = _interopRequireDefault(_DialogActions);

var _DialogContent = require('@material-ui/core/DialogContent');

var _DialogContent2 = _interopRequireDefault(_DialogContent);

var _DialogContentText = require('@material-ui/core/DialogContentText');

var _DialogContentText2 = _interopRequireDefault(_DialogContentText);

var _DialogTitle = require('@material-ui/core/DialogTitle');

var _DialogTitle2 = _interopRequireDefault(_DialogTitle);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Select = require('@material-ui/core/Select');

var _Select2 = _interopRequireDefault(_Select);

var _InputLabel = require('@material-ui/core/InputLabel');

var _InputLabel2 = _interopRequireDefault(_InputLabel);

var _MenuItem = require('@material-ui/core/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _FormControl = require('@material-ui/core/FormControl');

var _FormControl2 = _interopRequireDefault(_FormControl);

var _styles = require('@material-ui/core/styles');

var _TVResponsiveDialog = require('../../subsonic/components/hoc/TVResponsiveDialog');

var _TVResponsiveDialog2 = _interopRequireDefault(_TVResponsiveDialog);

var _connectToStores = require('../../utils/connectToStores');

var _connectToStores2 = _interopRequireDefault(_connectToStores);

var _PreferenceStore = require('../stores/PreferenceStore');

var _PreferenceStore2 = _interopRequireDefault(_PreferenceStore);

var _PreferenceActions = require('../actions/PreferenceActions');

var _PreferenceActions2 = _interopRequireDefault(_PreferenceActions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var PreferencesStores = function () {
  function PreferencesStores() {
    _classCallCheck(this, PreferencesStores);
  }

  _createClass(PreferencesStores, null, [{
    key: 'getStores',
    value: function getStores(props) {
      return [_PreferenceStore2.default];
    }
  }, {
    key: 'getPropsFromStores',
    value: function getPropsFromStores(props) {
      return _PreferenceStore2.default.getState();
    }
  }]);

  return PreferencesStores;
}();

var Preferences = function (_React$Component) {
  _inherits(Preferences, _React$Component);

  function Preferences() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Preferences);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Preferences.__proto__ || Object.getPrototypeOf(Preferences)).call.apply(_ref, [this].concat(args))), _this), _this.onBackgroundTypeChange = function (e) {
      var value = e.target.value;
      _PreferenceActions2.default.setBackgroundType(value);
    }, _this.handleClose = function () {
      if (_this.props.handleClose) _this.props.handleClose();
      if (_this.props.history) _this.props.history.goBack();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Preferences, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          backgroundType = _props.backgroundType,
          native = _props.native;


      return _react2.default.createElement(
        _TVResponsiveDialog2.default,
        { open: true, disableBackdropClick: true },
        _react2.default.createElement(
          _DialogTitle2.default,
          null,
          'SubFire Standard Preferences'
        ),
        _react2.default.createElement(
          _DialogContent2.default,
          null,
          _react2.default.createElement(
            _DialogContentText2.default,
            null,
            'The following preferences can be modified:'
          ),
          _react2.default.createElement(
            _FormControl2.default,
            { className: classes.formControl },
            _react2.default.createElement(
              _InputLabel2.default,
              { htmlFor: 'current-selection' },
              'Background Type'
            ),
            _react2.default.createElement(
              _Select2.default,
              {
                native: native,
                id: 'current-selection',
                value: backgroundType,
                onChange: this.onBackgroundTypeChange
              },
              Object.entries(_PreferenceActions.backgroundTypes).map(function (o) {
                if (native) return _react2.default.createElement(
                  'option',
                  { key: o[1], value: o[1] },
                  o[1]
                );
                return _react2.default.createElement(
                  _MenuItem2.default,
                  { key: o[1], value: o[1] },
                  o[1]
                );
              })
            )
          )
        ),
        _react2.default.createElement(
          _DialogActions2.default,
          null,
          _react2.default.createElement(
            _Button2.default,
            { onClick: this.handleClose },
            'Close'
          )
        )
      );
    }
  }]);

  return Preferences;
}(_react2.default.Component);

var styles = function styles(theme) {
  return {
    root: {
      display: 'flex',
      flexWrap: 'wrap'
    },
    formControl: {
      margin: 0,
      width: '100%'
    },
    selectEmpty: {
      marginTop: theme.spacing(2)
    }
  };
};

exports.default = (0, _styles.withStyles)(styles)((0, _connectToStores2.default)(PreferencesStores, Preferences));
module.exports = exports.default;