'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('@material-ui/core/styles');

var _materialColor = require('../../../utils/material-color');

var _amber = require('@material-ui/core/colors/amber');

var _amber2 = _interopRequireDefault(_amber);

var _blue = require('@material-ui/core/colors/blue');

var _blue2 = _interopRequireDefault(_blue);

var _blueGrey = require('@material-ui/core/colors/blueGrey');

var _blueGrey2 = _interopRequireDefault(_blueGrey);

var _brown = require('@material-ui/core/colors/brown');

var _brown2 = _interopRequireDefault(_brown);

var _cyan = require('@material-ui/core/colors/cyan');

var _cyan2 = _interopRequireDefault(_cyan);

var _deepOrange = require('@material-ui/core/colors/deepOrange');

var _deepOrange2 = _interopRequireDefault(_deepOrange);

var _deepPurple = require('@material-ui/core/colors/deepPurple');

var _deepPurple2 = _interopRequireDefault(_deepPurple);

var _green = require('@material-ui/core/colors/green');

var _green2 = _interopRequireDefault(_green);

var _grey = require('@material-ui/core/colors/grey');

var _grey2 = _interopRequireDefault(_grey);

var _indigo = require('@material-ui/core/colors/indigo');

var _indigo2 = _interopRequireDefault(_indigo);

var _lightBlue = require('@material-ui/core/colors/lightBlue');

var _lightBlue2 = _interopRequireDefault(_lightBlue);

var _lightGreen = require('@material-ui/core/colors/lightGreen');

var _lightGreen2 = _interopRequireDefault(_lightGreen);

var _lime = require('@material-ui/core/colors/lime');

var _lime2 = _interopRequireDefault(_lime);

var _orange = require('@material-ui/core/colors/orange');

var _orange2 = _interopRequireDefault(_orange);

var _pink = require('@material-ui/core/colors/pink');

var _pink2 = _interopRequireDefault(_pink);

var _purple = require('@material-ui/core/colors/purple');

var _purple2 = _interopRequireDefault(_purple);

var _red = require('@material-ui/core/colors/red');

var _red2 = _interopRequireDefault(_red);

var _teal = require('@material-ui/core/colors/teal');

var _teal2 = _interopRequireDefault(_teal);

var _yellow = require('@material-ui/core/colors/yellow');

var _yellow2 = _interopRequireDefault(_yellow);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

// import rangeSliderColor from "subsonic/components/controls/RangeSliderColors";

var colors = {
  amber: _amber2.default,
  blue: _blue2.default,
  blueGrey: _blueGrey2.default,
  brown: _brown2.default,
  cyan: _cyan2.default,
  deepOrange: _deepOrange2.default,
  deepPurple: _deepPurple2.default,
  green: _green2.default,
  grey: _grey2.default,
  indigo: _indigo2.default,
  lightBlue: _lightBlue2.default,
  lightGreen: _lightGreen2.default,
  lime: _lime2.default,
  orange: _orange2.default,
  pink: _pink2.default,
  purple: _purple2.default,
  red: _red2.default,
  teal: _teal2.default,
  yellow: _yellow2.default
};

var indexes = ['50', '100', '200', '300', '400', '500', '600', '700', '800', '900'];

var aIndex = ['A100', 'A200', 'A400', 'A700'];

function FindIndexes(key) {
  var m = void 0,
      l = void 0,
      d = void 0;
  if (key.startsWith('A')) {
    if (key === 'A100') key = '200';
    if (key === 'A200') key = '400';
    if (key === 'A400') key = '500';
    if (key === 'A700') key = '700';
  }

  m = key;
  var i = indexes.indexOf(m);
  l = i - 2;
  if (l < 0) l = 0;
  l = indexes[l];

  d = i + 2;
  if (d < 9) d = 9;
  d = indexes[d];

  return { m: m, l: l, d: d };
}

function parseColor(cname) {
  var c = cname.split('-');
  if (c.length === 2) {
    // console.log(c);
  } else {
    console.warn('oops', c);
  }
  return c;
}

function genPaletteFromColor(c, p) {
  var mc = _materialColor.colorToMaterial.apply(undefined, _toConsumableArray(c));
  var colorName = mc.closestMaterialName;
  // console.log(colorName);
  // brown is boring...
  if (colorName.startsWith('brown')) {
    colorName = _materialColor.colorToMaterial.apply(undefined, _toConsumableArray(p[3])).closestMaterialName;
    // console.log('replaced with ', colorName)
  }
  // console.log(mc);
  var colorKeys = parseColor(colorName);
  if (colorKeys.length === 2) {
    if (colorKeys[0] === 'black') colorKeys = ['grey', '800'];
    if (colorKeys[0] === 'white') colorKeys = ['grey', '400'];
    var ac = colors[colorKeys[0]];
    // console.log(ac);
    var idx = FindIndexes(colorKeys[1]);
    // if (!ac || !idx) {
    //   debugger;
    // }
    return {
      light: ac[idx.l],
      main: ac[idx.m],
      dark: ac[idx.d]
    };
  } else {
    return null;
  }
}

var ColorTheme = function (_Component) {
  _inherits(ColorTheme, _Component);

  function ColorTheme() {
    _classCallCheck(this, ColorTheme);

    return _possibleConstructorReturn(this, (ColorTheme.__proto__ || Object.getPrototypeOf(ColorTheme)).apply(this, arguments));
  }

  _createClass(ColorTheme, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          palette = _props.palette,
          defaultPrimary = _props.defaultPrimary,
          defaultSecondary = _props.defaultSecondary,
          _props$typography = _props.typography,
          typography = _props$typography === undefined ? {} : _props$typography,
          _props$overrides = _props.overrides,
          overrides = _props$overrides === undefined ? {} : _props$overrides;

      // hack

      overrides.MuiSnackbarContent = {
        root: {
          color: 'white'
        }
      };

      var primary = defaultPrimary || colors.amber,
          secondary = defaultSecondary || colors.indigo;

      if (palette && palette.length) {
        primary = genPaletteFromColor(palette[0], palette) || primary;
        secondary = genPaletteFromColor(palette[1], palette) || secondary;
      } else {
        // love to find the best place for this
        document.getElementsByTagName('body')[0].style.cssText = '';
      }

      var typographyConfig = Object.assign({}, typography, {});

      var config = {
        palette: {
          primary: primary,
          secondary: secondary,
          type: 'dark'
        },
        typography: typographyConfig,
        overrides: overrides
      };
      var theme = (0, _styles.createMuiTheme)(config);

      return _react2.default.createElement(
        _styles.MuiThemeProvider,
        { theme: theme },
        this.props.children
      );
    }
  }]);

  return ColorTheme;
}(_react.Component);

exports.default = ColorTheme;
module.exports = exports.default;