'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DialogActions = require('@material-ui/core/DialogActions');

var _DialogActions2 = _interopRequireDefault(_DialogActions);

var _DialogContent = require('@material-ui/core/DialogContent');

var _DialogContent2 = _interopRequireDefault(_DialogContent);

var _DialogContentText = require('@material-ui/core/DialogContentText');

var _DialogContentText2 = _interopRequireDefault(_DialogContentText);

var _DialogTitle = require('@material-ui/core/DialogTitle');

var _DialogTitle2 = _interopRequireDefault(_DialogTitle);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _TVResponsiveDialog = require('../../../subsonic/components/hoc/TVResponsiveDialog');

var _TVResponsiveDialog2 = _interopRequireDefault(_TVResponsiveDialog);

var _CredentialsActions = require('../../../subsonic/actions/CredentialsActions');

var _CredentialsActions2 = _interopRequireDefault(_CredentialsActions);

var _AuthExchangeActions = require('../../actions/AuthExchangeActions');

var _AuthExchangeActions2 = _interopRequireDefault(_AuthExchangeActions);

var _Tea = require('../../../utils/Tea');

var _Tea2 = _interopRequireDefault(_Tea);

var _styles = require('@material-ui/core/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = function styles(theme) {
  return {
    centerHeader: {
      textAlign: 'center',
      fontSize: '40pt',
      letterSpacing: '.5ch',
      color: 'white'
    }
  };
};

var AuthCodeClient = function (_React$Component) {
  _inherits(AuthCodeClient, _React$Component);

  function AuthCodeClient() {
    _classCallCheck(this, AuthCodeClient);

    return _possibleConstructorReturn(this, (AuthCodeClient.__proto__ || Object.getPrototypeOf(AuthCodeClient)).apply(this, arguments));
  }

  _createClass(AuthCodeClient, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          digits = _props.digits,
          route = _props.route;

      _AuthExchangeActions2.default.clientRequest(digits).then(function (response, err) {
        if (response) console.log(response.ok);
        if (err) console.error(err);

        if (response.ok) return response.json();
        return response.json();
      }).then(function (j) {
        console.log('back', j);
        if (j.status === 200) {
          // if parse failure, let the exception fire
          var data = _Tea2.default.decrypt(j.data, digits);
          //console.log(data);
          data = JSON.parse(data);
          //console.log(data);

          // localStorage.setItem("subsonic.credentials", data.configs);
          var configs = JSON.parse(data.configs);
          //console.log(configs);
          _CredentialsActions2.default.importCredentials(configs);
          route.history.goBack();
          // setTimeout(document.location.reload.bind(window.location), 100);
        }
      }).catch(function (err) {
        console.error(err);
      });
    }
  }, {
    key: 'buttonWasMounted',
    value: function buttonWasMounted(ref) {
      if (ref) ref.focus();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          digits = _props2.digits,
          classes = _props2.classes,
          handleClose = _props2.handleClose;


      return _react2.default.createElement(
        _TVResponsiveDialog2.default,
        {
          disableBackdropClick: true,
          open: true,
          className: classes.paperFullScreen
        },
        _react2.default.createElement(
          _DialogTitle2.default,
          null,
          'Authenticate Via Existing Source'
        ),
        _react2.default.createElement(
          _DialogContent2.default,
          null,
          _react2.default.createElement(
            _DialogContentText2.default,
            null,
            'On another device where you are already authenticated, enter the following ',
            (digits + '').length,
            ' digits.'
          ),
          _react2.default.createElement(
            'h1',
            { className: classes.centerHeader },
            digits
          )
        ),
        _react2.default.createElement(
          _DialogActions2.default,
          null,
          _react2.default.createElement(
            _Button2.default,
            { buttonRef: this.buttonWasMounted, onClick: handleClose },
            'Cancel'
          )
        )
      );
    }
  }]);

  return AuthCodeClient;
}(_react2.default.Component);

exports.default = (0, _styles.withStyles)(styles)(AuthCodeClient);
module.exports = exports.default;