'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DialogActions = require('@material-ui/core/DialogActions');

var _DialogActions2 = _interopRequireDefault(_DialogActions);

var _DialogContent = require('@material-ui/core/DialogContent');

var _DialogContent2 = _interopRequireDefault(_DialogContent);

var _DialogContentText = require('@material-ui/core/DialogContentText');

var _DialogContentText2 = _interopRequireDefault(_DialogContentText);

var _DialogTitle = require('@material-ui/core/DialogTitle');

var _DialogTitle2 = _interopRequireDefault(_DialogTitle);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Fab = require('@material-ui/core/Fab');

var _Fab2 = _interopRequireDefault(_Fab);

var _KeyboardBackspace = require('@material-ui/icons/KeyboardBackspace');

var _KeyboardBackspace2 = _interopRequireDefault(_KeyboardBackspace);

var _TextField = require('@material-ui/core/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _Grid = require('@material-ui/core/Grid');

var _Grid2 = _interopRequireDefault(_Grid);

var _TVResponsiveDialog = require('../../../subsonic/components/hoc/TVResponsiveDialog');

var _TVResponsiveDialog2 = _interopRequireDefault(_TVResponsiveDialog);

var _AuthExchangeActions = require('../../actions/AuthExchangeActions');

var _AuthExchangeActions2 = _interopRequireDefault(_AuthExchangeActions);

var _styles = require('@material-ui/core/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = function styles(theme) {
  return {
    centerHeader: {
      textAlign: 'center',
      fontSize: '40pt',
      letterSpacing: '.5ch',
      color: 'white'
    },
    gridItem: {
      justifyContent: 'center',
      textAlign: 'center'
    },
    fab: {
      fontSize: '20pt'
    },
    button: {
      fontSize: '16pt'
    },
    textInput: {
      fontSize: '20pt'
    },
    textField: {
      paddingTop: '2em'
    }
  };
};

var AuthCodeSource = function (_React$Component) {
  _inherits(AuthCodeSource, _React$Component);

  function AuthCodeSource() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, AuthCodeSource);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = AuthCodeSource.__proto__ || Object.getPrototypeOf(AuthCodeSource)).call.apply(_ref, [this].concat(args))), _this), _this.submit = function () {
      // if (this.props.handleSubmit) this.props.handleSubmit(this.t.value);
      var route = _this.props.route;

      _AuthExchangeActions2.default.sourceSubmit(_this.t.value).then(function (response, err) {
        if (response) console.log(response.ok);
        if (err) console.error(err);

        if (response.ok) return response.json();
        return response.json();
      }).then(function (j) {
        console.log('back', j);
        route.history.goBack();
      }).catch(function (err) {
        console.error(err);
      });
    }, _this.handleButtonClick = function (e) {
      var value = e.target.dataset.value;
      if (value === undefined) value = e.target.parentElement.dataset.value;

      if (value === 'DEL') {
        var s = _this.t.value;
        s = s.substring(0, s.length - 1);
        _this.t.value = s;
      } else if (value) {
        _this.t.value = _this.t.value + value;
      }
    }, _this.inputRef = function (t) {
      _this.t = t;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(AuthCodeSource, [{
    key: 'render',
    value: function render() {
      var classes = this.props.classes;

      return _react2.default.createElement(
        _TVResponsiveDialog2.default,
        {
          disableBackdropClick: true,
          open: true,
          className: classes.paperFullScreen
        },
        _react2.default.createElement(
          _DialogTitle2.default,
          null,
          'Authenticate Via Existing Source'
        ),
        _react2.default.createElement(
          _DialogContent2.default,
          null,
          _react2.default.createElement(
            _DialogContentText2.default,
            null,
            "Enter the specified digits from the other device's screen."
          ),
          _react2.default.createElement(
            _Grid2.default,
            { container: true, spacing: 4, justify: 'center', alignItems: 'center' },
            _react2.default.createElement(
              _Grid2.default,
              { item: true, className: classes.gridItem, xs: 4 },
              _react2.default.createElement(
                _Fab2.default,
                {
                  color: 'primary',
                  className: classes.fab,
                  autoFocus: true,
                  onClick: this.handleButtonClick,
                  'data-value': '1'
                },
                '1'
              )
            ),
            _react2.default.createElement(
              _Grid2.default,
              { item: true, className: classes.gridItem, xs: 4 },
              _react2.default.createElement(
                _Fab2.default,
                {
                  color: 'primary',
                  className: classes.fab,
                  onClick: this.handleButtonClick,
                  'data-value': '2'
                },
                '2'
              )
            ),
            _react2.default.createElement(
              _Grid2.default,
              { item: true, className: classes.gridItem, xs: 4 },
              _react2.default.createElement(
                _Fab2.default,
                {
                  color: 'primary',
                  className: classes.fab,
                  onClick: this.handleButtonClick,
                  'data-value': '3'
                },
                '3'
              )
            ),
            _react2.default.createElement(
              _Grid2.default,
              { item: true, className: classes.gridItem, xs: 4 },
              _react2.default.createElement(
                _Fab2.default,
                {
                  color: 'primary',
                  className: classes.fab,
                  onClick: this.handleButtonClick,
                  'data-value': '4'
                },
                '4'
              )
            ),
            _react2.default.createElement(
              _Grid2.default,
              { item: true, className: classes.gridItem, xs: 4 },
              _react2.default.createElement(
                _Fab2.default,
                {
                  color: 'primary',
                  className: classes.fab,
                  onClick: this.handleButtonClick,
                  'data-value': '5'
                },
                '5'
              )
            ),
            _react2.default.createElement(
              _Grid2.default,
              { item: true, className: classes.gridItem, xs: 4 },
              _react2.default.createElement(
                _Fab2.default,
                {
                  color: 'primary',
                  className: classes.fab,
                  onClick: this.handleButtonClick,
                  'data-value': '6'
                },
                '6'
              )
            ),
            _react2.default.createElement(
              _Grid2.default,
              { item: true, className: classes.gridItem, xs: 4 },
              _react2.default.createElement(
                _Fab2.default,
                {
                  color: 'primary',
                  className: classes.fab,
                  onClick: this.handleButtonClick,
                  'data-value': '7'
                },
                '7'
              )
            ),
            _react2.default.createElement(
              _Grid2.default,
              { item: true, className: classes.gridItem, xs: 4 },
              _react2.default.createElement(
                _Fab2.default,
                {
                  color: 'primary',
                  className: classes.fab,
                  onClick: this.handleButtonClick,
                  'data-value': '8'
                },
                '8'
              )
            ),
            _react2.default.createElement(
              _Grid2.default,
              { item: true, className: classes.gridItem, xs: 4 },
              _react2.default.createElement(
                _Fab2.default,
                {
                  color: 'primary',
                  className: classes.fab,
                  onClick: this.handleButtonClick,
                  'data-value': '9'
                },
                '9'
              )
            ),
            _react2.default.createElement(
              _Grid2.default,
              { item: true, className: classes.gridItem, xs: 4 },
              '\xA0'
            ),
            _react2.default.createElement(
              _Grid2.default,
              { item: true, className: classes.gridItem, xs: 4 },
              _react2.default.createElement(
                _Fab2.default,
                {
                  color: 'primary',
                  className: classes.fab,
                  onClick: this.handleButtonClick,
                  'data-value': '0'
                },
                '0'
              )
            ),
            _react2.default.createElement(
              _Grid2.default,
              { item: true, className: classes.gridItem, xs: 4 },
              _react2.default.createElement(
                _Fab2.default,
                {
                  color: 'secondary',
                  className: classes.fab,
                  onClick: this.handleButtonClick,
                  'data-value': 'DEL'
                },
                _react2.default.createElement(_KeyboardBackspace2.default, { 'data-value': 'DEL' })
              )
            )
          ),
          _react2.default.createElement(_TextField2.default, {
            className: classes.textField,
            InputProps: { className: classes.textInput },
            fullWidth: true,
            inputRef: this.inputRef
          })
        ),
        _react2.default.createElement(
          _DialogActions2.default,
          null,
          _react2.default.createElement(
            _Button2.default,
            { className: classes.button, onClick: this.props.handleClose },
            'Cancel'
          ),
          _react2.default.createElement(
            _Button2.default,
            { className: classes.button, onClick: this.submit },
            'Submit'
          )
        )
      );
    }
  }]);

  return AuthCodeSource;
}(_react2.default.Component);

exports.default = (0, _styles.withStyles)(styles)(AuthCodeSource);
module.exports = exports.default;