'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Grid = require('@material-ui/core/Grid');

var _Grid2 = _interopRequireDefault(_Grid);

var _styles = require('@material-ui/core/styles');

var _SubsonicStore = require('../../../subsonic/stores/SubsonicStore');

var _MediaButtons = require('../../../subsonic/components/controls/MediaButtons');

var _Notification = require('../../../subsonic/components/controls/Notification');

var _Notification2 = _interopRequireDefault(_Notification);

var _SubsonicActions = require('../../../subsonic/actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

var _ColorActions = require('../../actions/ColorActions');

var _ColorActions2 = _interopRequireDefault(_ColorActions);

var _GradientGeneratingImage = require('../GradientGeneratingImage');

var _GradientGeneratingImage2 = _interopRequireDefault(_GradientGeneratingImage);

var _GradientBackground = require('../GradientBackground');

var _GradientBackground2 = _interopRequireDefault(_GradientBackground);

var _FuzzyImageBackground = require('../FuzzyImageBackground');

var _FuzzyImageBackground2 = _interopRequireDefault(_FuzzyImageBackground);

var _RangeSlider = require('../../../subsonic/components/controls/RangeSlider');

var _RangeSlider2 = _interopRequireDefault(_RangeSlider);

var _CastSubsonic = require('../../../subsonic/components/containers/CastSubsonic');

var _CastSubsonic2 = _interopRequireDefault(_CastSubsonic);

var _ColorContainer = require('../containers/ColorContainer');

var _ColorContainer2 = _interopRequireDefault(_ColorContainer);

var _HollowCard = require('../../../subsonic/components/styled/HollowCard');

var _HollowCard2 = _interopRequireDefault(_HollowCard);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  base: {
    position: 'fixed',
    bottom: 5,
    left: 5,
    right: 5,
    marginLeft: 5,
    marginRight: 5,
    marginBottom: 5
  },
  text: {
    fontSize: 'smaller'
  }
};

var FooterPlayer = function (_Component) {
  _inherits(FooterPlayer, _Component);

  _createClass(FooterPlayer, null, [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(props, prevState) {
      var subsonic = props.subsonic,
          SubsonicSource = props.SubsonicSource;
      var currentPlaying = subsonic.currentPlaying;


      var newState = void 0;

      if (!currentPlaying.queue.length) {
        newState = {
          showBackground: false,
          currentFile: _SubsonicStore.emptytrack,
          coverArt: SubsonicSource.getCoverArtURL(_SubsonicStore.emptytrack.id, 60)
        };
      } else {
        var currentFile = currentPlaying.queue[currentPlaying.idx];
        if (!prevState || currentFile !== prevState.currentFile) {
          var isWaitingForNext = false;
          var coverArt = SubsonicSource.getCoverArtURL(currentFile.id, 60);
          var mediaSrc = currentFile.localPath || (currentFile.src && currentFile.src.startsWith('http') ? currentFile.src : SubsonicSource.getStreamingURL(currentFile.id));
          var mediaIcon = SubsonicSource.getCoverArtURL(currentFile.id, 192) + '&co=false';

          // now load castplayer
          currentFile.coverArtURL = coverArt;
          currentFile.src = mediaSrc;
          window.cp.playerHandler.load(currentFile, 0);
          // console.warn(currentFile);
          newState = {
            currentFile: currentFile,
            coverArt: coverArt,
            mediaSrc: mediaSrc,
            mediaIcon: mediaIcon,
            isWaitingForNext: isWaitingForNext
          };
        }
      }
      return Object.assign({}, prevState, newState);
    }
  }]);

  function FooterPlayer(props) {
    _classCallCheck(this, FooterPlayer);

    var _this = _possibleConstructorReturn(this, (FooterPlayer.__proto__ || Object.getPrototypeOf(FooterPlayer)).call(this, props));

    _this.audioUpdates = function (p) {
      // hack - no easy way to pass this around
      if (window.bookmarkSeekTo) {
        window.castSubsonic.seekMedia(window.bookmarkSeekTo);
        window.bookmarkSeekTo = null;
      }

      if (_this.state.showBackground !== p.isPlaying) {
        _this.setState({ showBackground: p.isPlaying });
      }

      // if (p.reason !== 'normal') console.log('p', p);

      if (!_this.state.isWaitingForNext && p.reason === 'playbackEnded') {
        console.log('endPlayback next...');
        _this.setState({ isWaitingForNext: true });
        _SubsonicActions2.default.playerNext.defer();
      }
    };

    _this.toggleBookmark = function (currentMediaTime) {
      // console.log('toggleBookmark', currentMediaTime, this.props);
      var _this$props = _this.props,
          subsonic = _this$props.subsonic,
          SubsonicSource = _this$props.SubsonicSource;
      var currentPlaying = subsonic.currentPlaying;

      var id = currentPlaying.queue[currentPlaying.idx].id;

      if (subsonic.bookmarksById[id]) {
        _SubsonicActions2.default.deleteBookmark(id);
      } else {
        _SubsonicActions2.default.createBookmark(id, Math.trunc(currentMediaTime * 1000));
      }
    };

    _this.state = {};
    // this.state = FooterPlayer.getDerivedStateFromProps(props);
    return _this;
  }

  _createClass(FooterPlayer, [{
    key: 'componentWillUnmount',


    // componentWillReceiveProps(nextProps) {
    //   this.setState(FooterPlayer.getDerivedStateFromProps(nextProps, this.state));
    // }

    // not every player will do this - if we keep an inline playing frame a-la Plex, then this needs to not happen here.
    // stop: control the player because of internal state; pause = toggle autoplay
    value: function componentWillUnmount() {
      window.cp.playerHandler.stop();
      _ColorActions2.default.resetColors();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          subsonic = _props.subsonic,
          SubsonicSource = _props.SubsonicSource,
          useGradients = _props.useGradients,
          useFuzzyImage = _props.useFuzzyImage,
          classes = _props.classes;
      var currentPlaying = subsonic.currentPlaying;

      var id = currentPlaying && currentPlaying.queue && currentPlaying.queue[currentPlaying.idx] ? currentPlaying.queue[currentPlaying.idx].id : '-1';

      var _state = this.state,
          showBackground = _state.showBackground,
          currentFile = _state.currentFile,
          coverArt = _state.coverArt;

      var c = currentFile;
      var background = useGradients ? _react2.default.createElement(
        _ColorContainer2.default,
        null,
        _react2.default.createElement(_GradientBackground2.default, { showGradients: showBackground })
      ) : useFuzzyImage ? _react2.default.createElement(_FuzzyImageBackground2.default, {
        selector: '.page-bg',
        image: coverArt,
        showBackground: showBackground
      }) : _react2.default.createElement('span', null);

      return _react2.default.createElement(
        'div',
        { className: classes.base },
        background,
        _react2.default.createElement(
          _HollowCard2.default,
          null,
          _react2.default.createElement(
            _Grid2.default,
            { container: true, spacing: 24 },
            _react2.default.createElement(
              _Grid2.default,
              { item: true, xs: 1 },
              _react2.default.createElement(_GradientGeneratingImage2.default, { src: coverArt, item: true, xs: 6, sm: 3 })
            ),
            _react2.default.createElement(
              _Grid2.default,
              { item: true, xs: 3, className: classes.text },
              c.title,
              ' (',
              currentPlaying.idx + 1,
              ' /',
              ' ',
              currentPlaying.queue.length,
              ')',
              _react2.default.createElement('br', null),
              c.artist,
              _react2.default.createElement('br', null),
              c.album,
              ' (',
              c.year,
              ')'
            ),
            _react2.default.createElement(
              _Grid2.default,
              { item: true, xs: 8 },
              _react2.default.createElement(
                _CastSubsonic2.default,
                { updateHandler: this.audioUpdates },
                _react2.default.createElement(_MediaButtons.PrevButton, null),
                _react2.default.createElement(_MediaButtons.Replay10Button, null),
                _react2.default.createElement(_MediaButtons.PlayPauseButton, { fab: true }),
                _react2.default.createElement(_MediaButtons.Forward30Button, null),
                _react2.default.createElement(_MediaButtons.NextButton, null),
                _react2.default.createElement(_MediaButtons.SkipAlbumButton, null),
                _react2.default.createElement(_Notification2.default, {
                  mediaIcon: this.state.mediaIcon,
                  song: this.state.currentFile
                }),
                _react2.default.createElement(_MediaButtons.BookmarkButton, {
                  isBookmarked: subsonic.bookmarksById[id],
                  action: this.toggleBookmark
                }),
                _react2.default.createElement(_MediaButtons.SavePlayQueueButton, null),
                _react2.default.createElement(_MediaButtons.ShuffleButton, null),
                _react2.default.createElement(_RangeSlider2.default, null)
              )
            )
          )
        )
      );
    }
  }]);

  return FooterPlayer;
}(_react.Component);

exports.default = (0, _styles.withStyles)(styles)(FooterPlayer);
module.exports = exports.default;