'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SkipAlbumButton = exports.ShuffleButton = exports.PrevButton = exports.NextButton = exports.PauseButton = exports.PlayButton = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ActionButton = require('../../../subsonic/components/controls/ActionButton');

var _ActionButton2 = _interopRequireDefault(_ActionButton);

var _icons = require('@material-ui/icons');

var _RemotesActions = require('../../actions/RemotesActions');

var _RemotesActions2 = _interopRequireDefault(_RemotesActions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var play = function play() {
  return _RemotesActions2.default.sendAction('play');
};
var pause = function pause() {
  return _RemotesActions2.default.sendAction('pause');
};
// const playOrPause = () => {
//   return RemotesActions.sendAction('playOrPause');
// };
var playerNext = function playerNext() {
  return _RemotesActions2.default.sendAction('playerNext');
};
var playerPrev = function playerPrev() {
  return _RemotesActions2.default.sendAction('playerPrev');
};
var shufflePlaying = function shufflePlaying() {
  return _RemotesActions2.default.sendAction('shufflePlaying');
};
var playerSkip = function playerSkip() {
  return _RemotesActions2.default.sendAction('playerSkip');
};

var PlayButton = exports.PlayButton = function PlayButton(props) {
  var label = 'play',
      icon = _react2.default.createElement(_icons.PlayArrow, { className: props.iconClassName });
  // if (props.isPlaying) {
  //   label = "pause";
  //   icon = <Pause className={props.iconClassName}/>;
  // } else if (props.isLoading) {
  //   label = "loading";
  //   icon = <Update className={props.iconClassName}/>;
  // }
  // console.warn(props);
  var coreProps = {
    // action: props.actions ? props.actions.playOrPause : null,
    action: play,
    label: label,
    disabled: props.isLoading,
    fab: props.fab,
    color: props.color,
    standalone: props.standalone,
    buttonClassName: props.buttonClassName
  };
  return _react2.default.createElement(
    _ActionButton2.default,
    coreProps,
    icon
  );
};

var PauseButton = exports.PauseButton = function PauseButton(props) {
  var label = 'pause',
      icon = _react2.default.createElement(_icons.Pause, { className: props.iconClassName });
  // if (props.isPlaying) {
  //   label = "pause";
  //   icon = <Pause className={props.iconClassName}/>;
  // } else if (props.isLoading) {
  //   label = "loading";
  //   icon = <Update className={props.iconClassName}/>;
  // }
  // console.warn(props);
  var coreProps = {
    // action: props.actions ? props.actions.playOrPause : null,
    action: pause,
    label: label,
    disabled: props.isLoading,
    fab: props.fab,
    color: props.color,
    standalone: props.standalone,
    buttonClassName: props.buttonClassName
  };
  return _react2.default.createElement(
    _ActionButton2.default,
    coreProps,
    icon
  );
};

var NextButton = exports.NextButton = function NextButton(props) {
  var icon = _react2.default.createElement(_icons.SkipNext, { className: props.iconClassName });
  var coreProps = {
    action: playerNext,
    label: 'next',
    // disabled: props.isLoading,
    fab: props.fab,
    buttonClassName: props.buttonClassName
  };

  return _react2.default.createElement(
    _ActionButton2.default,
    coreProps,
    icon
  );
};

var PrevButton = exports.PrevButton = function PrevButton(props) {
  var icon = _react2.default.createElement(_icons.SkipPrevious, { className: props.iconClassName });
  var coreProps = {
    action: playerPrev,
    label: 'prev',
    // disabled: props.isLoading,
    fab: props.fab,
    buttonClassName: props.buttonClassName
  };

  return _react2.default.createElement(
    _ActionButton2.default,
    coreProps,
    icon
  );
};

var ShuffleButton = exports.ShuffleButton = function ShuffleButton(props) {
  var icon = _react2.default.createElement(_icons.Shuffle, { className: props.iconClassName });
  var coreProps = {
    action: shufflePlaying,
    label: 'shuffle',
    // disabled: props.isLoading,
    fab: props.fab,
    buttonClassName: props.buttonClassName
  };

  return _react2.default.createElement(
    _ActionButton2.default,
    coreProps,
    icon
  );
};

var SkipAlbumButton = exports.SkipAlbumButton = function SkipAlbumButton(props) {
  var icon = _react2.default.createElement(_icons.Redo, { className: props.iconClassName });
  var coreProps = {
    action: playerSkip,
    label: 'skip album',
    // disabled: props.isLoading,
    fab: props.fab,
    buttonClassName: props.buttonClassName
  };

  return _react2.default.createElement(
    _ActionButton2.default,
    coreProps,
    icon
  );
};