'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DialogActions = require('@material-ui/core/DialogActions');

var _DialogActions2 = _interopRequireDefault(_DialogActions);

var _DialogContent = require('@material-ui/core/DialogContent');

var _DialogContent2 = _interopRequireDefault(_DialogContent);

var _DialogContentText = require('@material-ui/core/DialogContentText');

var _DialogContentText2 = _interopRequireDefault(_DialogContentText);

var _DialogTitle = require('@material-ui/core/DialogTitle');

var _DialogTitle2 = _interopRequireDefault(_DialogTitle);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _TextField = require('@material-ui/core/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _styles = require('@material-ui/core/styles');

var _TVResponsiveDialog = require('../../../subsonic/components/hoc/TVResponsiveDialog');

var _TVResponsiveDialog2 = _interopRequireDefault(_TVResponsiveDialog);

var _RemotesActions = require('../../actions/RemotesActions');

var _RemotesActions2 = _interopRequireDefault(_RemotesActions);

var _RemoteReceiverToggleButton = require('./RemoteReceiverToggleButton');

var _RemoteReceiverToggleButton2 = _interopRequireDefault(_RemoteReceiverToggleButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = function styles(theme) {
  return {};
};

var RemoteConfigScreen = function (_Component) {
  _inherits(RemoteConfigScreen, _Component);

  _createClass(RemoteConfigScreen, null, [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(props, prevState) {
      return {
        remoteName: prevState.remoteNameChanged ? prevState.remoteName : props.remotes.remoteName,
        remoteNameChanged: prevState.remoteNameChanged
      };
    }
  }]);

  function RemoteConfigScreen(props) {
    _classCallCheck(this, RemoteConfigScreen);

    var _this = _possibleConstructorReturn(this, (RemoteConfigScreen.__proto__ || Object.getPrototypeOf(RemoteConfigScreen)).call(this, props));

    _this.enableRemoteReceiver = function () {
      var remoteName = _this.state.remoteName;
      _this.setState({ remoteName: remoteName });
      _RemotesActions2.default.enableRemoteReceiver(remoteName, _this.props.SubsonicSource, _this.props.history);
    };

    _this.disableRemoteReceiver = function () {
      _RemotesActions2.default.disableRemoteReceiver();
    };

    _this.remoteNameChange = function (e) {
      _this.setState({
        remoteName: e.target.value,
        remoteNameChanged: true
      });
    };

    _this.state = {
      remoteNameChanged: false,
      remoteName: props.remotes.remoteName
    };
    return _this;
  }

  _createClass(RemoteConfigScreen, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          history = _props.history,
          remotes = _props.remotes;

      var remoteEnabled = remotes.remoteState === _RemotesActions.RemoteStates.receiver || remotes.remoteState === _RemotesActions.RemoteStates.receiverPaused;
      // console.log(remotes, remoteEnabled);
      var value = this.state.remoteName || '';
      return _react2.default.createElement(
        _TVResponsiveDialog2.default,
        {
          disableBackdropClick: true,
          open: true,
          className: classes.paperFullScreen
        },
        _react2.default.createElement(
          _DialogTitle2.default,
          null,
          'Remote Receiver Configuration'
        ),
        _react2.default.createElement(
          _DialogContent2.default,
          null,
          _react2.default.createElement(
            _DialogContentText2.default,
            null,
            'Name This Client'
          ),
          _react2.default.createElement(_TextField2.default, {
            label: 'zz-sbr-',
            value: value,
            className: classes.textField,
            onChange: this.remoteNameChange,
            margin: 'normal'
          })
        ),
        _react2.default.createElement(
          _DialogActions2.default,
          null,
          _react2.default.createElement(_RemoteReceiverToggleButton2.default, this.props),
          _react2.default.createElement(
            _Button2.default,
            {
              size: 'small',
              onClick: remoteEnabled ? this.disableRemoteReceiver : this.enableRemoteReceiver,
              disabled: value === ''
            },
            remoteEnabled ? 'Disable' : 'Enable'
          ),
          _react2.default.createElement(
            _Button2.default,
            { size: 'small', onClick: history.goBack },
            'Close'
          )
        )
      );
    }
  }]);

  return RemoteConfigScreen;
}(_react.Component);

exports.default = (0, _styles.withStyles)(styles)(RemoteConfigScreen);
module.exports = exports.default;