'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _RemoteSenderMenu = require('./RemoteSenderMenu');

var _RemoteSenderMenu2 = _interopRequireDefault(_RemoteSenderMenu);

var _MediaButtons = require('./MediaButtons');

var _styles = require('@material-ui/core/styles');

var _Grid = require('@material-ui/core/Grid');

var _Grid2 = _interopRequireDefault(_Grid);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = function styles(theme) {
  return {
    root: {
      width: '100%',
      maxWidth: 480
    },
    container: {}
  };
};

var RemoteControl = function (_React$PureComponent) {
  _inherits(RemoteControl, _React$PureComponent);

  function RemoteControl() {
    _classCallCheck(this, RemoteControl);

    return _possibleConstructorReturn(this, (RemoteControl.__proto__ || Object.getPrototypeOf(RemoteControl)).apply(this, arguments));
  }

  _createClass(RemoteControl, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          csProps = _props.csProps,
          rsProps = _objectWithoutProperties(_props, ['classes', 'csProps']);

      return _react2.default.createElement(
        'div',
        { className: classes.root },
        _react2.default.createElement(
          _Grid2.default,
          { container: true, spacing: 24, className: classes.container },
          _react2.default.createElement(
            _Grid2.default,
            { item: true, xs: 12 },
            _react2.default.createElement(_RemoteSenderMenu2.default, _extends({ variant: 'listItem' }, csProps, rsProps))
          ),
          _react2.default.createElement(
            _Grid2.default,
            { item: true, xs: 4 },
            _react2.default.createElement(_MediaButtons.PlayButton, _extends({}, csProps, {
              fab: true,
              standalone: false,
              color: 'primary'
            }))
          ),
          _react2.default.createElement(
            _Grid2.default,
            { item: true, xs: 4 },
            _react2.default.createElement(_MediaButtons.PauseButton, _extends({}, csProps, {
              fab: false,
              standalone: false,
              color: 'primary'
            }))
          ),
          _react2.default.createElement(
            _Grid2.default,
            { item: true, xs: 4 },
            _react2.default.createElement(_MediaButtons.SkipAlbumButton, csProps)
          ),
          _react2.default.createElement(
            _Grid2.default,
            { item: true, xs: 4 },
            _react2.default.createElement(_MediaButtons.PrevButton, _extends({}, csProps, {
              buttonClassName: 'button-class',
              iconClassName: 'icon-class'
            }))
          ),
          _react2.default.createElement(
            _Grid2.default,
            { item: true, xs: 4 },
            _react2.default.createElement(_MediaButtons.NextButton, csProps)
          ),
          _react2.default.createElement(
            _Grid2.default,
            { item: true, xs: 4 },
            _react2.default.createElement(_MediaButtons.ShuffleButton, null)
          )
        )
      );
    }
  }]);

  return RemoteControl;
}(_react2.default.PureComponent);

exports.default = (0, _styles.withStyles)(styles)(RemoteControl);
module.exports = exports.default;