'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ActionButton = require('../../../subsonic/components/controls/ActionButton');

var _ActionButton2 = _interopRequireDefault(_ActionButton);

var _icons = require('@material-ui/icons');

var _styles = require('@material-ui/core/styles');

var _RemotesActions = require('../../actions/RemotesActions');

var _RemotesActions2 = _interopRequireDefault(_RemotesActions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var style = function style(theme) {
  return {
    enabled: {
      color: theme.palette.primary.light
    },
    paused: {
      color: '#999999'
    },
    disabled: {
      display: 'none'
    }
  };
};

var RemoteReceiverToggleButton = function RemoteReceiverToggleButton(props) {
  if (!props.remotes) return null;
  var remoteEnabled = props.remotes.remoteState === _RemotesActions.RemoteStates.receiver;
  var remotePaused = props.remotes.remoteState === _RemotesActions.RemoteStates.receiverPaused;
  var disabled = !remoteEnabled && !remotePaused;

  var icon = _react2.default.createElement(_icons.Airplay, { className: props.iconClassName });
  var label = remoteEnabled ? 'Disable' : 'Enable';
  var action = remoteEnabled ? _RemotesActions2.default.pauseRemoteReceiver : _RemotesActions2.default.resumeRemoteReceiver;
  var classes = props.classes;
  var coreProps = {
    action: action,
    label: label,
    disabled: props.isLoading,
    fab: props.fab,
    standalone: props.standalone,
    buttonClassName: disabled ? props.classes.disabled : remoteEnabled ? props.classes.enabled : props.classes.paused
  };
  return _react2.default.createElement(
    _ActionButton2.default,
    coreProps,
    icon
  );
};

exports.default = (0, _styles.withStyles)(style)(RemoteReceiverToggleButton);
module.exports = exports.default;