'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _Menu = require('@material-ui/core/Menu');

var _Menu2 = _interopRequireDefault(_Menu);

var _MenuItem = require('@material-ui/core/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _ListItem = require('@material-ui/core/ListItem');

var _ListItem2 = _interopRequireDefault(_ListItem);

var _ListItemIcon = require('@material-ui/core/ListItemIcon');

var _ListItemIcon2 = _interopRequireDefault(_ListItemIcon);

var _ListItemText = require('@material-ui/core/ListItemText');

var _ListItemText2 = _interopRequireDefault(_ListItemText);

var _styles = require('@material-ui/core/styles');

var _icons = require('@material-ui/icons');

var _RemotesActions = require('../../actions/RemotesActions');

var _RemotesActions2 = _interopRequireDefault(_RemotesActions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ITEM_HEIGHT = 48;

var styles = function styles(theme) {
  return {
    listItemReceiver: {
      display: 'none'
    },
    receiver: {
      display: 'none'
    },
    sending: {
      color: theme.palette.primary.light
    },
    normal: {
      color: '#999999'
    }
  };
};

var RemoteSenderMenu = function (_Component) {
  _inherits(RemoteSenderMenu, _Component);

  function RemoteSenderMenu() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, RemoteSenderMenu);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = RemoteSenderMenu.__proto__ || Object.getPrototypeOf(RemoteSenderMenu)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      anchorEl: null
    }, _this.handleClick = function (event) {
      _this.setState({ anchorEl: event.currentTarget });
    }, _this.handleClose = function () {
      _this.setState({ anchorEl: null });
    }, _this.handleMenuClick = function (playlist) {
      console.log('playlist', playlist, _this.props.SubsonicSource);
      _RemotesActions2.default.enableSending(playlist, _this.props.SubsonicSource);
      _this.setState({ anchorEl: null });
    }, _this.handleDisableClick = function () {
      _RemotesActions2.default.disableSending();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(RemoteSenderMenu, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      // console.warn(this.props);
      var _props = this.props,
          classes = _props.classes,
          remotes = _props.remotes,
          _props$variant = _props.variant,
          variant = _props$variant === undefined ? 'button' : _props$variant;
      var anchorEl = this.state.anchorEl;

      var options = remotes.receivers;
      var isReceiver = remotes.remoteState === _RemotesActions.RemoteStates.receiver || remotes.remoteState === _RemotesActions.RemoteStates.receiverPaused;
      var isSending = remotes.remoteState === _RemotesActions.RemoteStates.sender;
      // console.warn('props', this.props);
      var className = void 0,
          liClassName = void 0;
      if (isReceiver) {
        className = classes.receiver;
        liClassName = classes.listItemReceiver;
      } else if (isSending) {
        className = classes.sending;
      } else if (options.length === 0) {
        className = classes.receiver; // nobody to see
        liClassName = classes.listItemReceiver;
      } else {
        className = classes.normal;
      }

      var TheIcon = isSending ? _icons.Phonelink : _icons.Phonelink;
      // console.log('className', className, isReceiver, isSending, options.length, classes);

      var rootOn = void 0,
          rootOff = void 0;
      if (variant === 'button') {
        rootOn = _react2.default.createElement(
          _IconButton2.default,
          { className: className, onClick: this.handleDisableClick },
          _react2.default.createElement(TheIcon, null)
        );
        rootOff = _react2.default.createElement(
          _IconButton2.default,
          {
            'aria-label': 'show list',
            'aria-owns': anchorEl ? 'long-menu' : null,
            'aria-haspopup': 'true',
            className: className,
            onClick: this.handleClick
          },
          _react2.default.createElement(TheIcon, null)
        );
      } else if (variant === 'listItem') {
        rootOn = _react2.default.createElement(
          _ListItem2.default,
          {
            className: liClassName,
            button: true,
            onClick: this.handleDisableClick
          },
          _react2.default.createElement(
            _ListItemIcon2.default,
            { className: className },
            _react2.default.createElement(TheIcon, null)
          ),
          _react2.default.createElement(_ListItemText2.default, { primary: 'Remote Sending On' })
        );
        rootOff = _react2.default.createElement(
          _ListItem2.default,
          {
            className: liClassName,
            button: true,
            'aria-label': 'show list',
            'aria-owns': anchorEl ? 'long-menu' : null,
            'aria-haspopup': 'true',
            onClick: this.handleClick
          },
          _react2.default.createElement(
            _ListItemIcon2.default,
            { className: className },
            _react2.default.createElement(TheIcon, null)
          ),
          _react2.default.createElement(_ListItemText2.default, { primary: 'Remote Sending Off' })
        );
      }

      if (isSending) {
        return rootOn;
      }
      return _react2.default.createElement(
        'div',
        null,
        rootOff,
        _react2.default.createElement(
          _Menu2.default,
          {
            id: 'long-menu',
            anchorEl: anchorEl,
            open: Boolean(anchorEl),
            onClose: this.handleClose,
            PaperProps: {
              style: {
                maxHeight: ITEM_HEIGHT * 4.5,
                width: 200
              }
            }
          },
          options.map(function (option) {
            return _react2.default.createElement(
              _MenuItem2.default,
              {
                key: option.id,
                onClick: _this2.handleMenuClick.bind(_this2, option)
              },
              option.name.substr(7)
            );
          })
        )
      );
    }
  }]);

  return RemoteSenderMenu;
}(_react.Component);

exports.default = (0, _styles.withStyles)(styles)(RemoteSenderMenu);
module.exports = exports.default;