'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PreferenceStoreClass = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Dispatcher = require('../../Dispatcher');

var _Dispatcher2 = _interopRequireDefault(_Dispatcher);

var _PreferenceActions = require('../actions/PreferenceActions');

var _PreferenceActions2 = _interopRequireDefault(_PreferenceActions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var persisted = localStorage.getItem('subfire.preferences');
if (persisted) {
  persisted = JSON.parse(persisted);
} else {
  persisted = {
    backgroundType: _PreferenceActions.backgroundTypes.fuzzyImage
  };
}

var PreferenceStoreClass = exports.PreferenceStoreClass = function () {
  function PreferenceStoreClass() {
    var _this = this;

    _classCallCheck(this, PreferenceStoreClass);

    this.bindActions(_PreferenceActions2.default);
    this.backgroundType = persisted.backgroundType;

    this.on('afterEach', function (payload, state) {
      return _this.afterEach(payload, state);
    });
  }

  _createClass(PreferenceStoreClass, [{
    key: 'setBackgroundType',
    value: function setBackgroundType(b) {
      this.backgroundType = b;
    }
  }, {
    key: 'afterEach',
    value: function afterEach(_ref) {
      var payload = _ref.payload,
          state = _ref.state;

      if (payload.details.name.startsWith('setBackgroundType')) {
        localStorage.setItem('subfire.preferences', JSON.stringify(state));
      }
    }
  }]);

  return PreferenceStoreClass;
}();

exports.default = _Dispatcher2.default.createStore(PreferenceStoreClass, 'PreferenceStore');