"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RemotesStoreClass = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Dispatcher = require("../../Dispatcher");

var _Dispatcher2 = _interopRequireDefault(_Dispatcher);

var _RemotesActions = require("../actions/RemotesActions");

var _RemotesActions2 = _interopRequireDefault(_RemotesActions);

var _SubsonicActions = require("../../subsonic/actions/SubsonicActions");

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var RECEIVER_INTERVAL = 5000;
var SENDER_CHECK_INTERVAL = 10000;

var RemotesStoreClass = exports.RemotesStoreClass = function () {
  function RemotesStoreClass() {
    _classCallCheck(this, RemotesStoreClass);

    this.bindActions(_RemotesActions2.default);
    this.bindAction(_SubsonicActions2.default.RETRIEVED_PLAYLISTS, this.retrievedPlaylists);
    // load from local storage
    this.remoteState = _RemotesActions.RemoteStates.disabled;
    this.receivers = [];
    // console.warn('init', this.remoteName);
  }

  _createClass(RemotesStoreClass, [{
    key: "startCheckingPlaylists",
    value: function startCheckingPlaylists() {
      this.playlistsInterval = setInterval(_SubsonicActions2.default.refreshPlaylists, SENDER_CHECK_INTERVAL);
    }
  }, {
    key: "enableSending",
    value: function enableSending(_ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          pl = _ref2[0],
          source = _ref2[1];

      this.sendingPlaylist = pl;
      this.f = source.fetcher;
      this.remoteState = _RemotesActions.RemoteStates.sender;
    }
  }, {
    key: "disableSending",
    value: function disableSending() {
      this.sendingPlaylist = null;
      this.remoteState = _RemotesActions.RemoteStates.disabled;
    }
  }, {
    key: "sendInstruction",
    value: function sendInstruction(instruction) {
      var _this = this;

      var id = this.sendingPlaylist.id;

      var f = this.f;
      f.getPlaylist(id).then(function (pl) {
        if (pl.playlist && pl.playlist.comment === 'pending') {
          return f.updatePlaylist(id, instruction);
        } else {
          if (pl.playlist && pl.playlist.comment !== 'pending') {
            throw "Warning: still processing previous instruction";
          }
          throw "Error: playlist no longer listening";
        }
      }).then(function (s) {
        console.log('should have worked...');
        return;
      }).catch(function (e) {
        console.error(e);
        if (e !== "Warning: still processing previous instruction") {
          _this.disableSending();
        }
      });
    }
  }, {
    key: "sendRoute",
    value: function sendRoute(route) {
      this.sendInstruction('route ' + route);
      _SubsonicActions2.default.snack.defer("Remote Route sent...", {
        variant: "info"
      });
    }
  }, {
    key: "sendAction",
    value: function sendAction(action) {
      this.sendInstruction('action ' + action);
      _SubsonicActions2.default.snack.defer("Remote Action " + action + " sent...", {
        variant: "info"
      });
    }

    // console.log('playlists', allPlaylists);

  }, {
    key: "retrievedPlaylists",
    value: function retrievedPlaylists(_ref3) {
      var _this2 = this;

      var allPlaylists = _ref3.allPlaylists,
          playlists = _ref3.playlists,
          stations = _ref3.stations;

      this.receivers = allPlaylists.filter(function (pl) {
        return pl.comment === 'pending' && pl.name.startsWith('zz-sbr-') && pl.name !== 'zz-sbr-' + _this2.remoteName;
      });
      // console.log('receivers', this.receivers);
    }
  }, {
    key: "initRemoteState",
    value: function initRemoteState(_ref4) {
      var _ref5 = _slicedToArray(_ref4, 2),
          source = _ref5[0],
          history = _ref5[1];

      console.warn("subsonic." + window.subsonicClientName + ".remoteName", localStorage.getItem("subsonic." + window.subsonicClientName + ".remoteName"));
      this.remoteName = localStorage.getItem("subsonic." + window.subsonicClientName + ".remoteName") || Math.random().toString(36).replace(/[^a-z]+/g, '').substr(0, 5);
      // console.warn(this.remoteName);
      var remoteEnabled = localStorage.getItem("subsonic." + window.subsonicClientName + ".remoteEnabled");
      if (remoteEnabled === 'true') {
        this.enableRemoteReceiver([this.remoteName, source, history]);
      }
    }
  }, {
    key: "enableRemoteReceiver",
    value: function enableRemoteReceiver(_ref6) {
      var _this3 = this;

      var _ref7 = _slicedToArray(_ref6, 3),
          remoteName = _ref7[0],
          source = _ref7[1],
          history = _ref7[2];

      var that = this;
      this.remoteName = remoteName;
      this.history = history;
      localStorage.setItem("subsonic." + window.subsonicClientName + ".remoteName", remoteName);
      localStorage.setItem("subsonic." + window.subsonicClientName + ".remoteEnabled", 'true');
      // TODO:[JS] react to credentials change
      var f = this.f = source.fetcher;
      var name = 'zz-sbr-' + remoteName;
      f.getPlaylists().then(function (pls) {
        // console.warn(pls, remoteName);
        var pl = pls.playlists.playlist.find(function (p) {
          // console.warn(p.name, name, p.owner, f._u);
          return p.name === name && p.owner === f._u;
        });
        if (pl) {
          // console.log('already found', pl);
          return pl;
        }
        return {};
      }).then(function (pl) {
        var id = pl.id;
        return f.createPlaylist(name, id);
      }).then(function (pl) {
        console.log('final pl', pl);
        that.id = pl.id;
        return f.updatePlaylist(that.id, 'pending');
      }).then(function (pl) {
        // console.log('updated');
        pl.comment = 'pending';
        that.remoteState = _RemotesActions.RemoteStates.receiver;
      }).catch(function (e) {
        console.error(e);
      }).then(function () {
        _this3.interval = setInterval(_RemotesActions2.default.checkRemoteState, RECEIVER_INTERVAL);
        _SubsonicActions2.default.refreshPlaylists();
        that.emitChange();
      });
      // set state to RemoteStates.receiver
    }
  }, {
    key: "disableRemoteReceiver",
    value: function disableRemoteReceiver() {
      var f = this.f,
          id = this.id;

      f.deletePlaylist(id).then(function (s) {
        console.log('status', s);
        _SubsonicActions2.default.refreshPlaylists();
      });
      this.remoteState = _RemotesActions.RemoteStates.disabled;
      localStorage.setItem("subsonic." + window.subsonicClientName + ".remoteEnabled", 'false');
      clearInterval(this.interval);
    }
  }, {
    key: "pauseRemoteReceiver",
    value: function pauseRemoteReceiver() {
      var f = this.f,
          id = this.id;

      var that = this;
      clearInterval(this.interval);
      localStorage.setItem("subsonic." + window.subsonicClientName + ".remoteEnabled", 'false');
      this.remoteState = _RemotesActions.RemoteStates.receiverPaused;
      f.updatePlaylist(id, 'paused').then(function (s) {
        console.log('pauseRemoteReceiver', s);
        _SubsonicActions2.default.refreshPlaylists();
      });
    }
  }, {
    key: "resumeRemoteReceiver",
    value: function resumeRemoteReceiver() {
      var f = this.f,
          id = this.id;

      var that = this;
      this.remoteState = _RemotesActions.RemoteStates.receiver;
      f.updatePlaylist(id, 'pending').then(function (s) {
        console.log('resumeRemoteReceiver', s);
        that.interval = setInterval(_RemotesActions2.default.checkRemoteState, RECEIVER_INTERVAL);
        _SubsonicActions2.default.refreshPlaylists();
      });
    }
  }, {
    key: "checkRemoteState",
    value: function checkRemoteState() {
      var _this4 = this;

      var f = this.f,
          id = this.id,
          history = this.history;

      f.getPlaylist(id).then(function (pl) {
        // console.log('checkstate pl', pl.playlist);
        var c = pl.playlist.comment || '';
        var method = history.location.pathname === '/player' ? 'replace' : 'push';
        var n = pl.playlist.name;
        if (c.startsWith('route')) {
          f.updatePlaylist(id, 'pending').then(function () {
            var r = c.substring(6);
            history[method](r);
          });
        } else if (c.startsWith('action')) {
          f.updatePlaylist(id, 'pending').then(function () {
            var a = c.substring(7);
            switch (a) {
              case 'play':
              case 'pause':
              case 'playOrPause':
              case 'playerNext':
              case 'playerPrev':
              case 'shufflePlaying':
              case 'playerSkip':
                _SubsonicActions2.default[a]();
                break;
              default:
                console.warn('unexpected instruction', a);
            }
          });
        } else if (c === 'playthis') {
          // to use to basically 'cast' your current play queue over as is.  not implemented yet, needs 'bookmark' like behavior of index and position
          f.updatePlaylist(id, 'playing').then(function () {
            history[method]('/loading/playlist/' + id);
          });
        } else if (c === 'playing') {
          // this is to clear the state of the previous event.  not used.
          f.createPlaylist(n, id).then(function () {
            return f.updatePlaylist(id, 'pending');
          }).then(function () {
            console.log('playing and cleared...');
          }).catch(function (e) {
            console.error(e);
            _this4.disableRemoteReceiver();
          });
        }
      }).catch(function (err) {
        console.log('maybe not logged in', err);
      });
    }
  }]);

  return RemotesStoreClass;
}();

exports.default = _Dispatcher2.default.createStore(RemotesStoreClass, 'RemotesStore');