'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _Dispatcher = require('../../Dispatcher');

var _Dispatcher2 = _interopRequireDefault(_Dispatcher);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/* eslint no-trailing-spaces: */
var SubsonicActions = function SubsonicActions() {
  _classCallCheck(this, SubsonicActions);

  this.snack = function (message, options) {
    console.warn(message, options);
    if (typeof options === 'string') {
      options = { variant: options };
    }
    return [message, options];
  };

  this.playOrPause = function () {
    window.castSubsonic.playerHandler.playOrPause();
    return true;
  };

  this.play = function () {
    window.castSubsonic.playerHandler.play();
    return true;
  };

  this.pause = function () {
    window.castSubsonic.playerHandler.pause(false);
    return true;
  };

  this.generateActions('startPlayingCurrentQueue', 'getNowPlaying', 'returnNowPlaying', 'followUser', 'appendToPlayQueue', 'setOffline', 'setBusy', 'setPostLoginRoute', 'setChromecastAvailable', 'setChromecastConnected', 'loginSuccess', 'loginFailure', 'refreshPlaylists', 'retrievedPlaylists', 'selectPlaylist', 'populatePlaylist', 'sortPlaylist', 'selectStation', 'populateStation', 'setInternetStations', 'playInternetStation', 'shuffleMusicFolder', 'fetchPodcasts', 'returnPodcasts', 'playPodcast', 'setAlbumQuery', 'fetchAlbumPage', 'returnAlbumPage', 'playSong', 'retrievedSong', 'loadAlbum', 'setAllArtists', 'setArtists', 'setArtistIndex', 'setArtist', 'setArtistAlbums', 'setAlbum', 'retrievedAlbum', 'setAndPlayArtistSongs', 'playArtistSongs', 'fetchMusicFolders', 'setMusicFolders', 'setMusicFolder', 'setMusicDirectoryIndexes', 'setMusicDirectoryIndex', 'setMusicDirectory', 'retrievedMusicDirectory', 'playMusicDirectorySongs', 'startPlaying', 'stopPlaying', 'playerNext', 'playerPrev', 'playerSkip', 'playerSkipToTrack', 'playerSkipToIndex', 'shufflePlaying', 'fetchPlayQueue', 'savePlayQueue', 'restorePlayQueue', 'setBookmarkContext', 'storeBookmarks', 'getBookmarks', 'createBookmark', 'deleteBookmark', 'setLoadingTitle', 'setSearchMusicFolder', 'doSearch', 'searchResults', 'toggleMenu', 'toggleAlbumsAsGrid', 'setSnackerFunction', 'getVideos', 'retrievedVideos');
};

exports.default = _Dispatcher2.default.createActions(SubsonicActions);
module.exports = exports.default;