'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _RemotesActions = require('../../subfire/actions/RemotesActions');

var _RemotesActions2 = _interopRequireDefault(_RemotesActions);

var _SubsonicActions = require('../actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

var _SubsonicLoadingCard = require('./SubsonicLoadingCard');

var _SubsonicLoadingCard2 = _interopRequireDefault(_SubsonicLoadingCard);

var _ColorActions = require('../../subfire/actions/ColorActions');

var _ColorActions2 = _interopRequireDefault(_ColorActions);

var _utils = require('../../utils/utils.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SubsonicLoader = function (_Component) {
  _inherits(SubsonicLoader, _Component);

  _createClass(SubsonicLoader, null, [{
    key: 'findArtist',
    value: function findArtist(id, subsonic, SubsonicSource) {
      var i = void 0,
          j = void 0;
      var ais = subsonic.allArtistIndexes;
      for (i = 0; i < ais.length; ++i) {
        for (j = 0; j < ais[i].artist.length; ++j) {
          if (ais[i].artist[j].id === id) {
            return ais[i].artist[j];
          }
        }
      }
      return {
        name: '' + id,
        id: '' + id
      };
    }
  }, {
    key: 'findAlbum',
    value: function findAlbum(id, subsonic, SubsonicSource) {
      var object = subsonic.albums.find(function (x) {
        return x.id === id;
      });
      if (!object && subsonic.artistAlbums && subsonic.artistAlbums.album) {
        object = subsonic.artistAlbums.album.find(function (x) {
          return x.id === id;
        });
      }
      // not loaded yet, lets just fake it.
      if (!object) object = {
        name: '' + id,
        title: '' + id,
        id: '' + id,
        coverArt: 'al-' + id
      };
      return object;
    }
  }, {
    key: 'findDirectory',
    value: function findDirectory(id, subsonic, SubsonicSource) {
      var object = void 0;
      return object;
    }
  }, {
    key: 'findObject',
    value: function findObject(type, id, mode, subsonic, SubsonicSource) {
      var object = void 0;

      switch (type) {
        case 'playlist':
        case 'station':
          object = subsonic.allPlaylists.find(function (x) {
            return x.id === id;
          });
          break;
        case 'albumID3':
        case 'albumAction':
          object = SubsonicLoader.findAlbum(id, subsonic, SubsonicSource);
          break;
        case 'artist':
        case 'artistAction':
          object = SubsonicLoader.findArtist(id, subsonic, SubsonicSource);
          break;
        case 'album':
        case 'directoryAction':
        case 'directory':
          object = SubsonicLoader.findDirectory(id, subsonic, SubsonicSource);
          break;
        case 'folderShuffle':
          id = id || -1;
          object = subsonic.musicFolders.find(function (m) {
            return m.id + '' === id + '';
          }) || {
            name: 'All Music Folders',
            id: -1
          };
          console.log(object, id);
          object.coverArt = -1;
          break;
        case 'playQueue':
          object = {
            name: 'Play Queue',
            id: -1
          };
          break;
        case 'podcasts':
          object = {
            name: 'Podcasts',
            id: -1
          };
          break;
        case 'song':
          object = {
            name: 'Song or Video',
            id: id
          };
          break;
        default:
          console.error('unsupported type', type, id, mode);
          object = {
            name: 'Unsupported Type',
            id: -1
          };
      }
      return object;
    }

    // need to verify before redirect because sometimes isBusy is being unset by other things like folders, artists, indexes, or ancient history.
    // MUST be something that will resolve. checking empty is not good enough because the result of the query may be empty as well.
    // means store will need to init more things as null instead.

  }, {
    key: 'checkIfReallyLoaded',
    value: function checkIfReallyLoaded(type, id, mode, subsonic) {
      if (type === 'podcasts') {
        return subsonic.podcasts !== null;
      }
      // will expand as needed
      return false;
    }
  }, {
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(props, prevState) {
      var type = props.route.match.params.type;
      var id = props.route.match.params.id;
      var mode = props.route.match.params.mode;

      var position = props.route.match.params.position;
      var bookmarkId = props.route.match.params.bookmarkId;

      var subsonic = props.subsonic;
      var SubsonicSource = props.SubsonicSource;
      var object = SubsonicLoader.findObject(type, id, mode, subsonic, SubsonicSource);
      //console.log('found object', object);

      var isBusy = props.subsonic.isBusy;
      var loadingState = prevState && prevState.loadingState ? prevState.loadingState : 'init';
      if (!isBusy && (prevState && prevState.isBusy || SubsonicLoader.checkIfReallyLoaded(type, id, mode, subsonic))) {
        console.warn('isBusy', isBusy, 'loading state to ready');
        loadingState = 'ready';
      }

      var state = {
        isBusy: isBusy,
        loadingState: loadingState,
        type: type,
        id: id,
        mode: mode,
        position: position,
        bookmarkId: bookmarkId,
        object: object
      };
      // console.warn('loader', state, props, prevState);
      return state;
    }
  }]);

  function SubsonicLoader(props) {
    _classCallCheck(this, SubsonicLoader);

    var _this = _possibleConstructorReturn(this, (SubsonicLoader.__proto__ || Object.getPrototypeOf(SubsonicLoader)).call(this, props));

    _this.goBack = function (history) {
      if (!_this.goneBack) {
        if (_this.props.remoteRoute) {
          history.replace(_this.props.remoteRoute);
        } else {
          history.goBack();
        }
      }
      _this.goneBack = true;
    };

    _this.state = {};
    // this.state = SubsonicLoader.getDerivedStateFromProps(props);
    // console.log('constructor  state', this.state);
    // this.state.loadingState = 'init';
    return _this;
  }

  _createClass(SubsonicLoader, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      console.log('mount', this.props, this.state);
      var _props = this.props,
          route = _props.route,
          remotes = _props.remotes,
          subsonic = _props.subsonic;
      var _state = this.state,
          type = _state.type,
          id = _state.id,
          mode = _state.mode,
          position = _state.position;

      if (remotes.remoteState === _RemotesActions.RemoteStates.sender) {
        this.startLoadRemote(route.location, type, id, mode, position, subsonic);
      } else {
        this.startLoad(type, id, mode, position, subsonic);
      }
      delete window.bookmarkSeekTo;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      // ColorActions.resetColors.defer();
    }
  }, {
    key: 'startLoadRemote',
    value: function startLoadRemote(location, type, id, mode, position, subsonic) {
      switch (type) {
        case 'playlist':
        case 'station':
        case 'albumAction':
        case 'playQueue':
        case 'directoryAction':
        case 'folderShuffle':
        case 'artistAction':
        case 'song':
          _RemotesActions2.default.sendRoute(location.pathname);
          this.setState({ loadingState: 'ready' });
          break;
        case 'albumID3':
          _SubsonicActions2.default.loadAlbum.defer([id, true]);
          break;
        case 'album':
          _SubsonicActions2.default.loadAlbum.defer([id, false]);
          break;
        case 'artist':
          // remote - load it locally
          var artist = SubsonicLoader.findArtist(id, this.props.subsonic);
          _SubsonicActions2.default.setArtist.defer(artist);
          break;
        case 'directory':
          // remote - load it locally
          _SubsonicActions2.default.setMusicDirectory.defer(id);
          break;
        case 'podcasts':
          // not sure yet
          _SubsonicActions2.default.fetchPodcasts.defer();
          break;
        default:
          console.error('unsupported remote type', type);
      }
    }
  }, {
    key: 'startLoad',
    value: function startLoad(type, id, mode, position, subsonic) {
      console.log('loading', type, id, mode, position);
      var bookmarkSource = 'SubFire';
      var loadingState = this.state.loadingState;
      _SubsonicActions2.default.setBookmarkContext.defer({
        type: type,
        id: id,
        mode: mode,
        position: position,
        bookmarkSource: bookmarkSource
      });
      switch (type) {
        case 'playlist':
          _SubsonicActions2.default.selectPlaylist.defer(id, mode);
          break;
        case 'station':
          _SubsonicActions2.default.selectStation(id);
          break;
        case 'albumID3':
          _SubsonicActions2.default.loadAlbum.defer([id, true]);
          break;
        case 'album':
          _SubsonicActions2.default.loadAlbum.defer([id, false]);
          break;
        case 'playQueue':
          _SubsonicActions2.default.fetchPlayQueue();
          break;
        case 'directoryAction':
          _SubsonicActions2.default.playMusicDirectorySongs(id, mode);
          break;
        case 'directory':
          _SubsonicActions2.default.setMusicDirectory.defer(id);
          break;
        case 'song':
          _SubsonicActions2.default.playSong(id);
          break;
        case 'podcasts':
          _SubsonicActions2.default.fetchPodcasts.defer();
          break;
        case 'folderShuffle':
          id = id === '-1' ? null : id;
          _SubsonicActions2.default.shuffleMusicFolder.defer(id);
          break;
        case 'albumAction':
          var albumItem = subsonic.albumsById[id];
          if (albumItem) {
            var songs = albumItem.song;
            if (mode === 'shuffle') {
              (0, _utils.arrayShuffle)(songs);
            }
            _SubsonicActions2.default.startPlaying(songs, 0);
            loadingState = 'ready';
          } else {
            if (loadingState === 'init') {
              _SubsonicActions2.default.loadAlbum.defer([id, true]);
              loadingState = 'loading';
            }
          }
          break;
        case 'artistAction':
          var aartist = SubsonicLoader.findArtist(id, this.props.subsonic);
          console.log('artistAction', aartist);
          _SubsonicActions2.default.setAndPlayArtistSongs(aartist, mode);
          break;
        case 'artist':
          var artist = SubsonicLoader.findArtist(id, this.props.subsonic);
          console.log('startLoad', artist);
          _SubsonicActions2.default.setArtist.defer(artist);
          break;
        default:
          console.error('unsupported type', type);
      }
      this.setState({ loadingState: loadingState });
    }

    // componentWillReceiveProps(nextProps) {
    //   var state = SubsonicLoader.getDerivedStateFromProps(nextProps, this.state);
    //   this.setState(state);
    //   console.log('new state', state);
    // }

  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return true;
    }

    // todo - route replace to /remoteControl or other location if specified in props

  }, {
    key: 'render',
    value: function render() {
      // console.log('render', this.props, this.state);
      var _state2 = this.state,
          _state2$position = _state2.position,
          position = _state2$position === undefined ? 0 : _state2$position,
          _state2$bookmarkId = _state2.bookmarkId,
          bookmarkId = _state2$bookmarkId === undefined ? null : _state2$bookmarkId;
      var _props2 = this.props,
          route = _props2.route,
          subsonic = _props2.subsonic;
      var history = route.history;
      var _route$match$params = route.match.params,
          id = _route$match$params.id,
          type = _route$match$params.type,
          mode = _route$match$params.mode;
      var goBack = this.props.goBack;

      var LoadingComponent = this.props.LoadingComponent || _SubsonicLoadingCard2.default;
      var successRoute = '/player'; // this includes bookmarks as well as /loading

      if (!route.match.params['0'] && !route.match.params.bookmarkId) {
        successRoute = '/songs';
      }

      if (this.state.loadingState === 'loading' || this.state.loadingState === 'init') return _react2.default.createElement(LoadingComponent, {
        SubsonicSource: this.props.SubsonicSource,
        subsonic: this.props.subsonic,
        object: this.state.object,
        type: this.state.type,
        id: this.state.id,
        top: this.props.top
      });
      if (type === 'playlist' && mode === 'list') {
        return _react2.default.createElement(_reactRouterDom.Redirect, { to: '/playlist/' + id });
      }
      if (type === 'artist') {
        return _react2.default.createElement(_reactRouterDom.Redirect, { to: '/artist/' + id });
      }
      if (type === 'album') {
        return _react2.default.createElement(_reactRouterDom.Redirect, { to: '/directory/' + id });
      }
      if (type === 'albumID3') {
        return _react2.default.createElement(_reactRouterDom.Redirect, { to: '/album/' + id });
      }
      if (type === 'directory') {
        return _react2.default.createElement(_reactRouterDom.Redirect, { to: '/directory/' + id });
      }
      if (type === 'podcasts' && !window.bookmarkState) {
        return _react2.default.createElement(_reactRouterDom.Redirect, { to: '/podcasts' });
      } else {
        if (this.props.remotes.remoteState === _RemotesActions.RemoteStates.sender) {
          this.goBack(history);
          return null;
        }

        if (type === 'playQueue' && subsonic.playQueue) {
          position = subsonic.playQueue.position;
          bookmarkId = subsonic.playQueue.current;
        }

        if (type === 'albumAction') {
          var albumItem = subsonic.albumsById[id];
          if (albumItem) {
            var songs = albumItem.song;
            if (mode === 'shuffle') {
              (0, _utils.arrayShuffle)(songs);
            }
            _SubsonicActions2.default.startPlaying.defer(songs, 0);
          }
        }

        if (goBack) {
          this.goBack(history);
          return null;
        }

        if (successRoute === '/player' && type !== 'albumAction') {
          _SubsonicActions2.default.startPlayingCurrentQueue.defer();
        }

        if (position || bookmarkId) {
          var bookmark = {
            position: position,
            bookmarkId: bookmarkId
          };
          _SubsonicActions2.default.playerSkipToTrack.defer(bookmark);
        }

        return _react2.default.createElement(_reactRouterDom.Redirect, { to: successRoute });
      }
    }
  }]);

  return SubsonicLoader;
}(_react.Component);

exports.default = SubsonicLoader;
module.exports = exports.default;