'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _MobilePlayer = require('./MobilePlayer');

var _MobilePlayer2 = _interopRequireDefault(_MobilePlayer);

var _MiniPlayer = require('./MiniPlayer');

var _MiniPlayer2 = _interopRequireDefault(_MiniPlayer);

var _SubsonicStore = require('../stores/SubsonicStore');

var _SubsonicActions = require('../actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

var _uaParserJs = require('ua-parser-js');

var _uaParserJs2 = _interopRequireDefault(_uaParserJs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ThePlayer = function (_Component) {
  _inherits(ThePlayer, _Component);

  _createClass(ThePlayer, null, [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(props, prevState) {
      var _props$subsonic = props.subsonic,
          subsonic = _props$subsonic === undefined ? {} : _props$subsonic,
          SubsonicSource = props.SubsonicSource,
          csProps = props.csProps;
      var isConnected = subsonic.isConnected,
          currentPlaying = subsonic.currentPlaying;

      if (!isConnected) {
        return prevState;
      }
      var newState = void 0;

      if (!currentPlaying.queue.length) {
        newState = {
          showBackground: false,
          currentFile: _SubsonicStore.emptytrack,
          currentPlaying: currentPlaying
        };
      } else {
        var currentFile = currentPlaying.queue[currentPlaying.idx];
        var p = csProps;
        // console.log(p.reason);
        var showBackground = prevState.showBackground,
            isWaitingForNext = prevState.isWaitingForNext,
            coverSize = prevState.coverSize,
            coverArt = prevState.coverArt,
            mediaSrc = prevState.mediaSrc,
            mediaIcon = prevState.mediaIcon,
            reason = prevState.reason;

        if (currentFile !== prevState.currentFile) {
          console.warn('next track...');
          isWaitingForNext = false;
          var minWidth = Math.trunc(window.innerWidth * (10 / 12));
          /*
          - 64 // appbar
          - 56 // buttons
          - 32 // slider
          - 16 // time strings
          - 80 // info cards
          */
          var maxHeight = Math.trunc(window.innerHeight - 248);

          coverSize = Math.min(minWidth, maxHeight);
          coverSize = coverSize <= 0 ? window.lastCoverSize : coverSize;
          window.lastCoverSize = coverSize;
          coverArt = SubsonicSource.getCoverArtURL(currentFile.id, coverSize);
          mediaSrc = currentFile.localPath || (currentFile.src && currentFile.src.startsWith('http') ? currentFile.src : SubsonicSource.getStreamingURL(currentFile.id));
          mediaIcon = SubsonicSource.getCoverArtURL(currentFile.id, 192) + '&co=false';

          // now load castplayer
          currentFile.coverArtURL = coverArt;
          currentFile.src = mediaSrc;
          console.warn('first load', currentFile);
          window.cp.playerHandler.load(currentFile, 0);
          // console.warn(currentFile);
        } else {
          // console.warn('checking', prevState.isWaitingForNext, reason, p.reason);
          if (!prevState.isWaitingForNext && reason !== p.reason && p.reason === 'playbackEnded') {
            console.warn('endPlayback next...');
            isWaitingForNext = true;
            _SubsonicActions2.default.playerNext.defer();
          }
        }

        // hack - no easy way to pass this around
        if (window.bookmarkSeekTo) {
          window.castSubsonic.seekMedia(window.bookmarkSeekTo);
          window.bookmarkSeekTo = null;
        }

        if (prevState.showBackground !== p.isPlaying) {
          showBackground = p.isPlaying;
        }

        // if (p.reason !== 'normal') console.log('p', p);
        var currentMediaTimeString = p.currentMediaTimeString,
            durationString = p.durationString;


        newState = {
          currentPlaying: currentPlaying,
          currentFile: currentFile,
          coverArt: coverArt,
          mediaSrc: mediaSrc,
          mediaIcon: mediaIcon,
          coverSize: coverSize,
          showBackground: showBackground,
          isWaitingForNext: isWaitingForNext,
          currentMediaTimeString: currentMediaTimeString,
          durationString: durationString,
          reason: csProps.reason
        };
      }
      return Object.assign({}, prevState, newState);
    }
  }]);

  function ThePlayer(props) {
    _classCallCheck(this, ThePlayer);

    // never gonna change so no need to be state
    var _this = _possibleConstructorReturn(this, (ThePlayer.__proto__ || Object.getPrototypeOf(ThePlayer)).call(this, props));

    _this.savePlayQueue = function () {
      _SubsonicActions2.default.savePlayQueue(Math.trunc((_this.state.currentMediaTime || 0) * 1000));
    };

    _this.toggleBookmark = function (currentMediaTime) {
      // console.log('toggleBookmark', currentMediaTime, this.props);
      var subsonic = _this.props.subsonic;
      var currentPlaying = subsonic.currentPlaying;

      var id = currentPlaying.queue[currentPlaying.idx].id;

      if (subsonic.bookmarksById[id]) {
        _SubsonicActions2.default.deleteBookmark(id);
      } else {
        _SubsonicActions2.default.createBookmark(id, Math.trunc(currentMediaTime * 1000));
      }
    };

    _this.seekValueChange = function (rangeSliderState) {
      _this.setState({ rangeSliderState: rangeSliderState });
    };

    _this.togglePlayer = function () {
      var isMobilePlayer = _this.state.Player === _MobilePlayer2.default;
      _this.setState({
        Player: isMobilePlayer ? _MiniPlayer2.default : _MobilePlayer2.default
      });
    };

    _this.ua = new _uaParserJs2.default().getResult();
    // console.log(this.ua);

    var os = _this.ua.os;
    _this.isMobile = os.name === 'Android' || os.name === 'iOS';
    // const portrait = window.innerHeight >= window.innerWidth;

    _this.state = {
      Player: window.lastPlayer || _MobilePlayer2.default
    };
    return _this;
  }

  _createClass(ThePlayer, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      try {
        console.warn('didMount - play');
        window.cp.playerHandler.play();
      } catch (e) {
        // console.error(e);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.cp.playerHandler.pause();
      window.lastPlayer = this.state.Player;
    }
  }, {
    key: 'render',
    value: function render() {
      var Player = this.state.Player;
      // const togglePlayer = this.isMobile ? null : this.togglePlayer;

      var actions = {
        seekValueChange: this.seekValueChange,
        toggleBookmark: this.toggleBookmark,
        savePlayQueue: this.savePlayQueue,
        togglePlayer: this.togglePlayer
      };
      return _react2.default.createElement(Player, _extends({}, this.props, { playerState: this.state }, actions));
    }
  }]);

  return ThePlayer;
}(_react.Component);

exports.default = ThePlayer;
module.exports = exports.default;