'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _GridList = require('@material-ui/core/GridList');

var _GridList2 = _interopRequireDefault(_GridList);

var _icons = require('@material-ui/icons');

var _List = require('@material-ui/core/List');

var _List2 = _interopRequireDefault(_List);

var _ListItem = require('@material-ui/core/ListItem');

var _ListItem2 = _interopRequireDefault(_ListItem);

var _ListItemIcon = require('@material-ui/core/ListItemIcon');

var _ListItemIcon2 = _interopRequireDefault(_ListItemIcon);

var _ListItemText = require('@material-ui/core/ListItemText');

var _ListItemText2 = _interopRequireDefault(_ListItemText);

var _ListItemSecondaryAction = require('@material-ui/core/ListItemSecondaryAction');

var _ListItemSecondaryAction2 = _interopRequireDefault(_ListItemSecondaryAction);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _MusicFolderChooser = require('./MusicFolderChooser');

var _MusicFolderChooser2 = _interopRequireDefault(_MusicFolderChooser);

var _AlbumQueryChooser = require('./AlbumQueryChooser');

var _AlbumQueryChooser2 = _interopRequireDefault(_AlbumQueryChooser);

var _SubsonicActions = require('../../actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

var _InfiniteScroll = require('../styled/InfiniteScroll');

var _InfiniteScroll2 = _interopRequireDefault(_InfiniteScroll);

var _ScrollToTopFab = require('../styled/ScrollToTopFab');

var _ScrollToTopFab2 = _interopRequireDefault(_ScrollToTopFab);

var _CoverGridTile = require('../styled/CoverGridTile');

var _CoverGridTile2 = _interopRequireDefault(_CoverGridTile);

var _styles = require('@material-ui/core/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = function styles(theme) {
  return {};
};

var AlbumQueryBrowser = function (_React$Component) {
  _inherits(AlbumQueryBrowser, _React$Component);

  function AlbumQueryBrowser(props) {
    _classCallCheck(this, AlbumQueryBrowser);

    var _this = _possibleConstructorReturn(this, (AlbumQueryBrowser.__proto__ || Object.getPrototypeOf(AlbumQueryBrowser)).call(this, props));

    _this.updateDimensions = function () {
      _this.setState({ width: window.innerWidth, height: window.innerHeight });
    };

    _this.componentDidMount = function () {
      window.addEventListener('resize', _this.updateDimensions);
      _this.updateDimensions();

      var state = _this.props.subsonic;
      if (state.albums.length === 0) {
        setTimeout(function () {
          _SubsonicActions2.default.fetchAlbumPage.defer(state.albumPage, state.albumID3);
        }, 2000);
      }
    };

    _this.componentWillUnmount = function () {
      window.removeEventListener('resize', _this.updateDimensions);
    };

    _this.loadMore = function (page) {
      var state = _this.props.subsonic;
      // console.log(page, state.albumPage, state.albumPage + 2);
      // hackery
      var alt = window.alt;
      if (alt && alt.dispatcher._isDispatching) {
        if (page === state.albumPage + 2) {
          _SubsonicActions2.default.fetchAlbumPage.defer(state.albumPage + 1, state.albumID3);
        }
        return;
      }
      _SubsonicActions2.default.fetchAlbumPage(state.albumPage + 1, state.albumID3);
    };

    _this.loadAlbumFolder = function (album) {
      var albumID3 = _this.props.subsonic.albumID3;

      if (albumID3) {
        _this.props.history.push('/loading/albumID3/' + album.id);
      } else {
        _this.props.history.push('/loading/directory/' + album.id);
      }
    };

    _this.myRef = _react2.default.createRef();
    return _this;
  }

  _createClass(AlbumQueryBrowser, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      // console.log(this.props);
      var _props = this.props,
          subsonic = _props.subsonic,
          SubsonicSource = _props.SubsonicSource,
          linkComponent = _props.linkComponent,
          linkComponentID3 = _props.linkComponentID3,
          native = _props.native,
          classes = _props.classes;

      var isGrid = subsonic.albumsAsGrid;
      var albumID3 = subsonic.albumID3;


      var theLinkComponent = albumID3 ? linkComponentID3 : linkComponent;

      var albums = subsonic.albums || [];
      // console.log('aqb', state.albums.length, state.albumPage, state.hasMoreAlbums, 'hasMore?', !!(state.hasMoreAlbums && albums.length));

      var hasMore = subsonic.hasMoreAlbums && albums.length !== 0 && albums.length < 400;

      var innerWidth = window.innerWidth;
      if (this.myRef && this.myRef.current) {
        innerWidth = this.myRef.current.offsetWidth;
      }

      if (isNaN(innerWidth)) innerWidth = 360;

      var spacing = innerWidth > 360 ? 10 : 6;
      var cellSize = innerWidth > 360 ? 170 : 164;

      var cols = innerWidth / (cellSize + spacing);
      var width = cols * (cellSize + spacing);

      var height = this.props.height || window.innerHeight;

      var GridListIcon = isGrid ? _icons.GridOn : _icons.ViewList;
      var gridListToggle = _react2.default.createElement(
        'div',
        { className: classes.buttonCell },
        _react2.default.createElement(
          _Button2.default,
          {
            variant: 'outlined',
            className: classes.button,
            onClick: _SubsonicActions2.default.toggleAlbumsAsGrid
          },
          'As ' + (isGrid ? 'Grid' : 'List'),
          _react2.default.createElement(GridListIcon, { className: classes.rightIcon })
        )
      );
      var musicFolderChooser = _react2.default.createElement(_MusicFolderChooser2.default, _extends({ native: native }, subsonic));

      var content = isGrid ? _react2.default.createElement(
        'div',
        { ref: this.myRef },
        _react2.default.createElement(
          _GridList2.default,
          {
            cellHeight: cellSize,
            width: width,
            cols: cols,
            spacing: spacing
          },
          albums.map(function (n, idx) {
            return _react2.default.createElement(_CoverGridTile2.default, {
              key: 'alb' + n.id + (subsonic.albumQuery && (subsonic.albumQuery === 'random' || subsonic.albumQuery.startsWith('pl-')) ? idx : ''),
              onClick: _this2.loadAlbumFolder.bind(_this2, n),
              subname: n.artist,
              name: n.title || n.name,
              normal: true,
              size: 160,
              coverArt: n.coverArt,
              linkComponent: theLinkComponent,
              id: n.id,
              SubsonicSource: SubsonicSource
            });
          })
        )
      ) : _react2.default.createElement(
        _List2.default,
        null,
        albums.map(function (item) {
          return _react2.default.createElement(
            _ListItem2.default,
            {
              key: 'alb' + item.id,
              button: true,
              component: _reactRouterDom.Link,
              to: albumID3 ? '/loading/albumID3/' + item.id : '/loading/directory/' + item.id
            },
            _react2.default.createElement(
              _ListItemIcon2.default,
              null,
              _react2.default.createElement('img', {
                alt: '',
                width: 48,
                height: 48,
                src: SubsonicSource.getCoverArtURL(item.coverArt, 48)
              })
            ),
            _react2.default.createElement(_ListItemText2.default, {
              primary: item.title || item.album || item.name,
              secondary: item.artist
            }),
            _react2.default.createElement(
              _ListItemSecondaryAction2.default,
              null,
              _react2.default.createElement(
                _IconButton2.default,
                {
                  'aria-label': 'Play',
                  component: _reactRouterDom.Link,
                  to: albumID3 ? '/loading/albumAction/' + item.id + '/play' : '/loading/directoryAction/' + item.id + '/all'
                },
                _react2.default.createElement(_icons.VideoLibrary, null)
              )
            )
          );
        })
      );

      return _react2.default.createElement(
        'div',
        {
          style: { height: height, overflow: 'auto' },
          id: 'album-query-wrapper'
        },
        _react2.default.createElement(_AlbumQueryChooser2.default, _extends({
          native: native
        }, subsonic, {
          SubsonicSource: SubsonicSource,
          musicFolderChooser: musicFolderChooser,
          gridListToggle: gridListToggle
        })),
        _react2.default.createElement(
          _InfiniteScroll2.default,
          {
            useWindow: false,
            initialLoad: false,
            pageStart: subsonic.albumPage,
            loadMore: this.loadMore,
            hasMore: hasMore
          },
          content
        ),
        _react2.default.createElement(_ScrollToTopFab2.default, this.props.fabProps)
      );
    }
  }]);

  return AlbumQueryBrowser;
}(_react2.default.Component);

exports.default = (0, _styles.withStyles)(styles)(AlbumQueryBrowser);
module.exports = exports.default;