'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _SubsonicActions = require('../../actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

var _PlaylistsBrowser = require('./PlaylistsBrowser');

var _PlaylistsBrowser2 = _interopRequireDefault(_PlaylistsBrowser);

var _Grid = require('@material-ui/core/Grid');

var _Grid2 = _interopRequireDefault(_Grid);

var _Select = require('@material-ui/core/Select');

var _Select2 = _interopRequireDefault(_Select);

var _MenuItem = require('@material-ui/core/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _FormControl = require('@material-ui/core/FormControl');

var _FormControl2 = _interopRequireDefault(_FormControl);

var _FormControlLabel = require('@material-ui/core/FormControlLabel');

var _FormControlLabel2 = _interopRequireDefault(_FormControlLabel);

var _Input = require('@material-ui/core/Input');

var _Input2 = _interopRequireDefault(_Input);

var _InputLabel = require('@material-ui/core/InputLabel');

var _InputLabel2 = _interopRequireDefault(_InputLabel);

var _Switch = require('@material-ui/core/Switch');

var _Switch2 = _interopRequireDefault(_Switch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AlbumQueryChooser = function (_Component) {
  _inherits(AlbumQueryChooser, _Component);

  function AlbumQueryChooser(props) {
    _classCallCheck(this, AlbumQueryChooser);

    var _this = _possibleConstructorReturn(this, (AlbumQueryChooser.__proto__ || Object.getPrototypeOf(AlbumQueryChooser)).call(this, props));

    _this.handleChange = function (evt) {
      _SubsonicActions2.default.setAlbumQuery(evt.target.value, _this.props.albumID3);
    };

    _this.handleID3Change = function (evt, isInputChecked) {
      _SubsonicActions2.default.setAlbumQuery(_this.props.albumQuery, isInputChecked);
    };

    _this.handlePlaylistChange = function (plID) {
      _SubsonicActions2.default.setAlbumQuery('pl-' + plID, _this.props.albumID3);
      _this.updatePlQuery(plID);
    };

    var plKey = props.albumQuery.startsWith('pl-') ? props.albumQuery : 'pl-';
    _this.state = {
      queries: [{
        id: 'random',
        name: 'Random'
      }, {
        id: 'newest',
        name: 'Recently Added'
      }, {
        id: 'recent',
        name: 'Recently Played'
      }, {
        id: 'frequent',
        name: 'Most Played'
      }, {
        id: 'alphabeticalByName',
        name: 'By Album Name'
      }, {
        id: 'alphabeticalByArtist',
        name: 'By Artist Name'
      }, {
        id: 'starred',
        name: 'Starred'
      }, {
        id: 'byYear',
        name: 'Oldest First'
      }, {
        id: 'byYear reversed',
        name: 'Newest First'
      }, {
        id: plKey,
        name: 'From Playlist'
      }]
    };
    return _this;
  }

  _createClass(AlbumQueryChooser, [{
    key: 'updatePlQuery',
    value: function updatePlQuery(id) {
      var queries = this.state.queries;
      queries[9].id = 'pl-' + id;
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;
      var native = props.native;
      var gridListToggle = props.gridListToggle;
      var musicFolderChooser = props.musicFolderChooser;
      var queryItems = this.state.queries.map(function (m) {
        if (native) return _react2.default.createElement(
          'option',
          { key: m.id, value: m.id },
          m.name
        );
        return _react2.default.createElement(
          _MenuItem2.default,
          { key: m.id, value: m.id },
          m.name
        );
      });

      var value = props.albumQuery;
      var id3 = this.props.albumID3 || false;
      var label = 'ID3?';

      var plMode = value.startsWith('pl-');
      var plSelect = null;
      if (plMode) {
        var currentPlaylistId = value.substring(3);
        plSelect = _react2.default.createElement(
          _Grid2.default,
          { item: true, xs: 6, md: 3 },
          _react2.default.createElement(
            _FormControl2.default,
            { fullWidth: true },
            _react2.default.createElement(
              _InputLabel2.default,
              { htmlFor: 'pl-select' },
              'Playlist'
            ),
            _react2.default.createElement(_PlaylistsBrowser2.default, {
              native: props.native,
              subsonic: props,
              SubsonicSource: props.SubsonicSource,
              renderMode: _PlaylistsBrowser2.default.renderTypes.SELECT,
              selectedId: currentPlaylistId,
              onSelect: this.handlePlaylistChange,
              showThumbs: false
            })
          )
        );
      }

      var id3Selector = _react2.default.createElement(
        _Grid2.default,
        { item: true, xs: 2, md: 1 },
        _react2.default.createElement(_FormControlLabel2.default, {
          control: _react2.default.createElement(_Switch2.default, {
            label: label,
            value: 'id3',
            checked: id3,
            onChange: this.handleID3Change
          }),
          label: 'ID3'
        })
      );

      var albumQuerySelector = _react2.default.createElement(
        _Grid2.default,
        { item: true, xs: plMode ? 5 : 12, md: plMode ? 3 : 6 },
        _react2.default.createElement(
          _FormControl2.default,
          { fullWidth: true },
          _react2.default.createElement(
            _InputLabel2.default,
            { htmlFor: 'album-query-select' },
            'Sorted By...'
          ),
          _react2.default.createElement(
            _Select2.default,
            {
              native: props.native,
              value: value,
              onChange: this.handleChange,
              input: _react2.default.createElement(_Input2.default, { name: 'album-query', id: 'album-query-select' })
            },
            queryItems
          )
        )
      );

      var gridListToggleSection = _react2.default.createElement(
        _Grid2.default,
        { item: true, xs: 5, md: 2 },
        gridListToggle
      );

      var musicFolderChooserSection = _react2.default.createElement(
        _Grid2.default,
        { item: true, xs: 5, md: 3 },
        musicFolderChooser
      );

      var content = window.innerWidth >= 960 ? _react2.default.createElement(
        _Grid2.default,
        { container: true },
        musicFolderChooserSection,
        albumQuerySelector,
        plSelect,
        id3Selector,
        gridListToggleSection
      ) : _react2.default.createElement(
        _Grid2.default,
        { container: true },
        musicFolderChooserSection,
        id3Selector,
        gridListToggleSection,
        albumQuerySelector,
        plSelect
      );
      return content;
    }
  }]);

  return AlbumQueryChooser;
}(_react.Component);

exports.default = AlbumQueryChooser;
module.exports = exports.default;