'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _styles = require('@material-ui/core/styles');

var _ArtistActionButtons = require('./ArtistActionButtons');

var _ArtistActionButtons2 = _interopRequireDefault(_ArtistActionButtons);

var _SubsonicActions = require('../../actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

var _ScrollToTopFab = require('../styled/ScrollToTopFab');

var _ScrollToTopFab2 = _interopRequireDefault(_ScrollToTopFab);

var _SongList = require('./SongList');

var _SongList2 = _interopRequireDefault(_SongList);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = function styles(theme) {
  return {
    li: {
      listStyle: 'none'
    }
  };
};

var AlbumSongBrowser = function (_Component) {
  _inherits(AlbumSongBrowser, _Component);

  function AlbumSongBrowser() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, AlbumSongBrowser);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = AlbumSongBrowser.__proto__ || Object.getPrototypeOf(AlbumSongBrowser)).call.apply(_ref, [this].concat(args))), _this), _this.playItem = function (song) {
      console.warn('playItem', song);
      if (_this.props.remotes.remoteState === 'sender') {
        _this.props.history.push('/loading/song/' + song.id);
      } else {
        _SubsonicActions2.default.startPlaying(song, 0);
        _this.props.history.push('/player');
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }
  // constructor(props) {
  //   super(props);
  // }

  _createClass(AlbumSongBrowser, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          subsonic = _props.subsonic,
          SubsonicSource = _props.SubsonicSource,
          match = _props.match,
          showBackButton = _props.showBackButton,
          history = _props.history;

      var id = match.params.id;
      if (!subsonic || !subsonic.isConnected) {
        return _react2.default.createElement(
          _Typography2.default,
          null,
          'awaiting login...'
        );
      }

      if (!subsonic.albumsById[id]) {
        if (id === undefined || id === 'undefined') {
          return _react2.default.createElement(
            _Typography2.default,
            null,
            'problem 1'
          );
        }
        return _react2.default.createElement(_reactRouterDom.Redirect, { to: '/loading/albumID3/' + id });
      }

      var contents = subsonic.albumsById[id];
      if (!contents) {
        return _react2.default.createElement(
          _Typography2.default,
          null,
          'oops?'
        );
      }

      // render first one's cover art, then list the rest
      // const songSection = contents.song.map(item => (
      //   <ListItem
      //     key={`item-${item.id}`}
      //     classes={{ container: classes.li }}
      //     button
      //     onClick={this.playItem.bind(this, item)}
      //   >
      //     <ListItemIcon>
      //       <img src={SubsonicSource.getCoverArtURL(item.coverArt, 24)} />
      //     </ListItemIcon>
      //     <ListItemText primary={`${item.title}`} />
      //   </ListItem>
      // ));
      // console.log(id, contents.song[0].artistId);

      var songSection = _react2.default.createElement(_SongList2.default, {
        contents: contents.song,
        SubsonicSource: SubsonicSource,
        showMeta: false,
        handleSongClick: this.playItem
      });
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(_ArtistActionButtons2.default, {
          id: id,
          artistId: contents.song[0].artistId,
          loadbase: 'artistAction',
          SubsonicActions: _SubsonicActions2.default,
          isGrid: subsonic.albumsAsGrid,
          showBackButton: showBackButton,
          history: history
        }),
        songSection,
        _react2.default.createElement(_ScrollToTopFab2.default, this.props.fabProps)
      );
    }
  }]);

  return AlbumSongBrowser;
}(_react.Component);

exports.default = (0, _styles.withStyles)(styles)(AlbumSongBrowser);
module.exports = exports.default;