'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _icons = require('@material-ui/icons');

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _styles = require('@material-ui/core/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = function styles(theme) {
  return {
    buttonRow: {
      display: 'flex',
      width: '100%',
      justifyContent: 'space-around'
    },
    buttonCell: {
      textAlign: 'center'
    },
    button: {
      margin: theme.spacing(1)
    },
    rightIcon: {
      marginLeft: theme.spacing(1)
    }
  };
};

var ArtistActionButtons = function ArtistActionButtons(props) {
  var classes = props.classes,
      loadbase = props.loadbase,
      id = props.id,
      SubsonicActions = props.SubsonicActions,
      isGrid = props.isGrid,
      showBackButton = props.showBackButton,
      history = props.history;
  var artistId = props.artistId;

  var isAlbum = !!artistId;

  // console.log(id, artistId, isAlbum);

  if (!artistId) artistId = id;
  var top = '';
  var radio = '';
  var backButton = '';
  if (showBackButton && history) {
    backButton = _react2.default.createElement(
      'div',
      { className: classes.buttonCell },
      _react2.default.createElement(
        _Button2.default,
        { onClick: history.goBack },
        _react2.default.createElement(_icons.Reply, null)
      )
    );
  }

  if (loadbase !== 'directoryAction') {
    // music directory isn't fully in cache, so no name, so this doesn't work :()
    top = _react2.default.createElement(
      'div',
      { className: classes.buttonCell },
      _react2.default.createElement(
        _Button2.default,
        { component: _reactRouterDom.Link, to: '/loading/' + loadbase + '/' + artistId + '/top' },
        _react2.default.createElement(_icons.ThumbUp, null)
      )
    );
  }

  radio = _react2.default.createElement(
    'div',
    { className: classes.buttonCell },
    _react2.default.createElement(
      _Button2.default,
      { component: _reactRouterDom.Link, to: '/loading/' + loadbase + '/' + artistId + '/radio' },
      _react2.default.createElement(_icons.Radio, null)
    )
  );

  var GridListIcon = isGrid ? _icons.GridOn : _icons.ViewList;
  var gridListToggle = _react2.default.createElement(
    'div',
    { className: classes.buttonCell },
    _react2.default.createElement(
      _Button2.default,
      {
        variant: 'outlined',
        className: classes.button,
        onClick: SubsonicActions.toggleAlbumsAsGrid
      },
      'As ' + (isGrid ? 'Grid' : 'List'),
      _react2.default.createElement(GridListIcon, { className: classes.rightIcon })
    )
  );

  return _react2.default.createElement(
    'div',
    { className: classes.buttonRow },
    backButton,
    top,
    !isAlbum && _react2.default.createElement(
      _react2.default.Fragment,
      null,
      _react2.default.createElement(
        'div',
        { className: classes.buttonCell },
        _react2.default.createElement(
          _Button2.default,
          { component: _reactRouterDom.Link, to: '/loading/' + loadbase + '/' + id + '/all' },
          _react2.default.createElement(_icons.VideoLibrary, null)
        )
      ),
      _react2.default.createElement(
        'div',
        { className: classes.buttonCell },
        _react2.default.createElement(
          _Button2.default,
          { component: _reactRouterDom.Link, to: '/loading/' + loadbase + '/' + id + '/shuffle' },
          _react2.default.createElement(_icons.Shuffle, null)
        )
      ),
      _react2.default.createElement(
        'div',
        { className: classes.buttonCell },
        _react2.default.createElement(
          _Button2.default,
          {
            component: _reactRouterDom.Link,
            to: '/loading/' + loadbase + '/' + id + '/shuffleAlbums'
          },
          _react2.default.createElement(_icons.Album, null)
        )
      )
    ),
    isAlbum && _react2.default.createElement(
      _react2.default.Fragment,
      null,
      _react2.default.createElement(
        'div',
        { className: classes.buttonCell },
        _react2.default.createElement(
          _Button2.default,
          { component: _reactRouterDom.Link, to: '/loading/albumAction/' + id + '/play' },
          _react2.default.createElement(_icons.VideoLibrary, null)
        )
      ),
      _react2.default.createElement(
        'div',
        { className: classes.buttonCell },
        _react2.default.createElement(
          _Button2.default,
          { component: _reactRouterDom.Link, to: '/loading/albumAction/' + id + '/shuffle' },
          _react2.default.createElement(_icons.Shuffle, null)
        )
      )
    ),
    radio,
    gridListToggle
  );
};

exports.default = (0, _styles.withStyles)(styles)(ArtistActionButtons);
module.exports = exports.default;