'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _SubsonicActions = require('../../actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

var _GridList = require('@material-ui/core/GridList');

var _GridList2 = _interopRequireDefault(_GridList);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _List = require('@material-ui/core/List');

var _List2 = _interopRequireDefault(_List);

var _ListItem = require('@material-ui/core/ListItem');

var _ListItem2 = _interopRequireDefault(_ListItem);

var _ListItemIcon = require('@material-ui/core/ListItemIcon');

var _ListItemIcon2 = _interopRequireDefault(_ListItemIcon);

var _ListItemText = require('@material-ui/core/ListItemText');

var _ListItemText2 = _interopRequireDefault(_ListItemText);

var _ListItemSecondaryAction = require('@material-ui/core/ListItemSecondaryAction');

var _ListItemSecondaryAction2 = _interopRequireDefault(_ListItemSecondaryAction);

var _VideoLibrary = require('@material-ui/icons/VideoLibrary');

var _VideoLibrary2 = _interopRequireDefault(_VideoLibrary);

var _ArtistActionButtons = require('./ArtistActionButtons');

var _ArtistActionButtons2 = _interopRequireDefault(_ArtistActionButtons);

var _styles = require('@material-ui/core/styles');

var _CoverGridTile = require('../styled/CoverGridTile');

var _CoverGridTile2 = _interopRequireDefault(_CoverGridTile);

var _ScrollToTopFab = require('../styled/ScrollToTopFab');

var _ScrollToTopFab2 = _interopRequireDefault(_ScrollToTopFab);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = function styles(theme) {
  return {};
};

var ArtistAlbumsBrowser = function (_Component) {
  _inherits(ArtistAlbumsBrowser, _Component);

  function ArtistAlbumsBrowser(props) {
    _classCallCheck(this, ArtistAlbumsBrowser);

    var _this = _possibleConstructorReturn(this, (ArtistAlbumsBrowser.__proto__ || Object.getPrototypeOf(ArtistAlbumsBrowser)).call(this, props));

    _this.loadAlbumFolder = function (album) {
      _this.props.history.push('/loading/albumID3/' + album.id);
    };

    _this.updateDimensions = function () {
      _this.setState({ width: window.innerWidth, height: window.innerHeight });
    };

    _this.componentDidMount = function () {
      window.addEventListener('resize', _this.updateDimensions);
      _this.updateDimensions();
    };

    _this.componentWillUnmount = function () {
      window.removeEventListener('resize', _this.updateDimensions);
    };

    _this.myRef = _react2.default.createRef();
    return _this;
  }

  _createClass(ArtistAlbumsBrowser, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      // console.log(this.props);
      var _props = this.props,
          subsonic = _props.subsonic,
          SubsonicSource = _props.SubsonicSource,
          linkComponent = _props.linkComponent,
          match = _props.match,
          showBackButton = _props.showBackButton,
          history = _props.history;

      var id = match.params.id;

      if (!subsonic || !subsonic.artistAlbums) {
        return _react2.default.createElement(_reactRouterDom.Redirect, { to: '/loading/artist/' + id });
      }

      var isGrid = subsonic.albumsAsGrid;
      var albums = subsonic.artistAlbums.album || [];
      var innerWidth = window.innerWidth;
      if (this.myRef && this.myRef.current) {
        innerWidth = this.myRef.current.offsetWidth;
      }

      if (isNaN(innerWidth)) innerWidth = 360;
      var spacing = innerWidth > 360 ? 10 : 6;
      var cellSize = innerWidth > 360 ? 170 : 164;

      var cols = innerWidth / (cellSize + spacing);
      var width = cols * (cellSize + spacing);

      var content = isGrid ? _react2.default.createElement(
        'div',
        { ref: this.myRef },
        _react2.default.createElement(
          _GridList2.default,
          {
            cellHeight: cellSize,
            width: width,
            cols: cols,
            spacing: spacing
          },
          albums.map(function (n, idx) {
            return _react2.default.createElement(_CoverGridTile2.default, {
              onClick: _this2.loadAlbumFolder.bind(_this2, n),
              key: 'alb' + n.id,
              subname: n.artist,
              name: n.title || n.name,
              normal: true,
              size: 160,
              coverArt: n.coverArt,
              linkComponent: linkComponent,
              id: n.id,
              SubsonicSource: SubsonicSource
            });
          })
        )
      ) : _react2.default.createElement(
        _List2.default,
        null,
        albums.map(function (item) {
          return _react2.default.createElement(
            _ListItem2.default,
            {
              key: 'alb' + item.id,
              button: true,
              component: _reactRouterDom.Link,
              to: '/loading/albumID3/' + item.id
            },
            _react2.default.createElement(
              _ListItemIcon2.default,
              null,
              _react2.default.createElement('img', {
                alt: '',
                width: 48,
                height: 48,
                src: SubsonicSource.getCoverArtURL(item.coverArt, 48)
              })
            ),
            _react2.default.createElement(_ListItemText2.default, {
              primary: item.title || item.album || item.name,
              secondary: item.artist
            }),
            _react2.default.createElement(
              _ListItemSecondaryAction2.default,
              null,
              _react2.default.createElement(
                _IconButton2.default,
                {
                  'aria-label': 'Play',
                  component: _reactRouterDom.Link,
                  to: '/loading/albumAction/' + item.id + '/play'
                },
                _react2.default.createElement(_VideoLibrary2.default, null)
              )
            )
          );
        })
      );

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(_ArtistActionButtons2.default, {
          id: id,
          loadbase: 'artistAction',
          SubsonicActions: _SubsonicActions2.default,
          isGrid: subsonic.albumsAsGrid,
          showBackButton: showBackButton,
          history: history
        }),
        content,
        _react2.default.createElement(_ScrollToTopFab2.default, this.props.fabProps)
      );
    }
  }]);

  return ArtistAlbumsBrowser;
}(_react.Component);

exports.default = (0, _styles.withStyles)(styles)(ArtistAlbumsBrowser);
module.exports = exports.default;