'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _MusicFolderChooser = require('./MusicFolderChooser');

var _MusicFolderChooser2 = _interopRequireDefault(_MusicFolderChooser);

var _MediaButtons = require('../controls/MediaButtons');

var _Avatar = require('@material-ui/core/Avatar');

var _Avatar2 = _interopRequireDefault(_Avatar);

var _Grid = require('@material-ui/core/Grid');

var _Grid2 = _interopRequireDefault(_Grid);

var _List = require('@material-ui/core/List');

var _List2 = _interopRequireDefault(_List);

var _ListSubheader = require('@material-ui/core/ListSubheader');

var _ListSubheader2 = _interopRequireDefault(_ListSubheader);

var _ListItem = require('@material-ui/core/ListItem');

var _ListItem2 = _interopRequireDefault(_ListItem);

var _ListItemText = require('@material-ui/core/ListItemText');

var _ListItemText2 = _interopRequireDefault(_ListItemText);

var _ListItemSecondaryAction = require('@material-ui/core/ListItemSecondaryAction');

var _ListItemSecondaryAction2 = _interopRequireDefault(_ListItemSecondaryAction);

var _styles = require('@material-ui/core/styles');

var _VideoLibrary = require('@material-ui/icons/VideoLibrary');

var _VideoLibrary2 = _interopRequireDefault(_VideoLibrary);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _ScrollToTopFab = require('../styled/ScrollToTopFab');

var _ScrollToTopFab2 = _interopRequireDefault(_ScrollToTopFab);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = function styles(theme) {
  return {
    listRoot: {
      width: '100%',
      overflow: 'auto',
      display: 'inline-block'
    },
    subheader: {
      backgroundColor: theme.palette.background.paper
    },
    li: {
      listStyle: 'none'
    },
    listSection: {
      backgroundColor: 'inherit'
    },
    ul: {
      backgroundColor: 'inherit',
      padding: 0
    },
    avatar: {
      margin: 5
    },
    bigAvatar: {
      width: 40,
      height: 40
    }
  };
};

var ArtistBrowser = function (_Component) {
  _inherits(ArtistBrowser, _Component);

  function ArtistBrowser(props) {
    _classCallCheck(this, ArtistBrowser);

    var _this = _possibleConstructorReturn(this, (ArtistBrowser.__proto__ || Object.getPrototypeOf(ArtistBrowser)).call(this, props));

    _this.scrollToTop = function () {
      document.querySelector('.artistList').scrollTop = 0;
    };

    _this.shuffleClick = function () {
      var id = _this.props.subsonic.musicFolder || '-1';
      _this.props.history.push('/loading/folderShuffle/' + id);
    };

    _this.playArtist = function (artist) {
      _this.props.history.push('/loading/artistAction/' + artist.id + '/all');
    };

    _this.setCurrentIndex = function (idx) {
      _this.setState({
        currentIndex: idx
      });
    };

    _this.state = {
      currentIndex: null,
      showAll: true
    };
    return _this;
  }

  _createClass(ArtistBrowser, [{
    key: 'componentDidMount',
    value: function componentDidMount() {}
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          subsonic = _props.subsonic,
          SubsonicSource = _props.SubsonicSource,
          classes = _props.classes;
      var _state = this.state,
          artistIndexes = _state.artistIndexes,
          showAll = _state.showAll,
          currentIndex = _state.currentIndex;

      // TODO: fix that ul/li below

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _Grid2.default,
          { container: true },
          _react2.default.createElement(
            _Grid2.default,
            { item: true, xs: 10 },
            _react2.default.createElement(_MusicFolderChooser2.default, subsonic)
          ),
          _react2.default.createElement(
            _Grid2.default,
            { item: true, xs: 2 },
            _react2.default.createElement(_MediaButtons.ShuffleButton, { shuffleClick: this.shuffleClick })
          )
        ),
        _react2.default.createElement(
          _List2.default,
          {
            className: (0, _classnames2.default)(classes.listRoot, 'artistList'),
            subheader: _react2.default.createElement('li', null)
          },
          artistIndexes.map(function (index) {
            return _react2.default.createElement(
              'li',
              { key: 'section-' + index.name, className: classes.listSection },
              _react2.default.createElement(
                'ul',
                {
                  className: classes.ul,
                  onClick: !showAll ? _this2.setCurrentIndex.bind(_this2, index.name) : null
                },
                _react2.default.createElement(
                  _ListSubheader2.default,
                  { className: classes.subheader },
                  'Artists: ' + index.name
                ),
                (showAll || index.name === currentIndex ? index.artist : []).map(function (item) {
                  return _react2.default.createElement(
                    _ListItem2.default,
                    {
                      classes: { container: classes.li },
                      key: 'item-' + index.name + '-' + item.id,
                      button: true,
                      component: _reactRouterDom.Link,
                      to: '/loading/artist/' + item.id
                    },
                    _react2.default.createElement(_Avatar2.default, {
                      alt: '' + item.name,
                      src: SubsonicSource.getCoverArtURL(item.coverArt, 40),
                      className: (0, _classnames2.default)(classes.avatar, classes.bigAvatar)
                    }),
                    _react2.default.createElement(_ListItemText2.default, {
                      primary: '' + item.name,
                      className: classes.listItemText
                    }),
                    _react2.default.createElement(
                      _ListItemSecondaryAction2.default,
                      null,
                      _react2.default.createElement(
                        _IconButton2.default,
                        {
                          'aria-label': 'Play',
                          onClick: _this2.playArtist.bind(_this2, item)
                        },
                        _react2.default.createElement(_VideoLibrary2.default, null)
                      )
                    )
                  );
                })
              )
            );
          })
        ),
        _react2.default.createElement(_ScrollToTopFab2.default, _extends({
          scrollToTop: this.scrollToTop
        }, this.props.fabProps))
      );
    }
  }]);

  return ArtistBrowser;
}(_react.Component);

ArtistBrowser.getDerivedStateFromProps = function (nextProps, lastState) {
  var subsonic = nextProps.subsonic;
  var artistIndexes = subsonic.artistIndexes,
      artists = subsonic.artists,
      musicFolder = subsonic.musicFolder;

  artistIndexes = artistIndexes || [];
  artists = artists || [];
  if (!Array.isArray(artistIndexes)) artistIndexes = [artistIndexes];
  if (!Array.isArray(artists)) artists = [artists];
  // console.log('artists', artists.length);

  if (artists.length < 20) {
    artistIndexes = [{
      artist: artists,
      name: 'All'
    }];
  }

  var showAll = artists.length < 201;
  var currentIndex = showAll ? null : musicFolder === lastState.musicFolder && lastState.currentIndex ? lastState.currentIndex : artistIndexes[0].name;

  return {
    artistIndexes: artistIndexes,
    artists: artists,
    showAll: showAll,
    currentIndex: currentIndex,
    musicFolder: musicFolder
  };
};

exports.default = (0, _styles.withStyles)(styles)(ArtistBrowser);
module.exports = exports.default;