'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('@material-ui/core/styles');

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _Table = require('@material-ui/core/Table');

var _Table2 = _interopRequireDefault(_Table);

var _TableBody = require('@material-ui/core/TableBody');

var _TableBody2 = _interopRequireDefault(_TableBody);

var _TableCell = require('@material-ui/core/TableCell');

var _TableCell2 = _interopRequireDefault(_TableCell);

var _TableHead = require('@material-ui/core/TableHead');

var _TableHead2 = _interopRequireDefault(_TableHead);

var _TableRow = require('@material-ui/core/TableRow');

var _TableRow2 = _interopRequireDefault(_TableRow);

var _Paper = require('@material-ui/core/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _Hidden = require('@material-ui/core/Hidden');

var _Hidden2 = _interopRequireDefault(_Hidden);

var _DeleteForever = require('@material-ui/icons/DeleteForever');

var _DeleteForever2 = _interopRequireDefault(_DeleteForever);

var _SubsonicLoader = require('../SubsonicLoader');

var _SubsonicLoader2 = _interopRequireDefault(_SubsonicLoader);

var _SubsonicActions = require('../../actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = function styles(theme) {
  return {
    root: {
      width: '100%',
      marginTop: theme.spacing(3),
      overflowX: 'auto'
    },
    table: {
      minWidth: 360
    },
    unsetButton: {
      fontWeight: 'inherit',
      fontSize: 'inherit',
      textTransform: 'inherit',
      letterSpacing: 'inherit',
      lineHeight: 'inherit',
      padding: 0
    }
  };
};

var BookmarksBrowser = function (_Component) {
  _inherits(BookmarksBrowser, _Component);

  _createClass(BookmarksBrowser, null, [{
    key: 'parseContext',
    value: function parseContext(comment, subsonic, SubsonicSource) {
      // console.warn(comment);
      comment = comment || '';
      try {
        comment = comment.replace(/&quot;/g, '"'); //ampache hack
        // console.warn(comment);
        var data = JSON.parse(comment);
        if (data.bookmarkSource !== 'SubFire') {
          // console.warn(data);
          return {
            contextObject: null,
            contextData: null,
            contextString: 'Not a SubFire Bookmark'
          };
        }
        var object = _SubsonicLoader2.default.findObject(data.type, data.id, data.mode, subsonic, SubsonicSource);
        // console.log(data, object);
        return {
          contextObject: object,
          contextData: data,
          contextString: object ? (data.type ? data.type.toUpperCase() + ' ' : '') + (object.name || object.title || object.album) : data.type ? data.type.toUpperCase() + ' ' + data.id : ''
        };
      } catch (e) {
        return {
          contextObject: null,
          contextData: null,
          contextString: comment.indexOf('DSub') >= 0 ? comment : 'Not a SubFire Bookmark'
        };
      }
    }
  }, {
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(props, prevState) {
      // if (prevState && prevState.bookmarks === props.subsonic.bookmarks)
      //   return prevState;
      var bookmarks = props.subsonic.bookmarks;
      // bookmarks = array of
      //  comment = JSON of type, id, source, potentially mode (albums)
      //  position
      //  entry:
      //    id, album, artist, coverArt, title
      // create the table structure here
      var tableData = bookmarks.map(function (b, i, a) {
        // console.log("tableData", b);
        var bookmarkDate = new Date(Date.parse(b.created));
        var context = BookmarksBrowser.parseContext(b.comment || '', props.subsonic, props.SubsonicSource);
        var e = Object.assign({}, b.entry, { position: b.position }, {
          contextData: context.contextData,
          contextObject: context.contextObject,
          contextString: context.contextString,
          bookmarkDate: bookmarkDate
        });
        return e;
      }, []);
      return {
        bookmarks: bookmarks,
        tableData: tableData
      };
    }
  }]);

  function BookmarksBrowser(props) {
    _classCallCheck(this, BookmarksBrowser);

    var _this = _possibleConstructorReturn(this, (BookmarksBrowser.__proto__ || Object.getPrototypeOf(BookmarksBrowser)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(BookmarksBrowser, [{
    key: 'handleRowClick',
    value: function handleRowClick(evt, bookmark) {
      // console.log('bookmark clicked', bookmark);
      var d = bookmark.contextData;
      var path = void 0;
      if (d) {
        // fix the old album since album now goes to directory browser
        if (d.type === 'album') {
          d.type = 'directoryAction';
          d.mode = 'all';
        }
        path = '/bookmark/' + bookmark.id + '/' + bookmark.position + '/loading/' + d.type + '/' + d.id;
        if (d.mode) path += '/' + d.mode;
      } else {
        // non-subfire bookmarks
        path = '/bookmark/' + bookmark.id + '/' + bookmark.position + '/loading/' + 'song/' + bookmark.id;
      }
      // console.log('path', path, this.props.route);
      var history = this.props.history;
      // hack for HashRouter
      // window.bookmarkState = bookmark;

      history.push(path, bookmark);
    }
  }, {
    key: 'handleDeleteClick',
    value: function handleDeleteClick(evt, bookmark) {
      var d = bookmark;
      if (d) {
        _SubsonicActions2.default.deleteBookmark(d.id);
      }
      evt.stopPropagation();
      return false;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      // console.log("render bookmarks", this.props, this.state);
      var _props = this.props,
          classes = _props.classes,
          SubsonicSource = _props.SubsonicSource,
          remotes = _props.remotes,
          props = _objectWithoutProperties(_props, ['classes', 'SubsonicSource', 'remotes']);

      // yes, letting a little of subfire bleed in. not much i can do about it...


      var warning = null;
      // if (remotes.remoteState === 'sender') warning = (<Typography>Note: currently, bookmark loading does not work correctly over remote casting.</Typography>);
      var nobookmarks = null;
      if (this.state.tableData.length === 0) {
        nobookmarks = _react2.default.createElement(
          _Typography2.default,
          { variant: 'h4' },
          'No Bookmarks have been stored.'
        );
      }

      return _react2.default.createElement(
        _Paper2.default,
        { className: classes.root },
        warning,
        _react2.default.createElement(
          _Table2.default,
          { className: classes.table },
          _react2.default.createElement(
            _TableHead2.default,
            null,
            _react2.default.createElement(
              _TableRow2.default,
              null,
              _react2.default.createElement(_TableCell2.default, { className: props.cellClasses, size: 'small' }),
              _react2.default.createElement(
                _TableCell2.default,
                { className: props.cellClasses, size: 'small' },
                'Title'
              ),
              _react2.default.createElement(
                _TableCell2.default,
                { className: props.cellClasses, size: 'small' },
                'Context'
              ),
              _react2.default.createElement(
                _Hidden2.default,
                { xsDown: true },
                _react2.default.createElement(
                  _TableCell2.default,
                  { className: props.cellClasses, size: 'small' },
                  'Bookmarked'
                )
              ),
              _react2.default.createElement(
                _TableCell2.default,
                { className: props.cellClasses, size: 'small' },
                'Delete'
              )
            )
          ),
          _react2.default.createElement(
            _TableBody2.default,
            null,
            this.state.tableData.map(function (n) {
              return _react2.default.createElement(
                _TableRow2.default,
                {
                  key: n.id,
                  onClick: function onClick(event) {
                    return _this2.handleRowClick(event, n);
                  }
                },
                _react2.default.createElement(
                  _TableCell2.default,
                  { className: props.cellClasses, size: 'small' },
                  _react2.default.createElement('img', {
                    style: { width: 40, height: 'auto' },
                    alt: '',
                    src: SubsonicSource.getCoverArtURL(n.coverArt, 40)
                  })
                ),
                _react2.default.createElement(
                  _TableCell2.default,
                  { className: props.cellClasses, size: 'small' },
                  _react2.default.createElement(
                    _Button2.default,
                    {
                      className: classes.unsetButton,
                      onClick: function onClick(event) {
                        return _this2.handleRowClick(event, n);
                      }
                    },
                    n.title.substring(0, 100)
                  )
                ),
                _react2.default.createElement(
                  _TableCell2.default,
                  { className: props.cellClasses, size: 'small' },
                  n.contextString
                ),
                _react2.default.createElement(
                  _Hidden2.default,
                  { xsDown: true },
                  _react2.default.createElement(
                    _TableCell2.default,
                    { className: props.cellClasses, size: 'small' },
                    n.bookmarkDate.toLocaleString()
                  )
                ),
                _react2.default.createElement(
                  _TableCell2.default,
                  { className: props.cellClasses, size: 'small' },
                  _react2.default.createElement(
                    _IconButton2.default,
                    {
                      onClick: function onClick(event) {
                        return _this2.handleDeleteClick(event, n);
                      }
                    },
                    _react2.default.createElement(_DeleteForever2.default, null)
                  )
                )
              );
            })
          )
        ),
        nobookmarks
      );
    }
  }]);

  return BookmarksBrowser;
}(_react.Component);

exports.default = (0, _styles.withStyles)(styles)(BookmarksBrowser);
module.exports = exports.default;