'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _GridList = require('@material-ui/core/GridList');

var _GridList2 = _interopRequireDefault(_GridList);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _List = require('@material-ui/core/List');

var _List2 = _interopRequireDefault(_List);

var _ListItem = require('@material-ui/core/ListItem');

var _ListItem2 = _interopRequireDefault(_ListItem);

var _ListItemIcon = require('@material-ui/core/ListItemIcon');

var _ListItemIcon2 = _interopRequireDefault(_ListItemIcon);

var _ListItemText = require('@material-ui/core/ListItemText');

var _ListItemText2 = _interopRequireDefault(_ListItemText);

var _ListItemSecondaryAction = require('@material-ui/core/ListItemSecondaryAction');

var _ListItemSecondaryAction2 = _interopRequireDefault(_ListItemSecondaryAction);

var _FolderOpen = require('@material-ui/icons/FolderOpen');

var _FolderOpen2 = _interopRequireDefault(_FolderOpen);

var _styles = require('@material-ui/core/styles');

var _VideoLibrary = require('@material-ui/icons/VideoLibrary');

var _VideoLibrary2 = _interopRequireDefault(_VideoLibrary);

var _ArtistActionButtons = require('./ArtistActionButtons');

var _ArtistActionButtons2 = _interopRequireDefault(_ArtistActionButtons);

var _SubsonicActions = require('../../actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

var _CoverGridTile = require('../styled/CoverGridTile');

var _CoverGridTile2 = _interopRequireDefault(_CoverGridTile);

var _ScrollToTopFab = require('../styled/ScrollToTopFab');

var _ScrollToTopFab2 = _interopRequireDefault(_ScrollToTopFab);

var _SongList = require('./SongList');

var _SongList2 = _interopRequireDefault(_SongList);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = function styles(theme) {
  return {
    li: {
      listStyle: 'none'
    }
  };
};

var DirectoryBrowser = function (_Component) {
  _inherits(DirectoryBrowser, _Component);

  function DirectoryBrowser(props) {
    _classCallCheck(this, DirectoryBrowser);

    var _this = _possibleConstructorReturn(this, (DirectoryBrowser.__proto__ || Object.getPrototypeOf(DirectoryBrowser)).call(this, props));

    _this.playItem = function (song) {
      if (_this.props.remotes.remoteState === 'sender') {
        _this.props.history.push('/loading/song/' + song.id);
      } else {
        _SubsonicActions2.default.startPlaying(song, 0);
        _this.props.history.push('/player');
      }
    };

    _this.loadAlbumFolder = function (album) {
      _this.props.history.push('/loading/directory/' + album.id);
    };

    _this.playFolder = function (album) {
      _this.props.history.push('/loading/directoryAction/' + album.id + '/all');
    };

    _this.updateDimensions = function () {
      _this.setState({ width: window.innerWidth, height: window.innerHeight });
    };

    _this.componentDidMount = function () {
      window.addEventListener('resize', _this.updateDimensions);
      _this.updateDimensions();
    };

    _this.componentWillUnmount = function () {
      window.removeEventListener('resize', _this.updateDimensions);
    };

    _this.myRef = _react2.default.createRef();
    return _this;
  }

  _createClass(DirectoryBrowser, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          subsonic = _props.subsonic,
          SubsonicSource = _props.SubsonicSource,
          match = _props.match,
          classes = _props.classes,
          showBackButton = _props.showBackButton,
          history = _props.history;

      var isGrid = subsonic.albumsAsGrid;
      var paramsId = match.params.id;
      if (!subsonic || !subsonic.isConnected) {
        return _react2.default.createElement(
          _Typography2.default,
          null,
          'awaiting login...'
        );
      }

      if (!subsonic.musicDirectory) {
        if (paramsId === undefined || paramsId === 'undefined') {
          return _react2.default.createElement(
            _Typography2.default,
            null,
            'problem 1'
          );
        }
        return _react2.default.createElement(_reactRouterDom.Redirect, { to: '/loading/directory/' + paramsId });
      }

      var id = subsonic.musicDirectory.id;

      if (paramsId === undefined || paramsId === 'undefined') {
        return _react2.default.createElement(
          _Typography2.default,
          null,
          'problem 1'
        );
      }
      if ('' + paramsId !== '' + id) {
        return _react2.default.createElement(_reactRouterDom.Redirect, { to: '/loading/directory/' + paramsId });
      }
      var contents = subsonic.musicDirectoryContents;
      if (!contents) {
        return _react2.default.createElement(
          _Typography2.default,
          null,
          'oops?'
        );
      }
      var sortedContentsInit = {
        folders: [],
        albums: [],
        songs: []
      };
      var sortedContents = contents.reduce(function (sortedContents, v, i, array) {
        if (v.isDir && v.coverArt) sortedContents.albums.push(v);else if (v.isDir) sortedContents.folders.push(v);else sortedContents.songs.push(v);
        return sortedContents;
      }, sortedContentsInit);
      // console.log(sortedContents);

      // add folder icon
      var folderSection = sortedContents.folders.map(function (item) {
        return _react2.default.createElement(
          _ListItem2.default,
          {
            classes: { container: classes.li },
            key: 'item-' + item.id,
            button: true,
            component: _reactRouterDom.Link,
            to: '/loading/directory/' + item.id
          },
          _react2.default.createElement(
            _ListItemIcon2.default,
            null,
            _react2.default.createElement(_FolderOpen2.default, null)
          ),
          _react2.default.createElement(_ListItemText2.default, { primary: '' + item.title }),
          _react2.default.createElement(
            _ListItemSecondaryAction2.default,
            null,
            _react2.default.createElement(
              _IconButton2.default,
              {
                'aria-label': 'Play',
                onClick: _this2.playFolder.bind(_this2, item)
              },
              _react2.default.createElement(_VideoLibrary2.default, null)
            )
          )
        );
      });

      // convert to grid
      var innerWidth = window.innerWidth;
      if (this.myRef && this.myRef.current) {
        innerWidth = this.myRef.current.offsetWidth;
      }

      if (isNaN(innerWidth)) innerWidth = 360;
      var spacing = innerWidth > 360 ? 10 : 6;
      var cellSize = innerWidth > 360 ? 170 : 164;

      var cols = innerWidth / (cellSize + spacing);
      var width = cols * (cellSize + spacing);

      var PlayLink = _react2.default.forwardRef(function (props, ref) {
        var link = '/loading/directoryAction/' + props.id + '/all';
        return _react2.default.createElement(
          _reactRouterDom.Link,
          { innerRef: ref, to: link },
          props.children
        );
      });

      var albumSection = isGrid ? _react2.default.createElement(
        'div',
        { ref: this.myRef },
        _react2.default.createElement(
          _GridList2.default,
          {
            cellHeight: cellSize,
            width: width,
            cols: cols,
            spacing: spacing
          },
          sortedContents.albums.map(function (item, idx) {
            return _react2.default.createElement(_CoverGridTile2.default, {
              onClick: _this2.loadAlbumFolder.bind(_this2, item),
              key: 'alb' + item.id,
              subname: item.artist,
              name: item.title || item.album || item.name,
              normal: true,
              size: 160,
              coverArt: item.coverArt,
              linkComponent: PlayLink,
              id: item.id,
              SubsonicSource: SubsonicSource
            });
          })
        )
      ) : _react2.default.createElement(
        _List2.default,
        null,
        sortedContents.albums.map(function (item) {
          return _react2.default.createElement(
            _ListItem2.default,
            {
              key: 'alb' + item.id,
              button: true,
              component: _reactRouterDom.Link,
              to: '/loading/directory/' + item.id
            },
            _react2.default.createElement(
              _ListItemIcon2.default,
              null,
              _react2.default.createElement('img', {
                width: 48,
                height: 48,
                alt: '',
                src: SubsonicSource.getCoverArtURL(item.coverArt, 48)
              })
            ),
            _react2.default.createElement(_ListItemText2.default, {
              primary: item.title || item.album || item.name,
              secondary: item.artist
            }),
            _react2.default.createElement(
              _ListItemSecondaryAction2.default,
              null,
              _react2.default.createElement(
                _IconButton2.default,
                {
                  'aria-label': 'Play',
                  onClick: _this2.playFolder.bind(_this2, item)
                },
                _react2.default.createElement(_VideoLibrary2.default, null)
              )
            )
          );
        })
      );

      // render first one's cover art, then list the rest
      // const songSection = sortedContents.songs.map(item => (
      //   <ListItem
      //     key={`item-${item.id}`}
      //     button
      //     onClick={this.playItem.bind(this, item)}
      //   >
      //     <ListItemIcon>
      //       <img src={SubsonicSource.getCoverArtURL(item.coverArt, 24)} />
      //     </ListItemIcon>
      //     <ListItemText primary={`${item.title}`} />
      //   </ListItem>
      // ));

      var songSection = _react2.default.createElement(_SongList2.default, {
        contents: sortedContents.songs,
        SubsonicSource: SubsonicSource,
        showMeta: false,
        handleSongClick: this.playItem
      });

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(_ArtistActionButtons2.default, {
          id: id,
          loadbase: 'directoryAction',
          SubsonicActions: _SubsonicActions2.default,
          isGrid: subsonic.albumsAsGrid,
          showBackButton: showBackButton,
          history: history
        }),
        _react2.default.createElement(
          _List2.default,
          null,
          folderSection
        ),
        albumSection,
        songSection,
        _react2.default.createElement(_ScrollToTopFab2.default, this.props.fabProps)
      );
    }
  }]);

  return DirectoryBrowser;
}(_react.Component);

exports.default = (0, _styles.withStyles)(styles)(DirectoryBrowser);
module.exports = exports.default;