'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _MusicFolderChooser = require('./MusicFolderChooser');

var _MusicFolderChooser2 = _interopRequireDefault(_MusicFolderChooser);

var _MediaButtons = require('../controls/MediaButtons');

var _Grid = require('@material-ui/core/Grid');

var _Grid2 = _interopRequireDefault(_Grid);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _List = require('@material-ui/core/List');

var _List2 = _interopRequireDefault(_List);

var _ListSubheader = require('@material-ui/core/ListSubheader');

var _ListSubheader2 = _interopRequireDefault(_ListSubheader);

var _ListItem = require('@material-ui/core/ListItem');

var _ListItem2 = _interopRequireDefault(_ListItem);

var _ListItemIcon = require('@material-ui/core/ListItemIcon');

var _ListItemIcon2 = _interopRequireDefault(_ListItemIcon);

var _ListItemText = require('@material-ui/core/ListItemText');

var _ListItemText2 = _interopRequireDefault(_ListItemText);

var _styles = require('@material-ui/core/styles');

var _ListItemSecondaryAction = require('@material-ui/core/ListItemSecondaryAction');

var _ListItemSecondaryAction2 = _interopRequireDefault(_ListItemSecondaryAction);

var _FolderOpen = require('@material-ui/icons/FolderOpen');

var _FolderOpen2 = _interopRequireDefault(_FolderOpen);

var _VideoLibrary = require('@material-ui/icons/VideoLibrary');

var _VideoLibrary2 = _interopRequireDefault(_VideoLibrary);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _ScrollToTopFab = require('../styled/ScrollToTopFab');

var _ScrollToTopFab2 = _interopRequireDefault(_ScrollToTopFab);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = function styles(theme) {
  return {
    listRoot: {
      width: '100%',
      overflow: 'auto',
      display: 'inline-block'
    },
    subheader: {
      backgroundColor: theme.palette.background.paper
    },
    subhidden: {
      display: 'none'
    },
    listSection: {
      backgroundColor: 'inherit'
    },
    li: {
      listStyle: 'none'
    },
    ul: {
      backgroundColor: 'inherit',
      padding: 0
    },
    avatar: {
      margin: 5
    },
    bigAvatar: {
      width: 40,
      height: 40
    }
  };
};

var IndexBrowser = function (_Component) {
  _inherits(IndexBrowser, _Component);

  function IndexBrowser(props) {
    _classCallCheck(this, IndexBrowser);

    var _this = _possibleConstructorReturn(this, (IndexBrowser.__proto__ || Object.getPrototypeOf(IndexBrowser)).call(this, props));

    _this.scrollToTop = function () {
      document.querySelector('.indexList').scrollTop = 0;
    };

    _this.shuffleClick = function () {
      var id = _this.props.subsonic.musicFolder || '-1';
      _this.props.history.push('/loading/folderShuffle/' + id);
    };

    _this.playFolder = function (album) {
      _this.props.history.push('/loading/directoryAction/' + album.id + '/all');
    };

    _this.setCurrentIndex = function (idx) {
      _this.setState({
        currentIndex: idx
      });
    };

    _this.state = {
      currentIndex: null,
      showAll: true,
      musicDirectoryIndexes: []
    };
    return _this;
  }

  _createClass(IndexBrowser, [{
    key: 'componentDidMount',
    value: function componentDidMount() {}
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          subsonic = _props.subsonic,
          classes = _props.classes;
      var _state = this.state,
          musicDirectoryIndexes = _state.musicDirectoryIndexes,
          showAll = _state.showAll,
          currentIndex = _state.currentIndex;


      if (!musicDirectoryIndexes || musicDirectoryIndexes.length === 0) {
        return _react2.default.createElement(
          'span',
          null,
          'loading...'
        );
      }
      var subhidden = {};
      subhidden[classes.subhidden] = musicDirectoryIndexes.length < 10;
      var subheaderClasses = (0, _classnames2.default)(classes.subheader, subhidden);

      /*
      index musicDirectory doesn't have cover art
      <Avatar
      alt={`${item.name}`}
      src={SubsonicSource.getCoverArtURL(item.coverArt, 40)}
      className={classNames(
      classes.avatar,
      classes.bigAvatar
      )}
      />
      */
      return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        _react2.default.createElement(
          _Grid2.default,
          { container: true },
          _react2.default.createElement(
            _Grid2.default,
            { item: true, xs: 10 },
            _react2.default.createElement(_MusicFolderChooser2.default, subsonic)
          ),
          _react2.default.createElement(
            _Grid2.default,
            { item: true, xs: 2 },
            _react2.default.createElement(_MediaButtons.ShuffleButton, { shuffleClick: this.shuffleClick })
          )
        ),
        _react2.default.createElement(
          _List2.default,
          {
            className: (0, _classnames2.default)(classes.listRoot, 'indexList'),
            subheader: _react2.default.createElement('li', null)
          },
          musicDirectoryIndexes.map(function (index) {
            return _react2.default.createElement(
              'li',
              { key: 'section-' + index.name, className: classes.listSection },
              _react2.default.createElement(
                'ul',
                {
                  className: classes.ul,
                  onClick: !showAll ? _this2.setCurrentIndex.bind(_this2, index.name) : null
                },
                _react2.default.createElement(
                  _ListSubheader2.default,
                  { className: subheaderClasses },
                  'Index: ' + index.name
                ),
                (showAll || index.name === currentIndex ? index.artist || [] : []).map(function (item) {
                  return _react2.default.createElement(
                    _ListItem2.default,
                    {
                      classes: { container: classes.li },
                      key: 'item-' + index.name + '-' + item.id,
                      button: true,
                      component: _reactRouterDom.Link,
                      to: '/loading/directory/' + item.id
                    },
                    _react2.default.createElement(
                      _ListItemIcon2.default,
                      null,
                      _react2.default.createElement(_FolderOpen2.default, null)
                    ),
                    _react2.default.createElement(_ListItemText2.default, { primary: '' + item.name }),
                    _react2.default.createElement(
                      _ListItemSecondaryAction2.default,
                      null,
                      _react2.default.createElement(
                        _IconButton2.default,
                        {
                          'aria-label': 'Play',
                          onClick: _this2.playFolder.bind(_this2, item)
                        },
                        _react2.default.createElement(_VideoLibrary2.default, null)
                      )
                    )
                  );
                })
              )
            );
          })
        ),
        _react2.default.createElement(_ScrollToTopFab2.default, _extends({}, this.props.fabProps, {
          scrollToTop: this.scrollToTop
        }))
      );
    }
  }]);

  return IndexBrowser;
}(_react.Component);

IndexBrowser.getDerivedStateFromProps = function (nextProps, lastState) {
  var subsonic = nextProps.subsonic;
  var musicDirectoryIndexes = subsonic.musicDirectoryIndexes,
      musicDirectories = subsonic.musicDirectories,
      musicFolder = subsonic.musicFolder;

  musicDirectoryIndexes = musicDirectoryIndexes || [];
  musicDirectories = musicDirectories || [];
  if (!Array.isArray(musicDirectoryIndexes)) musicDirectoryIndexes = [musicDirectoryIndexes];
  if (!Array.isArray(musicDirectories)) musicDirectories = [musicDirectories];
  // console.log('musicDirectories', musicDirectories.length);

  if (musicDirectories.length < 20) {
    musicDirectoryIndexes = [{
      artist: musicDirectories,
      name: 'All'
    }];
  }

  var showAll = musicDirectories.length < 201;
  var currentIndex = showAll ? null : musicFolder === lastState.musicFolder && lastState.currentIndex ? lastState.currentIndex : musicDirectoryIndexes[0].name;

  return {
    musicDirectoryIndexes: musicDirectoryIndexes,
    musicDirectories: musicDirectories,
    showAll: showAll,
    currentIndex: currentIndex,
    musicFolder: musicFolder
  };
};

exports.default = (0, _styles.withStyles)(styles)(IndexBrowser);
module.exports = exports.default;