'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('@material-ui/core/styles');

var _Table = require('@material-ui/core/Table');

var _Table2 = _interopRequireDefault(_Table);

var _TableBody = require('@material-ui/core/TableBody');

var _TableBody2 = _interopRequireDefault(_TableBody);

var _TableCell = require('@material-ui/core/TableCell');

var _TableCell2 = _interopRequireDefault(_TableCell);

var _TableHead = require('@material-ui/core/TableHead');

var _TableHead2 = _interopRequireDefault(_TableHead);

var _TableRow = require('@material-ui/core/TableRow');

var _TableRow2 = _interopRequireDefault(_TableRow);

var _Paper = require('@material-ui/core/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _Hidden = require('@material-ui/core/Hidden');

var _Hidden2 = _interopRequireDefault(_Hidden);

var _SubsonicActions = require('../../actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = function styles(theme) {
  return {
    root: {
      width: '100%',
      marginTop: theme.spacing(3),
      overflowX: 'auto'
    },
    table: {
      minWidth: 360
    }
  };
};

var NowPlayingBrowser = function (_Component) {
  _inherits(NowPlayingBrowser, _Component);

  _createClass(NowPlayingBrowser, null, [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(props, prevState) {
      if (prevState && prevState.nowPlaying === props.subsonic.nowPlaying) return prevState;
      var nowPlaying = props.subsonic.nowPlaying;
      // bookmarks = array of
      //  comment = JSON of type, id, source, potentially mode (albums)
      //  position
      //  entry:
      //    id, album, artist, coverArt, title
      // create the table structure here
      var tableData = nowPlaying.map(function (b, i, a) {
        // console.log("tableData", b);
        var e = Object.assign({}, b);
        return e;
      }, []);
      return {
        nowPlaying: nowPlaying,
        tableData: tableData
      };
    }
  }]);

  function NowPlayingBrowser(props) {
    _classCallCheck(this, NowPlayingBrowser);

    var _this = _possibleConstructorReturn(this, (NowPlayingBrowser.__proto__ || Object.getPrototypeOf(NowPlayingBrowser)).call(this, props));

    _this.state = {};
    // this.state = NowPlayingBrowser.getDerivedStateFromProps(props);
    return _this;
  }

  // componentWillReceiveProps(nextProps) {
  //   this.setState(
  //     NowPlayingBrowser.getDerivedStateFromProps(nextProps, this.state)
  //   );
  // }

  _createClass(NowPlayingBrowser, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      _SubsonicActions2.default.getNowPlaying.defer();
      _SubsonicActions2.default.followUser.defer(null);
      this.interval = setInterval(_SubsonicActions2.default.getNowPlaying.defer, 10000);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearInterval(this.interval);
    }
  }, {
    key: 'handleRowClick',
    value: function handleRowClick(evt, np) {
      console.log('np', np);
      _SubsonicActions2.default.followUser(np);

      var history = this.props.history;

      history.push('/player');
      // hack for HashRouter
      // window.bookmarkState = bookmark;
      // history.push(path, bookmark);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      // console.log("render bookmarks", this.props, this.state);
      var _props = this.props,
          classes = _props.classes,
          SubsonicSource = _props.SubsonicSource;


      return _react2.default.createElement(
        _Paper2.default,
        { className: classes.root },
        _react2.default.createElement(
          _Table2.default,
          { className: classes.table },
          _react2.default.createElement(
            _TableHead2.default,
            null,
            _react2.default.createElement(
              _TableRow2.default,
              null,
              _react2.default.createElement(_TableCell2.default, { size: 'small' }),
              _react2.default.createElement(
                _TableCell2.default,
                { size: 'small' },
                'Title'
              ),
              _react2.default.createElement(
                _Hidden2.default,
                { xsDown: true },
                _react2.default.createElement(
                  _TableCell2.default,
                  { size: 'small' },
                  'Artist'
                )
              ),
              _react2.default.createElement(
                _Hidden2.default,
                { xsDown: true },
                _react2.default.createElement(
                  _TableCell2.default,
                  { size: 'small' },
                  'Album'
                )
              ),
              _react2.default.createElement(
                _TableCell2.default,
                { size: 'small' },
                'Player'
              ),
              _react2.default.createElement(_TableCell2.default, { size: 'small' })
            )
          ),
          _react2.default.createElement(
            _TableBody2.default,
            null,
            this.state.tableData.map(function (n) {
              return _react2.default.createElement(
                _TableRow2.default,
                {
                  key: n.username + n.playerId + n.id,
                  onClick: function onClick(event) {
                    return _this2.handleRowClick(event, n);
                  }
                },
                _react2.default.createElement(
                  _TableCell2.default,
                  { size: 'small' },
                  _react2.default.createElement('img', {
                    style: {
                      width: '100%',
                      maxWidth: '40px',
                      height: 'auto'
                    },
                    alt: '',
                    src: SubsonicSource.getCoverArtURL(n.coverArt, 40)
                  })
                ),
                _react2.default.createElement(
                  _TableCell2.default,
                  { size: 'small' },
                  n.title
                ),
                _react2.default.createElement(
                  _Hidden2.default,
                  { xsDown: true },
                  _react2.default.createElement(
                    _TableCell2.default,
                    { size: 'small' },
                    n.artist
                  )
                ),
                _react2.default.createElement(
                  _Hidden2.default,
                  { xsDown: true },
                  _react2.default.createElement(
                    _TableCell2.default,
                    { size: 'small' },
                    n.album
                  )
                ),
                _react2.default.createElement(
                  _TableCell2.default,
                  { size: 'small' },
                  n.username + '@' + n.playerName
                ),
                _react2.default.createElement(
                  _Hidden2.default,
                  { xsDown: true },
                  _react2.default.createElement(
                    _TableCell2.default,
                    { size: 'small' },
                    n.minutesAgo + ' minutes ago'
                  )
                ),
                _react2.default.createElement(
                  _Hidden2.default,
                  { mdUp: true },
                  _react2.default.createElement(
                    _TableCell2.default,
                    { size: 'small' },
                    n.minutesAgo
                  )
                )
              );
            })
          )
        )
      );
    }
  }]);

  return NowPlayingBrowser;
}(_react.Component);

exports.default = (0, _styles.withStyles)(styles)(NowPlayingBrowser);
module.exports = exports.default;