'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _Grid = require('@material-ui/core/Grid');

var _Grid2 = _interopRequireDefault(_Grid);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _styles = require('@material-ui/core/styles');

var _PlayArrow = require('@material-ui/icons/PlayArrow');

var _PlayArrow2 = _interopRequireDefault(_PlayArrow);

var _Shuffle = require('@material-ui/icons/Shuffle');

var _Shuffle2 = _interopRequireDefault(_Shuffle);

var _SubsonicActions = require('../../actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

var _ScrollToTopFab = require('../styled/ScrollToTopFab');

var _ScrollToTopFab2 = _interopRequireDefault(_ScrollToTopFab);

var _SongList = require('./SongList');

var _SongList2 = _interopRequireDefault(_SongList);

var _utils = require('../../../utils/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = function styles(theme) {
  return {
    list: {
      paddingInlineStart: 0
    },
    li: {
      listStyle: 'none'
    }
  };
};

var PlaylistBrowser = function (_Component) {
  _inherits(PlaylistBrowser, _Component);

  function PlaylistBrowser(props) {
    _classCallCheck(this, PlaylistBrowser);

    var _this = _possibleConstructorReturn(this, (PlaylistBrowser.__proto__ || Object.getPrototypeOf(PlaylistBrowser)).call(this, props));

    _this.playItem = function (song) {
      if (_this.props.remotes.remoteState === 'sender') {
        _this.props.history.push('/loading/song/' + song.id);
      } else {
        _SubsonicActions2.default.startPlaying(song, 0);
        _this.props.history.push('/player');
      }
    };

    _this.playList = function (shuffle) {
      var match = _this.props.match;

      var id = match.params.id;
      if (_this.props.remotes.remoteState === 'sender') {
        _this.props.history.push('/loading/playlist/' + id + (shuffle ? '/shuffle' : ''));
      } else {
        var contents = _this.state.contents;
        if (shuffle) {
          contents = (0, _utils.arrayShuffle)(contents.slice(0));
        }
        _SubsonicActions2.default.startPlaying(contents, 0);
        _this.props.history.push('/player');
      }
    };

    _this.state = {
      contents: props.subsonic.playlistEntries
    };
    return _this;
  }

  _createClass(PlaylistBrowser, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          subsonic = _props.subsonic,
          SubsonicSource = _props.SubsonicSource,
          match = _props.match,
          classes = _props.classes;

      var id = match.params.id;
      if (!subsonic || !subsonic.isConnected || !subsonic.allPlaylists) {
        return _react2.default.createElement(
          _Typography2.default,
          null,
          'awaiting login...'
        );
      }

      if (!subsonic.playlistInfo) {
        if (id === undefined || id === 'undefined') {
          return _react2.default.createElement(
            _Typography2.default,
            null,
            'problem 1'
          );
        }
        return _react2.default.createElement(_reactRouterDom.Redirect, { to: '/loading/playlist/' + id + '/list' });
      }

      if ('' + subsonic.playlistInfo.id !== '' + id) {
        return _react2.default.createElement(_reactRouterDom.Redirect, { to: '/loading/playlist/' + id + '/list' });
      }

      var contents = this.state.contents;


      var buttons = _react2.default.createElement(
        _Grid2.default,
        { container: true },
        _react2.default.createElement(_Grid2.default, { item: true, xs: 1 }),
        _react2.default.createElement(
          _Grid2.default,
          { item: true, xs: 2 },
          _react2.default.createElement(
            _Button2.default,
            {
              variant: 'outlined',
              color: 'primary',
              className: classes.button,
              onClick: this.playList.bind(this, false)
            },
            'Play',
            _react2.default.createElement(_PlayArrow2.default, { className: classes.rightIcon })
          )
        ),
        ' ',
        _react2.default.createElement(_Grid2.default, { item: true, xs: 1 }),
        _react2.default.createElement(
          _Grid2.default,
          { item: true, xs: 2 },
          _react2.default.createElement(
            _Button2.default,
            {
              variant: 'outlined',
              color: 'secondary',
              className: classes.button,
              onClick: this.playList.bind(this, true)
            },
            'Shuffle and Play',
            _react2.default.createElement(_Shuffle2.default, { className: classes.rightIcon })
          )
        )
      );

      var songListProps = {
        contents: contents,
        SubsonicSource: SubsonicSource,
        showCover: true,
        coverSize: 48,
        sortable: true,
        handleSongClick: this.playItem
      };
      var songSection = _react2.default.createElement(_SongList2.default, _extends({
        onChange: function onChange(ids) {
          var songs = _this2.state.contents;
          var c = ids.map(function (id) {
            return songs.find(function (s) {
              return s.id * 1 === id * 1;
            });
          });
          _this2.setState({ contents: c });
        }
      }, songListProps));

      return _react2.default.createElement(
        'div',
        null,
        buttons,
        songSection,
        _react2.default.createElement(_ScrollToTopFab2.default, this.props.fabProps)
      );
    }
  }]);

  return PlaylistBrowser;
}(_react.Component);

PlaylistBrowser.getDerivedStateFromProps = function (nextProps, lastState) {
  var incoming = nextProps.subsonic.playlistEntries || [];
  if (incoming.length !== lastState.contents.length) {
    return {
      contents: nextProps.subsonic.playlistEntries || []
    };
  }
  return lastState;
};

exports.default = (0, _styles.withStyles)(styles)(PlaylistBrowser);
module.exports = exports.default;