'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Table = require('@material-ui/core/Table');

var _Table2 = _interopRequireDefault(_Table);

var _TableBody = require('@material-ui/core/TableBody');

var _TableBody2 = _interopRequireDefault(_TableBody);

var _TableCell = require('@material-ui/core/TableCell');

var _TableCell2 = _interopRequireDefault(_TableCell);

var _TableRow = require('@material-ui/core/TableRow');

var _TableRow2 = _interopRequireDefault(_TableRow);

var _List = require('@material-ui/core/List');

var _List2 = _interopRequireDefault(_List);

var _ListItem = require('@material-ui/core/ListItem');

var _ListItem2 = _interopRequireDefault(_ListItem);

var _ListItemIcon = require('@material-ui/core/ListItemIcon');

var _ListItemIcon2 = _interopRequireDefault(_ListItemIcon);

var _ListItemText = require('@material-ui/core/ListItemText');

var _ListItemText2 = _interopRequireDefault(_ListItemText);

var _ListItemSecondaryAction = require('@material-ui/core/ListItemSecondaryAction');

var _ListItemSecondaryAction2 = _interopRequireDefault(_ListItemSecondaryAction);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _FormControlLabel = require('@material-ui/core/FormControlLabel');

var _FormControlLabel2 = _interopRequireDefault(_FormControlLabel);

var _FormControl = require('@material-ui/core/FormControl');

var _FormControl2 = _interopRequireDefault(_FormControl);

var _Input = require('@material-ui/core/Input');

var _Input2 = _interopRequireDefault(_Input);

var _InputLabel = require('@material-ui/core/InputLabel');

var _InputLabel2 = _interopRequireDefault(_InputLabel);

var _Select = require('@material-ui/core/Select');

var _Select2 = _interopRequireDefault(_Select);

var _MenuItem = require('@material-ui/core/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _Checkbox = require('@material-ui/core/Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

var _Paper = require('@material-ui/core/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _GridList = require('@material-ui/core/GridList');

var _GridList2 = _interopRequireDefault(_GridList);

var _PlayArrow = require('@material-ui/icons/PlayArrow');

var _PlayArrow2 = _interopRequireDefault(_PlayArrow);

var _Shuffle = require('@material-ui/icons/Shuffle');

var _Shuffle2 = _interopRequireDefault(_Shuffle);

var _CoverCard = require('../styled/CoverCard');

var _CoverCard2 = _interopRequireDefault(_CoverCard);

var _CoverGridTile = require('../styled/CoverGridTile');

var _CoverGridTile2 = _interopRequireDefault(_CoverGridTile);

var _ScrollToTopFab = require('../styled/ScrollToTopFab');

var _ScrollToTopFab2 = _interopRequireDefault(_ScrollToTopFab);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PlaylistsBrowser = function (_Component) {
  _inherits(PlaylistsBrowser, _Component);

  function PlaylistsBrowser(props) {
    _classCallCheck(this, PlaylistsBrowser);

    var _this = _possibleConstructorReturn(this, (PlaylistsBrowser.__proto__ || Object.getPrototypeOf(PlaylistsBrowser)).call(this, props));

    _this.updateDimensions = function () {
      _this.setState({ width: window.innerWidth, height: window.innerHeight });
    };

    _this.componentDidMount = function () {
      window.addEventListener('resize', _this.updateDimensions);
      _this.updateDimensions();
    };

    _this.componentWillUnmount = function () {
      window.removeEventListener('resize', _this.updateDimensions);
    };

    _this.playlistLoad = function (id) {
      console.log('props!', id, _this.props);
      if (_this.props.onSelect) _this.props.onSelect(id, _this.props.route || {
        history: _this.props.history,
        location: _this.props.location,
        match: _this.props.match
      }, _this.state.shuffle);
    };

    _this.playlistSelect = function (evt) {
      _this.playlistLoad(evt.target.value);
    };

    _this.handleShuffleChange = function (evt, checked) {
      _this.setState({ shuffle: checked });
    };

    _this.myRef = _react2.default.createRef();

    _this.state = {
      shuffle: false
    };
    return _this;
  }

  _createClass(PlaylistsBrowser, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      // console.warn("pl render", this.props);

      var _props = this.props,
          renderAllPlaylists = _props.renderAllPlaylists,
          linkComponent = _props.linkComponent,
          subsonic = _props.subsonic,
          renderMode = _props.renderMode,
          selectedId = _props.selectedId,
          SubsonicSource = _props.SubsonicSource,
          native = _props.native,
          includeEmpty = _props.includeEmpty,
          label = _props.label,
          fullWidth = _props.fullWidth,
          _props$classes = _props.classes,
          classes = _props$classes === undefined ? {} : _props$classes,
          _props$showShuffleOpt = _props.showShuffleOption,
          showShuffleOption = _props$showShuffleOpt === undefined ? false : _props$showShuffleOpt,
          renderEmptyMessage = _props.renderEmptyMessage;
      var shuffle = this.state.shuffle;
      var playlists = subsonic.playlists,
          allPlaylists = subsonic.allPlaylists;

      var rm = renderMode || PlaylistsBrowser.renderTypes.TABLE;
      var PlayerRefLink = linkComponent;
      var pl = renderAllPlaylists ? allPlaylists : playlists;
      var rv = void 0;

      if (!pl || pl.length === 0) {
        var message = 'No Playlists have been added to this server.';
        if (!subsonic.isConnected) {
          message = 'Not yet connected...';
        } else if (subsonic.isBusy) {
          message = 'Still loading...';
        }
        rv = renderEmptyMessage ? renderEmptyMessage(message) : _react2.default.createElement(
          _Paper2.default,
          null,
          _react2.default.createElement(
            _Typography2.default,
            { variant: 'h4' },
            message
          )
        );
      } else if (rm === PlaylistsBrowser.renderTypes.CARDS) {
        var innerWidth = window.innerWidth;

        var cellSize = innerWidth > 560 ? 250 : 164;

        rv = _react2.default.createElement(
          _react2.default.Fragment,
          null,
          pl.map(function (n, i) {
            return _react2.default.createElement(_CoverCard2.default, {
              key: n.id,
              name: n.name,
              size: cellSize,
              coverArt: n.coverArt,
              link: '/loading/playlist/' + n.id,
              id: n.id,
              SubsonicSource: SubsonicSource,
              idx: i
            });
          })
        );
      } else if (rm === PlaylistsBrowser.renderTypes.GRID) {
        var _innerWidth = window.innerWidth;
        if (this.myRef && this.myRef.current) {
          _innerWidth = this.myRef.current.offsetWidth;
        }

        if (isNaN(_innerWidth)) _innerWidth = 360;
        var spacing = _innerWidth > 360 ? 10 : 6;
        var _cellSize = _innerWidth > 360 ? 170 : 164;

        var cols = _innerWidth / (_cellSize + spacing);
        var width = cols * (_cellSize + spacing);
        var Icon = shuffle ? _Shuffle2.default : _PlayArrow2.default;
        rv = _react2.default.createElement(
          'div',
          { ref: this.myRef },
          showShuffleOption && _react2.default.createElement(_FormControlLabel2.default, {
            labelPlacement: 'start',
            control: _react2.default.createElement(_Checkbox2.default, {
              icon: _react2.default.createElement(_PlayArrow2.default, null),
              checkedIcon: _react2.default.createElement(_Shuffle2.default, null),
              checked: shuffle,
              onChange: this.handleShuffleChange,
              value: 'shuffle'
            }),
            label: 'Shuffle on Play'
          }),
          _react2.default.createElement(
            _GridList2.default,
            {
              className: 'playlist-gridlist',
              cellHeight: _cellSize,
              width: width,
              cols: cols,
              spacing: spacing
            },
            pl.map(function (n) {
              return _react2.default.createElement(_CoverGridTile2.default, {
                onClick: _this2.playlistLoad.bind(_this2, n.id),
                key: 'pl' + n.id,
                name: n.name,
                size: _cellSize,
                coverArt: n.coverArt,
                options: { shuffle: shuffle },
                linkComponent: linkComponent,
                id: n.id,
                SubsonicSource: SubsonicSource,
                icon: Icon
              });
            })
          ),
          _react2.default.createElement(_ScrollToTopFab2.default, this.props.fabProps)
        );
      } else if (rm === PlaylistsBrowser.renderTypes.LIST) {
        rv = _react2.default.createElement(
          'div',
          { ref: this.myRef },
          showShuffleOption && _react2.default.createElement(_FormControlLabel2.default, {
            labelPlacement: 'start',
            control: _react2.default.createElement(_Checkbox2.default, {
              icon: _react2.default.createElement(_PlayArrow2.default, null),
              checkedIcon: _react2.default.createElement(_Shuffle2.default, null),
              checked: shuffle,
              onChange: this.handleShuffleChange,
              value: 'shuffle'
            }),
            label: 'Shuffle on Play'
          }),
          _react2.default.createElement(
            _List2.default,
            null,
            pl.map(function (n) {
              return _react2.default.createElement(
                _ListItem2.default,
                {
                  key: 'pl' + n.id,
                  button: true,
                  onClick: _this2.playlistLoad.bind(_this2, n.id)
                },
                _react2.default.createElement(
                  _ListItemIcon2.default,
                  null,
                  _react2.default.createElement('img', {
                    alt: '',
                    width: 48,
                    height: 48,
                    src: SubsonicSource.getCoverArtURL(n.coverArt, 48)
                  })
                ),
                _react2.default.createElement(_ListItemText2.default, {
                  primary: n.name,
                  secondary: n.songCount + ' songs'
                }),
                _react2.default.createElement(
                  _ListItemSecondaryAction2.default,
                  { style: { width: 48, height: 48 } },
                  _react2.default.createElement(
                    _IconButton2.default,
                    {
                      'aria-label': shuffle ? 'Shuffle' : 'Play',
                      component: PlayerRefLink,
                      id: n.id,
                      options: shuffle ? { shuffle: shuffle } : {}
                    },
                    shuffle ? _react2.default.createElement(_Shuffle2.default, null) : _react2.default.createElement(_PlayArrow2.default, null)
                  )
                )
              );
            })
          )
        );
      } else if (rm === PlaylistsBrowser.renderTypes.TABLE) {
        rv = _react2.default.createElement(
          'div',
          { ref: this.myRef },
          showShuffleOption && _react2.default.createElement(_FormControlLabel2.default, {
            labelPlacement: 'start',
            control: _react2.default.createElement(_Checkbox2.default, {
              icon: _react2.default.createElement(_PlayArrow2.default, null),
              checkedIcon: _react2.default.createElement(_Shuffle2.default, null),
              checked: shuffle,
              onChange: this.handleShuffleChange,
              value: 'shuffle'
            }),
            label: 'Shuffle on Play'
          }),
          _react2.default.createElement(
            _Table2.default,
            null,
            _react2.default.createElement(
              _TableBody2.default,
              null,
              pl.map(function (n) {
                var selected = '' + n.id === '' + selectedId;
                return _react2.default.createElement(
                  _TableRow2.default,
                  { selected: selected, key: 'pl' + n.id },
                  _react2.default.createElement(
                    _TableCell2.default,
                    null,
                    _react2.default.createElement(
                      PlayerRefLink,
                      { id: n.id },
                      _react2.default.createElement('img', {
                        crossOrigin: 'anonymous',
                        src: _this2.props.SubsonicSource.getCoverArtURL(n.coverArt, 40),
                        alt: n.name
                      })
                    )
                  ),
                  _react2.default.createElement(
                    _TableCell2.default,
                    null,
                    _react2.default.createElement(
                      PlayerRefLink,
                      { id: n.id },
                      n.name
                    )
                  )
                );
              })
            )
          )
        );
      } else if (rm === PlaylistsBrowser.renderTypes.SELECT) {
        // console.log('select', pl, selectedId, typeof selectedId);
        var emptyRef = includeEmpty ? native ? _react2.default.createElement('option', { value: '' }) : _react2.default.createElement(_MenuItem2.default, { value: '' }) : null;
        rv = _react2.default.createElement(
          _FormControl2.default,
          { className: classes.formControl, fullWidth: fullWidth },
          _react2.default.createElement(
            _InputLabel2.default,
            { htmlFor: 'pl-label' },
            label
          ),
          _react2.default.createElement(
            _Select2.default,
            {
              fullWidth: fullWidth,
              native: native,
              value: '' + selectedId,
              onChange: this.playlistSelect,
              id: 'pl-select',
              input: _react2.default.createElement(_Input2.default, { id: 'pl-label' })
            },
            emptyRef,
            pl.map(function (n, idx) {
              // console.log('option', n.id, '' + selectedId === '' + n.id, n.name);
              if (native) return _react2.default.createElement(
                'option',
                { value: '' + n.id, key: 'pl' + n.id + '-' + idx },
                n.name
              );
              return _react2.default.createElement(
                _MenuItem2.default,
                { value: '' + n.id, key: 'pl' + n.id + '-' + idx },
                _react2.default.createElement('img', {
                  crossOrigin: 'anonymous',
                  src: _this2.props.SubsonicSource.getCoverArtURL(n.coverArt, 15),
                  alt: pl.name
                }),
                '\xA0',
                n.name
              );
            })
          ),
          showShuffleOption && _react2.default.createElement(_FormControlLabel2.default, {
            labelPlacement: 'end',
            control: _react2.default.createElement(_Checkbox2.default, {
              icon: _react2.default.createElement(_PlayArrow2.default, null),
              checkedIcon: _react2.default.createElement(_Shuffle2.default, null),
              checked: shuffle,
              onChange: this.handleShuffleChange,
              value: 'shuffle'
            }),
            label: 'Shuffle on Play'
          })
        );
      }
      return rv;
    }
  }]);

  return PlaylistsBrowser;
}(_react.Component);

PlaylistsBrowser.renderTypes = {
  GRID: 'grid',
  LIST: 'list',
  TABLE: 'table',
  SELECT: 'select',
  CARDS: 'cards'
};
exports.default = PlaylistsBrowser;
module.exports = exports.default;