'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _SubsonicActions = require('../../actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

var _Paper = require('@material-ui/core/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _List = require('@material-ui/core/List');

var _List2 = _interopRequireDefault(_List);

var _ListItem = require('@material-ui/core/ListItem');

var _ListItem2 = _interopRequireDefault(_ListItem);

var _ListItemIcon = require('@material-ui/core/ListItemIcon');

var _ListItemIcon2 = _interopRequireDefault(_ListItemIcon);

var _ListItemText = require('@material-ui/core/ListItemText');

var _ListItemText2 = _interopRequireDefault(_ListItemText);

var _Collapse = require('@material-ui/core/Collapse');

var _Collapse2 = _interopRequireDefault(_Collapse);

var _ExpandLess = require('@material-ui/icons/ExpandLess');

var _ExpandLess2 = _interopRequireDefault(_ExpandLess);

var _ExpandMore = require('@material-ui/icons/ExpandMore');

var _ExpandMore2 = _interopRequireDefault(_ExpandMore);

var _styles = require('@material-ui/core/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = function styles(theme) {
  return {
    root: {
      width: '100%',
      // maxWidth: 360,
      backgroundColor: theme.palette.background.paper
    },
    nested: {
      paddingLeft: theme.spacing(4)
    }
  };
};

var PodcastsBrowser = function (_React$Component) {
  _inherits(PodcastsBrowser, _React$Component);

  _createClass(PodcastsBrowser, null, [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(props, prevState) {
      if (!prevState) prevState = { open: '-1' };
      return Object.assign({}, prevState);
    }
  }]);

  function PodcastsBrowser(props) {
    _classCallCheck(this, PodcastsBrowser);

    var _this = _possibleConstructorReturn(this, (PodcastsBrowser.__proto__ || Object.getPrototypeOf(PodcastsBrowser)).call(this, props));

    _this.handleItemClick = function (episode, evt) {
      console.warn('playing', episode);
      _SubsonicActions2.default.playPodcast(episode);
      _this.props.history.push('/player');
    };

    _this.handleExpandClick = function (id, evt) {
      _this.setState({ open: id === _this.state.open ? '-1' : id });
    };

    _this.renderPodcastItem = function (p) {
      var _this$props = _this.props,
          classes = _this$props.classes,
          subsonic = _this$props.subsonic,
          SubsonicSource = _this$props.SubsonicSource,
          podcastProps = _this$props.podcastProps,
          podcastItemProps = _this$props.podcastItemProps;

      return _react2.default.createElement(
        _ListItem2.default,
        {
          key: p.id,
          button: true,
          className: classes.nested,
          onClick: _this.handleItemClick.bind(_this, p)
        },
        _react2.default.createElement(_ListItemText2.default, {
          inset: true,
          primary: p.title,
          primaryTypographyProps: podcastItemProps
        })
      );
    };

    _this.renderPodcast = function (p) {
      var _this$props2 = _this.props,
          SubsonicSource = _this$props2.SubsonicSource,
          podcastProps = _this$props2.podcastProps;

      return _react2.default.createElement(
        'span',
        { key: p.id },
        _react2.default.createElement(
          _ListItem2.default,
          { button: true, onClick: _this.handleExpandClick.bind(_this, p.id) },
          _react2.default.createElement(
            _ListItemIcon2.default,
            null,
            _react2.default.createElement('img', { src: SubsonicSource.getCoverArtURL(p.coverArt, 24), alt: '' })
          ),
          _react2.default.createElement(_ListItemText2.default, {
            inset: true,
            primary: p.title,
            primaryTypographyProps: podcastProps
          }),
          _this.state.open === p.id ? _react2.default.createElement(_ExpandLess2.default, null) : _react2.default.createElement(_ExpandMore2.default, null)
        ),
        _react2.default.createElement(
          _Collapse2.default,
          { 'in': _this.state.open === p.id, timeout: 'auto', unmountOnExit: true },
          _react2.default.createElement(
            _List2.default,
            { component: 'div', disablePadding: true },
            p.episode.slice(0, 12).map(function (e) {
              return _this.renderPodcastItem(e);
            })
          )
        )
      );
    };

    _this.state = {};
    // this.state = PodcastsBrowser.getDerivedStateFromProps(props);
    return _this;
  }

  // componentWillReceiveProps(nextProps) {
  //   this.setState(PodcastsBrowser.getDerivedStateFromProps(nextProps, this.state));
  // }

  _createClass(PodcastsBrowser, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          classes = _props.classes,
          subsonic = _props.subsonic,
          remotes = _props.remotes;
      // yes, letting a little of subfire bleed in. not much i can do about it...

      var warning = null;
      if (remotes.remoteState === 'sender') warning = _react2.default.createElement(
        _Typography2.default,
        null,
        'Note: currently, podcast loading does not work correctly over remote casting. It will load locally.'
      );

      if (subsonic.podcasts === null) {
        console.log('redirect to loading');
        return _react2.default.createElement(_reactRouterDom.Redirect, { to: '/loading/podcasts/all' });
        // return <span/>;
      }

      if (subsonic.podcasts.length === 0) {
        return _react2.default.createElement(
          _Paper2.default,
          null,
          _react2.default.createElement(
            _Typography2.default,
            { variant: 'h4' },
            'No Podcasts have been added to this server.'
          )
        );
      }

      var listItems = subsonic.podcasts.map(function (p) {
        return _this2.renderPodcast(p);
      });

      return _react2.default.createElement(
        'div',
        { className: classes.root },
        warning,
        _react2.default.createElement(
          _List2.default,
          { component: 'nav' },
          listItems
        )
      );
    }
  }]);

  return PodcastsBrowser;
}(_react2.default.Component);

exports.default = (0, _styles.withStyles)(styles)(PodcastsBrowser);
module.exports = exports.default;