'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Select = require('@material-ui/core/Select');

var _Select2 = _interopRequireDefault(_Select);

var _styles = require('@material-ui/core/styles');

var _FormControl = require('@material-ui/core/FormControl');

var _FormControl2 = _interopRequireDefault(_FormControl);

var _MenuItem = require('@material-ui/core/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ServerSelect = function ServerSelect(props) {
  var classes = props.classes,
      credentials = props.credentials,
      handleServerChange = props.handleServerChange,
      native = props.native,
      labelId = props.labelId,
      _props$fullWidth = props.fullWidth,
      fullWidth = _props$fullWidth === undefined ? true : _props$fullWidth;

  var creds = credentials ? credentials.creds : [{ name: 'unconfigured...' }];
  var current = credentials ? credentials.current : 'unconfigured...';
  var isConnected = credentials ? credentials.isConnected : false;

  var className = isConnected ? '' : classes.notConnected;

  return _react2.default.createElement(
    _FormControl2.default,
    { className: classes.formControl, fullWidth: fullWidth },
    _react2.default.createElement(
      _Select2.default,
      {
        native: native,
        id: 'current-server',
        labelId: labelId,
        SelectDisplayProps: { id: 'select-server' },
        MenuProps: { id: 'menu-server' },
        value: current,
        onChange: handleServerChange,
        className: className
      },
      Object.entries(creds).map(function (o) {
        if (native) return _react2.default.createElement(
          'option',
          { key: o[0], value: o[0] },
          o[1].name
        );
        return _react2.default.createElement(
          _MenuItem2.default,
          { key: o[0], value: o[0] },
          o[1].name
        );
      })
    )
  );
};

var styles = function styles(theme) {
  return {
    formControl: {
      margin: 0
    },
    notConnected: {
      fontStyle: 'italic'
    }
  };
};

exports.default = (0, _styles.withStyles)(styles)(ServerSelect);
module.exports = exports.default;