'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactSortablejs = require('react-sortablejs');

var _reactSortablejs2 = _interopRequireDefault(_reactSortablejs);

var _List = require('@material-ui/core/List');

var _List2 = _interopRequireDefault(_List);

var _ListItem = require('@material-ui/core/ListItem');

var _ListItem2 = _interopRequireDefault(_ListItem);

var _ListItemText = require('@material-ui/core/ListItemText');

var _ListItemText2 = _interopRequireDefault(_ListItemText);

var _ListItemIcon = require('@material-ui/core/ListItemIcon');

var _ListItemIcon2 = _interopRequireDefault(_ListItemIcon);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _styles = require('@material-ui/core/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// list items


// table items

var styles = function styles(theme) {
  return {
    list: {
      paddingInlineStart: 0
    },
    li: {
      listStyle: 'none'
    }
  };
};

var SongList = function (_Component) {
  _inherits(SongList, _Component);

  function SongList() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, SongList);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = SongList.__proto__ || Object.getPrototypeOf(SongList)).call.apply(_ref, [this].concat(args))), _this), _this.handleSongClick = function (song, idx) {
      if (_this.props.handleSongClick) _this.props.handleSongClick(song, idx);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(SongList, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          contents = _props.contents,
          idx = _props.idx,
          classes = _props.classes,
          _props$showCover = _props.showCover,
          showCover = _props$showCover === undefined ? true : _props$showCover,
          _props$coverSize = _props.coverSize,
          coverSize = _props$coverSize === undefined ? 24 : _props$coverSize,
          SubsonicSource = _props.SubsonicSource,
          _props$sortable = _props.sortable,
          sortable = _props$sortable === undefined ? false : _props$sortable,
          _props$showMeta = _props.showMeta,
          showMeta = _props$showMeta === undefined ? true : _props$showMeta;
      var sortedOptions = this.props.sortedOptions;


      var onChange = function onChange(items, sortable, evt) {
        console.log(items, sortable);
        if (_this2.props.onChange) _this2.props.onChange(items, sortable, evt);
      };

      var songItems = '';
      songItems = contents.map(function (s, i, cp) {
        return _react2.default.createElement(
          _ListItem2.default,
          {
            'data-song-id': s.id,
            component: 'li',
            classes: { container: classes.li },
            id: 'songs-li-' + i,
            className: idx === i ? classes.selectedSongListItem : classes.songListItem,
            key: i,
            button: true,
            onClick: _this2.handleSongClick.bind(_this2, s, i)
          },
          showCover && _react2.default.createElement(
            _ListItemIcon2.default,
            {
              style: {
                width: coverSize,
                height: coverSize
              }
            },
            _react2.default.createElement('img', {
              alt: s.title,
              src: SubsonicSource.getCoverArtURL(s.coverArt, coverSize)
            })
          ),
          _react2.default.createElement(
            _ListItemText2.default,
            null,
            i + 1,
            '. ',
            s.title,
            showMeta && _react2.default.createElement(
              _react2.default.Fragment,
              null,
              _react2.default.createElement('br', null),
              _react2.default.createElement(
                _Typography2.default,
                { variant: 'caption' },
                s.artist,
                '- ',
                s.album
              )
            )
          )
        );
      });

      if (sortable) {
        sortedOptions = Object.assign({}, sortedOptions, {
          animation: 150,
          dataIdAttr: 'data-song-id',
          ghostClass: 'sortable-ghost', // Class name for the drop placeholder
          chosenClass: 'sortable-chosen', // Class name for the chosen item
          dragClass: 'sortable-drag' // Class name for the dragging item
        });
        return _react2.default.createElement(
          _reactSortablejs2.default,
          {
            options: sortedOptions,
            className: classes.list,
            tag: 'ul',
            onChange: onChange
          },
          songItems
        );
      }

      return _react2.default.createElement(
        _List2.default,
        { className: classes.list },
        songItems
      );
    }
  }]);

  return SongList;
}(_react.Component);

exports.default = (0, _styles.withStyles)(styles)(SongList);
module.exports = exports.default;