'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _MusicFolderChooser = require('./MusicFolderChooser');

var _MusicFolderChooser2 = _interopRequireDefault(_MusicFolderChooser);

var _Avatar = require('@material-ui/core/Avatar');

var _Avatar2 = _interopRequireDefault(_Avatar);

var _ListSubheader = require('@material-ui/core/ListSubheader');

var _ListSubheader2 = _interopRequireDefault(_ListSubheader);

var _List = require('@material-ui/core/List');

var _List2 = _interopRequireDefault(_List);

var _ListItem = require('@material-ui/core/ListItem');

var _ListItem2 = _interopRequireDefault(_ListItem);

var _ListItemText = require('@material-ui/core/ListItemText');

var _ListItemText2 = _interopRequireDefault(_ListItemText);

var _styles = require('@material-ui/core/styles');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _ScrollToTopFab = require('../styled/ScrollToTopFab');

var _ScrollToTopFab2 = _interopRequireDefault(_ScrollToTopFab);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = function styles(theme) {
  return {
    root: {
      width: '100%',
      // maxWidth: 360,
      // maxHeight: 300,
      position: 'absolute',
      top: 48,
      bottom: 0,
      // backgroundColor: theme.palette.background.paper,
      overflow: 'auto'
    },
    subheader: {
      backgroundColor: theme.palette.background.paper
    },
    subhidden: {
      display: 'none'
    },
    listSection: {
      backgroundColor: 'inherit'
    },
    ul: {
      backgroundColor: 'inherit',
      padding: 0
    },
    avatar: {
      margin: 5
    },
    bigAvatar: {
      width: 40,
      height: 40
    }
  };
};

var TreeBrowser = function (_Component) {
  _inherits(TreeBrowser, _Component);

  function TreeBrowser() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, TreeBrowser);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TreeBrowser.__proto__ || Object.getPrototypeOf(TreeBrowser)).call.apply(_ref, [this].concat(args))), _this), _this.scrollToTop = function () {
      document.querySelector('.indexList').scrollTop = 0;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TreeBrowser, [{
    key: 'UNSAFE_componentWillReceiveProps',
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      //console.log("ib will", nextProps);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {}
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          subsonic = _props.subsonic,
          SubsonicSource = _props.SubsonicSource,
          classes = _props.classes;
      var musicDirectoryIndexes = subsonic.musicDirectoryIndexes;

      if (!musicDirectoryIndexes) return _react2.default.createElement(
        'span',
        null,
        'loading...'
      );

      var subhidden = {};
      subhidden[classes.subhidden] = musicDirectoryIndexes.length < 10;
      var subheaderClasses = (0, _classnames2.default)(classes.subheader, subhidden);

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(_MusicFolderChooser2.default, subsonic),
        _react2.default.createElement(
          _List2.default,
          {
            className: (0, _classnames2.default)(classes.root, 'indexList'),
            subheader: _react2.default.createElement('li', null)
          },
          musicDirectoryIndexes.map(function (index) {
            return _react2.default.createElement(
              'li',
              { key: 'section-' + index.name, className: classes.listSection },
              _react2.default.createElement(
                'ul',
                { className: classes.ul },
                _react2.default.createElement(
                  _ListSubheader2.default,
                  { className: subheaderClasses },
                  'Index: ' + index.name
                ),
                index.artist.map(function (item) {
                  return _react2.default.createElement(
                    _ListItem2.default,
                    {
                      key: 'item-' + index.name + '-' + item.id,
                      button: true,
                      component: _reactRouterDom.Link,
                      to: '/loading/directory/' + item.id
                    },
                    _react2.default.createElement(_Avatar2.default, {
                      alt: '' + item.name,
                      src: SubsonicSource.getCoverArtURL(item.coverArt, 40),
                      className: (0, _classnames2.default)(classes.avatar, classes.bigAvatar)
                    }),
                    _react2.default.createElement(_ListItemText2.default, { primary: '' + item.name })
                  );
                })
              )
            );
          })
        ),
        _react2.default.createElement(_ScrollToTopFab2.default, { scrollToTop: this.scrollToTop })
      );
    }
  }]);

  return TreeBrowser;
}(_react.Component);

exports.default = (0, _styles.withStyles)(styles)(TreeBrowser);
module.exports = exports.default;