'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _altContainer = require('alt-container');

var _altContainer2 = _interopRequireDefault(_altContainer);

var _SubsonicStore = require('../../stores/SubsonicStore');

var _SubsonicStore2 = _interopRequireDefault(_SubsonicStore);

var _RemotesStore = require('../../../subfire/stores/RemotesStore');

var _RemotesStore2 = _interopRequireDefault(_RemotesStore);

var _SubsonicSource = require('../../sources/SubsonicSource');

var _SubsonicSource2 = _interopRequireDefault(_SubsonicSource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// const UpdateCheck = (props) => {
//   console.log('UpdateCheck', props);
//   return "<span/>";
// }

var lastSecond = -1;

var SubsonicContainer = function SubsonicContainer(props) {
  var inject = {
    SubsonicSource: _SubsonicSource2.default
  };
  if (props.route) inject.route = props.route;
  if (props.location) inject.location = props.location;
  if (props.match) inject.match = props.match;
  if (props.history) inject.history = props.history;

  if (props.csProps) {
    inject.csProps = props.csProps;
    var currentMediaTime = Math.floor(props.csProps.currentMediaTime || -1);
    if (currentMediaTime !== lastSecond) {
      _SubsonicStore2.default.state.currentMediaTime = currentMediaTime;
      _SubsonicStore2.default.persistQueueLocally();
      lastSecond = currentMediaTime;
    }
  }

  // returns subsonic as the data, route from the react-router match, and SubsonicSource only for the URL generators
  return _react2.default.createElement(
    _altContainer2.default,
    {
      stores: {
        subsonic: _SubsonicStore2.default,
        remotes: _RemotesStore2.default
      },
      inject: inject
    },
    props.children
  );
};

exports.default = SubsonicContainer;
module.exports = exports.default;