'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Fab = require('@material-ui/core/Fab');

var _Fab2 = _interopRequireDefault(_Fab);

var _common = require('@material-ui/core/colors/common');

var _common2 = _interopRequireDefault(_common);

var _styles = require('@material-ui/core/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var styles = function styles(theme) {
  return {
    root: {
      color: _common2.default.white,
      width: '25px',
      minWidth: '50px'
    },
    standalone: {
      position: 'fixed',
      bottom: theme.spacing(2),
      right: theme.spacing(2),
      zIndex: 100
    }
  };
};

var ActionButton = function ActionButton(props) {
  var Component = _Button2.default;
  var coreProps = {
    color: props.color || 'primary',
    onClick: props.action,
    'aria-label': props.label
  };
  if (props.disabled) coreProps.disabled = true;
  if (props.fab) {
    // coreProps.variant = "fab";
    Component = _Fab2.default;
    if (props.standalone) coreProps.classes = { root: props.classes.standalone };
  } else coreProps.classes = { root: props.classes.root };

  if (props.is) {
    coreProps.component = function (_ref) {
      var className = _ref.className,
          coreProps = _objectWithoutProperties(_ref, ['className']);

      return _react2.default.createElement('button', _extends({}, coreProps, { 'class': className, is: props.is }));
    };
  }

  return _react2.default.createElement(
    Component,
    _extends({}, coreProps, { className: props.buttonClassName }),
    props.children
  );
};

exports.default = (0, _styles.withStyles)(styles)(ActionButton);
module.exports = exports.default;