'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ChromecastButton = exports.SavePlayQueueButton = exports.BookmarkButton = exports.Forward30Button = exports.Replay10Button = exports.SkipAlbumButton = exports.ShuffleButton = exports.PrevButton = exports.NextButton = exports.PlayPauseButton = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ActionButton = require('./ActionButton');

var _ActionButton2 = _interopRequireDefault(_ActionButton);

var _icons = require('@material-ui/icons');

var _SubsonicActions = require('../../actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// import { withStyles } from '@material-ui/core/styles';

var PlayPauseButton = exports.PlayPauseButton = function PlayPauseButton(props) {
  var label = 'play',
      icon = _react2.default.createElement(_icons.PlayArrow, { className: props.iconClassName });
  if (props.isPlaying) {
    label = 'pause';
    icon = _react2.default.createElement(_icons.Pause, { className: props.iconClassName });
  } else if (props.isLoading) {
    label = 'loading';
    icon = _react2.default.createElement(_icons.Update, { className: props.iconClassName });
  }
  // console.warn(props);
  var coreProps = {
    action: props.actions ? props.actions.playOrPause : null,
    label: label,
    disabled: props.isLoading,
    fab: props.fab,
    color: props.color,
    standalone: props.standalone,
    buttonClassName: props.buttonClassName
  };
  return _react2.default.createElement(
    _ActionButton2.default,
    coreProps,
    icon
  );
};

var NextButton = exports.NextButton = function NextButton(props) {
  var icon = _react2.default.createElement(_icons.SkipNext, { className: props.iconClassName });
  var coreProps = {
    action: _SubsonicActions2.default.playerNext,
    label: 'next',
    // disabled: props.isLoading,
    fab: props.fab,
    buttonClassName: props.buttonClassName
  };

  return _react2.default.createElement(
    _ActionButton2.default,
    coreProps,
    icon
  );
};

var PrevButton = exports.PrevButton = function PrevButton(props) {
  var icon = _react2.default.createElement(_icons.SkipPrevious, { className: props.iconClassName });
  var playerPrev = function playerPrev() {
    var currentTime = props.currentMediaTime;
    if (props.actions && props.actions.seekTo && currentTime > 10) {
      props.actions.seekTo(0);
    } else {
      _SubsonicActions2.default.playerPrev();
    }
  };

  var coreProps = {
    action: playerPrev,
    label: 'previous',
    // disabled: props.isLoading,
    fab: props.fab,
    buttonClassName: props.buttonClassName
  };

  return _react2.default.createElement(
    _ActionButton2.default,
    coreProps,
    icon
  );
};

var ShuffleButton = exports.ShuffleButton = function ShuffleButton(props) {
  var icon = _react2.default.createElement(_icons.Shuffle, { className: props.iconClassName });
  var coreProps = {
    action: props.shuffleClick || _SubsonicActions2.default.shufflePlaying,
    label: 'shuffle',
    // disabled: props.isLoading,
    fab: props.fab,
    buttonClassName: props.buttonClassName
  };

  return _react2.default.createElement(
    _ActionButton2.default,
    coreProps,
    icon
  );
};

var SkipAlbumButton = exports.SkipAlbumButton = function SkipAlbumButton(props) {
  var icon = _react2.default.createElement(_icons.Redo, { className: props.iconClassName });
  var coreProps = {
    action: _SubsonicActions2.default.playerSkip,
    label: 'skip album',
    // disabled: props.isLoading,
    fab: props.fab,
    buttonClassName: props.buttonClassName
  };

  return _react2.default.createElement(
    _ActionButton2.default,
    coreProps,
    icon
  );
};

var Replay10Button = exports.Replay10Button = function Replay10Button(props) {
  var replay10Action = function replay10Action() {
    var currentTime = props.currentMediaTime;
    if (props.actions && props.actions.seekTo) {
      props.actions.seekTo(Math.max(0, props.currentMediaTime - 10));
    }
  };

  var icon = _react2.default.createElement(_icons.Replay10, { className: props.iconClassName });
  var coreProps = {
    action: replay10Action,
    label: 'replay 10 seconds',
    disabled: props.isLoading,
    fab: props.fab,
    buttonClassName: props.buttonClassName
  };

  return _react2.default.createElement(
    _ActionButton2.default,
    coreProps,
    icon
  );
};

var Forward30Button = exports.Forward30Button = function Forward30Button(props) {
  var forward30Action = function forward30Action() {
    if (props.actions && props.actions.seekTo) {
      props.actions.seekTo(Math.min(props.duration - 1, props.currentMediaTime + 30));
    }
  };

  var icon = _react2.default.createElement(_icons.Forward30, { className: props.iconClassName });
  var coreProps = {
    action: forward30Action,
    label: 'skip 30 seconds',
    disabled: props.isLoading,
    fab: props.fab,
    buttonClassName: props.buttonClassName
  };

  return _react2.default.createElement(
    _ActionButton2.default,
    coreProps,
    icon
  );
};

var BookmarkButton = exports.BookmarkButton = function BookmarkButton(props) {
  var bookmarkToggle = function bookmarkToggle() {
    console.log('internal bookmarkToggle', props);
    props.action(props.currentMediaTime || 0);
  };

  var label = 'not bookmarked',
      icon = _react2.default.createElement(_icons.BookmarkBorder, { className: props.iconClassName });
  if (props.isBookmarked) {
    label = 'bookmarked';
    icon = _react2.default.createElement(_icons.Bookmark, { className: props.iconClassName });
  }
  var coreProps = {
    action: bookmarkToggle,
    label: label,
    // disabled: props.isLoading,
    fab: props.fab,
    buttonClassName: props.buttonClassName
  };

  return _react2.default.createElement(
    _ActionButton2.default,
    coreProps,
    icon
  );
};

var SavePlayQueueButton = exports.SavePlayQueueButton = function SavePlayQueueButton(props) {
  var savePlayQueue = function savePlayQueue() {
    _SubsonicActions2.default.savePlayQueue(Math.trunc((props.currentMediaTime || 0) * 1000));
  };

  var icon = _react2.default.createElement(_icons.Queue, { className: props.iconClassName });
  var coreProps = {
    action: savePlayQueue,
    label: 'save play queue',
    // disabled: props.isLoading,
    fab: props.fab,
    buttonClassName: props.buttonClassName
  };

  return _react2.default.createElement(
    _ActionButton2.default,
    coreProps,
    icon
  );
};

var ChromecastButton = exports.ChromecastButton = function (_React$Component) {
  _inherits(ChromecastButton, _React$Component);

  function ChromecastButton() {
    _classCallCheck(this, ChromecastButton);

    return _possibleConstructorReturn(this, (ChromecastButton.__proto__ || Object.getPrototypeOf(ChromecastButton)).apply(this, arguments));
  }

  _createClass(ChromecastButton, [{
    key: 'render',
    value: function render() {
      // return (<google-cast-launcher class="fakeMuiButton1 fakeMuiButton2 fakeMuiButton3"/>);
      var props = this.props;
      var coreProps = {
        // disabled: props.isLoading,
        fab: props.fab,
        buttonClassName: props.buttonClassName
      };
      return _react2.default.createElement(
        _ActionButton2.default,
        coreProps,
        _react2.default.createElement('google-cast-launcher', { 'class': 'googleCastButton' })
      );
    }
  }]);

  return ChromecastButton;
}(_react2.default.Component);