'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DialogActions = require('@material-ui/core/DialogActions');

var _DialogActions2 = _interopRequireDefault(_DialogActions);

var _DialogContent = require('@material-ui/core/DialogContent');

var _DialogContent2 = _interopRequireDefault(_DialogContent);

var _DialogTitle = require('@material-ui/core/DialogTitle');

var _DialogTitle2 = _interopRequireDefault(_DialogTitle);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _TVResponsiveDialog = require('../hoc/TVResponsiveDialog');

var _TVResponsiveDialog2 = _interopRequireDefault(_TVResponsiveDialog);

var _styles = require('@material-ui/core/styles');

var _CredentialsActions = require('../../actions/CredentialsActions');

var _CredentialsActions2 = _interopRequireDefault(_CredentialsActions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ImportCredentials = function (_React$Component) {
  _inherits(ImportCredentials, _React$Component);

  function ImportCredentials(props) {
    _classCallCheck(this, ImportCredentials);

    var _this = _possibleConstructorReturn(this, (ImportCredentials.__proto__ || Object.getPrototypeOf(ImportCredentials)).call(this, props));

    _this.handleSubmitPlayer = function () {
      _CredentialsActions2.default.importSubFirePlayerCredentials();
    };

    _this.handleSubmitMobile = function () {
      _CredentialsActions2.default.importSubFireM1Credentials();
    };

    _this.handleClose = function () {
      if (_this.props.handleClose) {
        _this.props.handleClose();
      } else if (_this.props.route && _this.props.route.history) {
        _this.props.route.history.goBack();
      }
    };

    var ls = window.localStorage;

    var configs = ls.getItem('configs');
    var config = void 0;
    if (configs) {
      configs = JSON.parse(configs);
      config = ls.getItem('config');
    }

    var credentials = ls.getItem('credentials');
    if (credentials) {
      credentials = JSON.parse(credentials);
    }
    _this.state = {
      config: config,
      configs: configs,
      credentials: credentials
    };
    return _this;
  }

  _createClass(ImportCredentials, [{
    key: 'render',
    value: function render() {
      var classes = this.props.classes;
      var _state = this.state,
          config = _state.config,
          configs = _state.configs,
          credentials = _state.credentials;


      var playerCancel = credentials ? null : _react2.default.createElement(
        _Button2.default,
        { onClick: this.handleClose },
        'Cancel'
      );

      var player = configs ? _react2.default.createElement(
        _react2.default.Fragment,
        null,
        _react2.default.createElement(
          _DialogContent2.default,
          null,
          _react2.default.createElement(
            _Typography2.default,
            { variant: 'h6' },
            'SubFire Player'
          ),
          _react2.default.createElement(
            _Typography2.default,
            null,
            'Found config ' + config + ' with server ' + configs[config].server + ', username ' + configs[config].username + ' as 1 of ' + Object.keys(configs).length + ' config(s) that can be imported.'
          )
        ),
        _react2.default.createElement(
          _DialogActions2.default,
          null,
          playerCancel,
          _react2.default.createElement(
            _Button2.default,
            { color: 'primary', onClick: this.handleSubmitPlayer },
            'Import SubFire Player'
          )
        )
      ) : null;

      var mobile = credentials ? _react2.default.createElement(
        _react2.default.Fragment,
        null,
        _react2.default.createElement(
          _DialogContent2.default,
          null,
          _react2.default.createElement(
            _Typography2.default,
            { variant: 'h6' },
            'SubFire Mobile'
          ),
          _react2.default.createElement(
            _Typography2.default,
            null,
            'Found server ' + credentials.server + ', username ' + credentials.username + ' that can be imported.'
          )
        ),
        _react2.default.createElement(
          _DialogActions2.default,
          null,
          _react2.default.createElement(
            _Button2.default,
            { onClick: this.handleClose },
            'Cancel'
          ),
          ',',
          _react2.default.createElement(
            _Button2.default,
            { color: 'primary', onClick: this.handleSubmitMobile },
            'Import SubFire Mobile'
          )
        )
      ) : null;

      var nothing = !(player || mobile) ? _react2.default.createElement(
        _react2.default.Fragment,
        null,
        _react2.default.createElement(
          _DialogContent2.default,
          null,
          _react2.default.createElement(
            _Typography2.default,
            null,
            'There are no configurations to import.'
          )
        ),
        _react2.default.createElement(
          _DialogActions2.default,
          null,
          _react2.default.createElement(
            _Button2.default,
            { onClick: this.handleClose, color: 'primary' },
            'Close'
          ),
          ','
        )
      ) : null;

      return _react2.default.createElement(
        _TVResponsiveDialog2.default,
        {
          disableBackdropClick: true,
          open: true,
          className: classes.paperFullScreen
        },
        _react2.default.createElement(
          _DialogTitle2.default,
          null,
          'Import Credentials'
        ),
        player,
        mobile,
        nothing
      );
    }
  }]);

  return ImportCredentials;
}(_react2.default.Component);

// Uncomment properties you need
// LoginComponent.propTypes = {};
// LoginComponent.defaultProps = {};

var styles = function styles(theme) {
  return {
    root: {
      display: 'flex',
      flexWrap: 'wrap'
    },
    formControl: {
      margin: 0,
      width: '100%'
    },
    selectEmpty: {
      marginTop: theme.spacing(2)
    }
  };
};

exports.default = (0, _styles.withStyles)(styles)(ImportCredentials);
module.exports = exports.default;