'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DialogActions = require('@material-ui/core/DialogActions');

var _DialogActions2 = _interopRequireDefault(_DialogActions);

var _DialogContent = require('@material-ui/core/DialogContent');

var _DialogContent2 = _interopRequireDefault(_DialogContent);

var _DialogContentText = require('@material-ui/core/DialogContentText');

var _DialogContentText2 = _interopRequireDefault(_DialogContentText);

var _DialogTitle = require('@material-ui/core/DialogTitle');

var _DialogTitle2 = _interopRequireDefault(_DialogTitle);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _TextField = require('@material-ui/core/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _Select = require('@material-ui/core/Select');

var _Select2 = _interopRequireDefault(_Select);

var _InputLabel = require('@material-ui/core/InputLabel');

var _InputLabel2 = _interopRequireDefault(_InputLabel);

var _MenuItem = require('@material-ui/core/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _FormControl = require('@material-ui/core/FormControl');

var _FormControl2 = _interopRequireDefault(_FormControl);

var _TVResponsiveDialog = require('../hoc/TVResponsiveDialog');

var _TVResponsiveDialog2 = _interopRequireDefault(_TVResponsiveDialog);

var _styles = require('@material-ui/core/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LoginCredentials = function (_React$Component) {
  _inherits(LoginCredentials, _React$Component);

  function LoginCredentials(props) {
    _classCallCheck(this, LoginCredentials);

    // console.log(props);
    var _this = _possibleConstructorReturn(this, (LoginCredentials.__proto__ || Object.getPrototypeOf(LoginCredentials)).call(this, props));

    _this.handleSubmit = function () {
      var creds = _this.state.credentials;
      var newCreds = {
        name: document.getElementById('name').value,
        server: document.getElementById('server').value,
        username: document.getElementById('username').value,
        password: document.getElementById('password').value || creds.password,
        bitrate: document.getElementById('bitrate') ? document.getElementById('bitrate').value : 0
      };
      if (newCreds.server.endsWith('/')) newCreds.server = newCreds.server.substring(0, newCreds.server.length - 1);
      if (_this.props.handleSubmit) _this.props.handleSubmit(_this.state.current, newCreds);
      if (_this.props.route && _this.props.route.history) _this.props.route.history.goBack();
    };

    _this.handleDelete = function () {
      //console.log(this.state.current);
      if (_this.props.handleDelete) _this.props.handleDelete(_this.state.current);
      if (_this.props.route && _this.props.route.history) _this.props.route.history.goBack();
    };

    _this.handleClose = function () {
      //console.log('handleClose called');
      if (_this.props.handleClose) _this.props.handleClose();
      if (_this.props.route && _this.props.route.history) _this.props.route.history.goBack();
    };

    _this.handleImport = function () {
      _this.props.route.history.push('/import');
    };

    _this.handleChangeCurrent = function (e) {
      //console.log(e.target.value);
      var state = _this.state;
      state.current = e.target.value;
      if (state.current === '__new__') {
        state.credentials = Object.assign({}, state.credentials);
        state.credentials.name = 'Set Name Here';
      } else {
        state.credentials = _this.props.credentials.creds[state.current];
      }
      _this.setState(state);
    };

    _this.handleChange = function (property) {
      return function (e) {
        //console.log(property, e.target.value);
        var state = _this.state;
        state.credentials[property] = e.target.value;
        _this.setState(state);
      };
    };

    _this.handlePasswordKeyDown = _this.handlePasswordKeyDown.bind(_this);
    var currentCreds = props.current;
    _this.state = {
      current: props.credentials.current,
      credentials: Object.assign({}, currentCreds)
    };
    return _this;
  }

  _createClass(LoginCredentials, [{
    key: 'UNSAFE_componentWillReceiveProps',
    value: function UNSAFE_componentWillReceiveProps(newProps) {
      // console.warn('lc componentWillReceiveProps', newProps);
      var props = newProps;
      var currentCreds = props.current;
      this.setState({
        current: props.credentials.current,
        credentials: Object.assign({}, currentCreds)
      });
    }
  }, {
    key: 'handlePasswordKeyDown',
    value: function handlePasswordKeyDown(evt) {
      if (evt.keyCode + '' === '13') {
        this.handleSubmit();
        return false;
      }
      return true;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          native = _props.native;

      var state = Object.assign({}, this.state);
      state.loginState = {};

      var isDeleteDisabled = this.props.credentials.current === state.current || state.current === '__new__';

      var isFailure = state.loginState.isLoggedIn !== null && state.loginState.isLoggedIn !== undefined && !state.loginState.isLoggedIn;

      var p = '';
      if (isFailure === true) {
        p = _react2.default.createElement(
          _DialogContentText2.default,
          null,
          'The Login Failed...'
        );
      } else {
        p = null;
      }
      var bitrates = ['320', '256', '192', '160', '128', '96', '80', '64', '32'];
      var options = [{
        value: '0',
        primaryText: 'Unlimited'
      }];
      bitrates.forEach(function (br) {
        options.push({ value: br, primaryText: br + ' Kbps' });
      });

      var that = this;

      var currentSelectorField = _react2.default.createElement(
        _FormControl2.default,
        { className: classes.formControl },
        _react2.default.createElement(
          _InputLabel2.default,
          { htmlFor: 'current-selection' },
          'Current Selection'
        ),
        _react2.default.createElement(
          _Select2.default,
          {
            native: native,
            id: 'current-selection',
            value: this.state.current,
            onChange: this.handleChangeCurrent
          },
          Object.entries(this.props.credentials.creds).map(function (o) {
            if (native) return _react2.default.createElement(
              'option',
              { key: o[0], value: o[0] },
              o[1].name
            );
            return _react2.default.createElement(
              _MenuItem2.default,
              { key: o[0], value: o[0] },
              o[1].name
            );
          }),
          native && _react2.default.createElement(
            'option',
            { key: '__new__', value: '__new__' },
            state.current === '__new__' ? state.credentials.name : 'New Server'
          ),
          !native && _react2.default.createElement(
            _MenuItem2.default,
            { key: '__new__', value: '__new__' },
            state.current === '__new__' ? state.credentials.name : 'New Server'
          )
        )
      );

      // const bitrateField = (
      //   <FormControl fullWidth>
      //     <InputLabel htmlFor="bitrate">Bitrate</InputLabel>
      //     <Select
      //       native={native}
      //       fullWidth
      //       id="bitrate"
      //       value={state.credentials.bitrate || "0"}
      //       onChange={that.handleChange("bitrate")}
      //     >
      //       {options.map(o => {
      //         if (native) {
      //           return (
      //             <option key={o} value={o.value}>
      //               {o.primaryText}
      //             </option>
      //           );
      //         } else {
      //           return (
      //             <MenuItem key={o.primaryText} value={o.value}>
      //               {o.primaryText}
      //             </MenuItem>
      //           );
      //         }
      //       })}
      //     </Select>
      //   </FormControl>
      // );

      var bitrateField = null;
      var showBitRateField = false;
      var bitrateFieldRender = showBitRateField ? bitrateField : '';

      var existing = this.props.credentials.creds[state.current];
      var passwordValues = {};
      if (existing && existing.password === state.credentials.password) {
        passwordValues.label = 'Password: unchanged';
        passwordValues.value = '';
      } else {
        passwordValues.label = 'Password';
        passwordValues.value = state.credentials.password;
      }

      return _react2.default.createElement(
        _TVResponsiveDialog2.default,
        {
          disableBackdropClick: true,
          open: true,
          className: classes.paperFullScreen
        },
        _react2.default.createElement(
          _DialogTitle2.default,
          null,
          'Server Credentials'
        ),
        _react2.default.createElement(
          _DialogContent2.default,
          null,
          p,
          currentSelectorField,
          _react2.default.createElement(_TextField2.default, {
            id: 'name',
            label: 'Name',
            margin: 'dense',
            fullWidth: true,
            onChange: this.handleChange('name'),
            value: state.credentials.name
          }),
          _react2.default.createElement(_TextField2.default, {
            id: 'server',
            label: 'Server',
            margin: 'dense',
            helperText: 'http(s)://host:port',
            fullWidth: true,
            onChange: this.handleChange('server'),
            value: state.credentials.server
          }),
          _react2.default.createElement(_TextField2.default, {
            id: 'username',
            label: 'Username',
            margin: 'dense',
            fullWidth: true,
            onChange: this.handleChange('username'),
            value: state.credentials.username
          }),
          _react2.default.createElement(_TextField2.default, _extends({
            id: 'password',
            type: 'password',
            margin: 'dense',
            fullWidth: true,
            onChange: this.handleChange('password'),
            onKeyDown: this.handlePasswordKeyDown
          }, passwordValues)),
          bitrateFieldRender
        ),
        _react2.default.createElement(
          _DialogActions2.default,
          null,
          _react2.default.createElement(
            _Button2.default,
            { onClick: this.handleImport },
            'Import'
          ),
          _react2.default.createElement(
            _Button2.default,
            { disabled: isDeleteDisabled, onClick: this.handleDelete },
            'Delete'
          ),
          _react2.default.createElement(
            _Button2.default,
            { onClick: this.handleClose },
            'Cancel'
          ),
          _react2.default.createElement(
            _Button2.default,
            { color: 'primary', onClick: this.handleSubmit },
            'Submit'
          )
        )
      );
    }
  }]);

  return LoginCredentials;
}(_react2.default.Component);

// Uncomment properties you need
// LoginComponent.propTypes = {};
// LoginComponent.defaultProps = {};

var styles = function styles(theme) {
  return {
    root: {
      display: 'flex',
      flexWrap: 'wrap'
    },
    formControl: {
      margin: 0,
      width: '100%'
    },
    selectEmpty: {
      marginTop: theme.spacing(2)
    }
  };
};

exports.default = (0, _styles.withStyles)(styles)(LoginCredentials);
module.exports = exports.default;