'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Grid = require('@material-ui/core/Grid');

var _Grid2 = _interopRequireDefault(_Grid);

var _FormControl = require('@material-ui/core/FormControl');

var _FormControl2 = _interopRequireDefault(_FormControl);

var _FormControlLabel = require('@material-ui/core/FormControlLabel');

var _FormControlLabel2 = _interopRequireDefault(_FormControlLabel);

var _Input = require('@material-ui/core/Input');

var _Input2 = _interopRequireDefault(_Input);

var _InputAdornment = require('@material-ui/core/InputAdornment');

var _InputAdornment2 = _interopRequireDefault(_InputAdornment);

var _InputLabel = require('@material-ui/core/InputLabel');

var _InputLabel2 = _interopRequireDefault(_InputLabel);

var _Switch = require('@material-ui/core/Switch');

var _Switch2 = _interopRequireDefault(_Switch);

var _Tabs = require('@material-ui/core/Tabs');

var _Tabs2 = _interopRequireDefault(_Tabs);

var _Tab = require('@material-ui/core/Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _icons = require('@material-ui/icons');

var _MusicFolderChooser = require('../browsers/MusicFolderChooser');

var _MusicFolderChooser2 = _interopRequireDefault(_MusicFolderChooser);

var _SubsonicActions = require('../../actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

var _ArtistSearchResults = require('./ArtistSearchResults');

var _ArtistSearchResults2 = _interopRequireDefault(_ArtistSearchResults);

var _AlbumSearchResults = require('./AlbumSearchResults');

var _AlbumSearchResults2 = _interopRequireDefault(_AlbumSearchResults);

var _SongSearchResults = require('./SongSearchResults');

var _SongSearchResults2 = _interopRequireDefault(_SongSearchResults);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ARTIST_TAB = 0;
var ALBUM_TAB = 1;
var SONG_TAB = 2;

var Search = function (_Component) {
  _inherits(Search, _Component);

  function Search(props) {
    _classCallCheck(this, Search);

    var _this = _possibleConstructorReturn(this, (Search.__proto__ || Object.getPrototypeOf(Search)).call(this, props));

    _this.startSearch = function () {
      // due to music folder change, this may need to be deferred
      var params = {
        query: _this.state.query + '*',
        id3: _this.state.id3,
        searchType: _this.state.value === 0 ? 'artist' : _this.state.value === 1 ? 'album' : 'song',
        pageSize: 300, // this.state.pageSize,
        nextPage: _this.state.value === 0 ? _this.state.albumPage : _this.state.value === 1 ? _this.state.artistPage : _this.state.songPage
      };
      _SubsonicActions2.default.doSearch.defer(params);
    };

    _this.handleSearchChange = function (evt, value) {
      _this.setState({ query: evt.target.value }, function () {
        _this.startSearch();
      });
    };

    _this.handleID3Change = function (evt, isInputChecked) {
      _this.setState({ id3: isInputChecked }, function () {
        _this.startSearch();
      });
    };

    _this.searchFolderChanged = function (value) {
      _SubsonicActions2.default.setSearchMusicFolder(value);
      _this.startSearch();
    };

    _this.changeTab = function (event, value) {
      _this.setState({ value: value }, function () {
        _this.startSearch();
      });
    };

    _this.state = {
      query: '',
      id3: false,
      value: SONG_TAB,
      albumPage: 0,
      artistPage: 0,
      songPage: 0,
      pageSize: 10
    };
    return _this;
  }

  _createClass(Search, [{
    key: 'render',
    value: function render() {
      var subsonic = this.props.subsonic;
      var musicFolders = subsonic.musicFolders,
          searchMusicFolder = subsonic.searchMusicFolder;
      var _state = this.state,
          query = _state.query,
          id3 = _state.id3,
          value = _state.value,
          songPage = _state.songPage,
          pageSize = _state.pageSize;


      var musicChooserProps = {
        musicFolder: searchMusicFolder,
        musicFolders: musicFolders
      };

      var label = 'ID3?';
      var id3Switch = _react2.default.createElement(_Switch2.default, {
        label: label,
        value: 'id3',
        checked: id3,
        onChange: this.handleID3Change
      });
      var id3Selector = _react2.default.createElement(
        _Grid2.default,
        { item: true, xs: 3 },
        _react2.default.createElement(_FormControlLabel2.default, { control: id3Switch, label: 'ID3' })
      );

      return _react2.default.createElement(
        _Grid2.default,
        { container: true },
        _react2.default.createElement(
          _Grid2.default,
          { xs: 9, item: true },
          _react2.default.createElement(_MusicFolderChooser2.default, _extends({}, musicChooserProps, {
            musicFolderChanged: this.searchFolderChanged
          }))
        ),
        id3Selector,
        _react2.default.createElement(
          _Grid2.default,
          { xs: 9, item: true },
          _react2.default.createElement(
            _FormControl2.default,
            { fullWidth: true },
            _react2.default.createElement(
              _InputLabel2.default,
              { htmlFor: 'search-input' },
              'Search String (use * for wildcards)'
            ),
            _react2.default.createElement(_Input2.default, {
              defaultValue: query,
              onChange: this.handleSearchChange,
              id: 'search-input',
              startAdornment: _react2.default.createElement(
                _InputAdornment2.default,
                { position: 'start' },
                ' ',
                _react2.default.createElement(_icons.Search, null)
              )
            })
          )
        ),
        _react2.default.createElement(
          _Grid2.default,
          { xs: 12, item: true },
          _react2.default.createElement(
            _Tabs2.default,
            {
              value: value,
              onChange: this.changeTab,
              fullWidth: true,
              indicatorColor: 'primary',
              textColor: 'primary'
            },
            _react2.default.createElement(_Tab2.default, { icon: _react2.default.createElement(_icons.Album, null) }),
            _react2.default.createElement(_Tab2.default, { icon: _react2.default.createElement(_icons.People, null) }),
            _react2.default.createElement(_Tab2.default, { icon: _react2.default.createElement(_icons.LibraryMusic, null) })
          )
        ),
        _react2.default.createElement(
          _Grid2.default,
          { xs: 12, item: true },
          value === ARTIST_TAB && _react2.default.createElement(_ArtistSearchResults2.default, null),
          value === ALBUM_TAB && _react2.default.createElement(_AlbumSearchResults2.default, null),
          value === SONG_TAB && _react2.default.createElement(_SongSearchResults2.default, {
            results: subsonic.searchSongsResults,
            page: songPage,
            pageSize: pageSize
          })
        )
      );
    }
  }]);

  return Search;
}(_react.Component);

exports.default = Search;
module.exports = exports.default;