'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('@material-ui/core/styles');

var _Table = require('@material-ui/core/Table');

var _Table2 = _interopRequireDefault(_Table);

var _TableBody = require('@material-ui/core/TableBody');

var _TableBody2 = _interopRequireDefault(_TableBody);

var _TableHead = require('@material-ui/core/TableHead');

var _TableHead2 = _interopRequireDefault(_TableHead);

var _TableCell = require('@material-ui/core/TableCell');

var _TableCell2 = _interopRequireDefault(_TableCell);

var _TableFooter = require('@material-ui/core/TableFooter');

var _TableFooter2 = _interopRequireDefault(_TableFooter);

var _TablePagination = require('@material-ui/core/TablePagination');

var _TablePagination2 = _interopRequireDefault(_TablePagination);

var _TableRow = require('@material-ui/core/TableRow');

var _TableRow2 = _interopRequireDefault(_TableRow);

var _Paper = require('@material-ui/core/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _FirstPage = require('@material-ui/icons/FirstPage');

var _FirstPage2 = _interopRequireDefault(_FirstPage);

var _KeyboardArrowLeft = require('@material-ui/icons/KeyboardArrowLeft');

var _KeyboardArrowLeft2 = _interopRequireDefault(_KeyboardArrowLeft);

var _KeyboardArrowRight = require('@material-ui/icons/KeyboardArrowRight');

var _KeyboardArrowRight2 = _interopRequireDefault(_KeyboardArrowRight);

var _LastPage = require('@material-ui/icons/LastPage');

var _LastPage2 = _interopRequireDefault(_LastPage);

var _FileCopy = require('@material-ui/icons/FileCopy');

var _FileCopy2 = _interopRequireDefault(_FileCopy);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var actionsStyles = function actionsStyles(theme) {
  return {
    root: {
      flexShrink: 0,
      color: theme.palette.text.secondary,
      marginLeft: theme.spacing(2.5)
    }
  };
};

var TablePaginationActions = function (_React$Component) {
  _inherits(TablePaginationActions, _React$Component);

  function TablePaginationActions() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, TablePaginationActions);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TablePaginationActions.__proto__ || Object.getPrototypeOf(TablePaginationActions)).call.apply(_ref, [this].concat(args))), _this), _this.handleFirstPageButtonClick = function (event) {
      _this.props.onChangePage(event, 0);
    }, _this.handleBackButtonClick = function (event) {
      _this.props.onChangePage(event, _this.props.page - 1);
    }, _this.handleNextButtonClick = function (event) {
      _this.props.onChangePage(event, _this.props.page + 1);
    }, _this.handleLastPageButtonClick = function (event) {
      _this.props.onChangePage(event, Math.max(0, Math.ceil(_this.props.count / _this.props.rowsPerPage) - 1));
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TablePaginationActions, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          classes = _props.classes,
          count = _props.count,
          page = _props.page,
          rowsPerPage = _props.rowsPerPage,
          theme = _props.theme;


      return _react2.default.createElement(
        'div',
        { className: classes.root },
        _react2.default.createElement(
          _IconButton2.default,
          {
            onClick: this.handleFirstPageButtonClick,
            disabled: page === 0,
            'aria-label': 'First Page'
          },
          theme.direction === 'rtl' ? _react2.default.createElement(_LastPage2.default, null) : _react2.default.createElement(_FirstPage2.default, null)
        ),
        _react2.default.createElement(
          _IconButton2.default,
          {
            onClick: this.handleBackButtonClick,
            disabled: page === 0,
            'aria-label': 'Previous Page'
          },
          theme.direction === 'rtl' ? _react2.default.createElement(_KeyboardArrowRight2.default, null) : _react2.default.createElement(_KeyboardArrowLeft2.default, null)
        ),
        _react2.default.createElement(
          _IconButton2.default,
          {
            onClick: this.handleNextButtonClick,
            disabled: page >= Math.ceil(count / rowsPerPage) - 1,
            'aria-label': 'Next Page'
          },
          theme.direction === 'rtl' ? _react2.default.createElement(_KeyboardArrowLeft2.default, null) : _react2.default.createElement(_KeyboardArrowRight2.default, null)
        ),
        _react2.default.createElement(
          _IconButton2.default,
          {
            onClick: this.handleLastPageButtonClick,
            disabled: page >= Math.ceil(count / rowsPerPage) - 1,
            'aria-label': 'Last Page'
          },
          theme.direction === 'rtl' ? _react2.default.createElement(_FirstPage2.default, null) : _react2.default.createElement(_LastPage2.default, null)
        )
      );
    }
  }]);

  return TablePaginationActions;
}(_react2.default.Component);

var TablePaginationActionsWrapped = (0, _styles.withStyles)(actionsStyles, {
  withTheme: true
})(TablePaginationActions);

var styles = function styles(theme) {
  return {
    root: {
      width: '100%',
      marginTop: theme.spacing(3)
    },
    table: {
      minWidth: 500
    },
    tableWrapper: {
      overflowX: 'auto'
    }
  };
};

var SongSearchResults = function (_React$Component2) {
  _inherits(SongSearchResults, _React$Component2);

  _createClass(SongSearchResults, null, [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(props, state) {
      return { data: props.results, rowsPerPage: props.pageSize };
    }
  }]);

  function SongSearchResults(props) {
    _classCallCheck(this, SongSearchResults);

    var _this2 = _possibleConstructorReturn(this, (SongSearchResults.__proto__ || Object.getPrototypeOf(SongSearchResults)).call(this, props));

    _this2.handleChangePage = function (event, page) {
      _this2.setState({ page: page });
    };

    _this2.handleChangeRowsPerPage = function (event) {
      _this2.setState({ rowsPerPage: event.target.value });
    };

    _this2.writeClipboard = function (x, a, b, c) {
      navigator.clipboard.writeText(x).then(function (res) {
        console.log(res);
      }).catch(function (err) {
        console.error(err);
      });
    };

    _this2.state = {
      page: 0
    };
    return _this2;
  }

  _createClass(SongSearchResults, [{
    key: 'render',
    value: function render() {
      var _this3 = this;

      var classes = this.props.classes;
      var _state = this.state,
          data = _state.data,
          rowsPerPage = _state.rowsPerPage,
          page = _state.page;

      var emptyRows = rowsPerPage - Math.min(rowsPerPage, data.length - page * rowsPerPage);

      return _react2.default.createElement(
        _Paper2.default,
        { className: classes.root },
        _react2.default.createElement(
          'div',
          { className: classes.tableWrapper },
          _react2.default.createElement(
            _Table2.default,
            { className: classes.table },
            _react2.default.createElement(
              _TableHead2.default,
              null,
              _react2.default.createElement(
                _TableRow2.default,
                null,
                _react2.default.createElement(
                  _TableCell2.default,
                  { style: { width: '35%' } },
                  'Title'
                ),
                _react2.default.createElement(
                  _TableCell2.default,
                  { style: { width: '25%' } },
                  'Artist'
                ),
                _react2.default.createElement(
                  _TableCell2.default,
                  { style: { width: '25%' } },
                  'Album'
                ),
                _react2.default.createElement(
                  _TableCell2.default,
                  null,
                  'copy'
                )
              )
            ),
            _react2.default.createElement(
              _TableBody2.default,
              null,
              data.slice(page * rowsPerPage, page * rowsPerPage + rowsPerPage).map(function (n) {
                n = n || {};
                return _react2.default.createElement(
                  _TableRow2.default,
                  { key: n.id },
                  _react2.default.createElement(
                    _TableCell2.default,
                    { component: 'th', scope: 'row' },
                    n.title
                  ),
                  _react2.default.createElement(
                    _TableCell2.default,
                    null,
                    n.artist
                  ),
                  _react2.default.createElement(
                    _TableCell2.default,
                    null,
                    n.album
                  ),
                  _react2.default.createElement(
                    _TableCell2.default,
                    null,
                    _react2.default.createElement(
                      _IconButton2.default,
                      {
                        onClick: _this3.writeClipboard.bind(_this3, n.title + ' - ' + n.artist)
                      },
                      _react2.default.createElement(_FileCopy2.default, null)
                    )
                  )
                );
              }),
              emptyRows > 0 && _react2.default.createElement(
                _TableRow2.default,
                {
                  style: {
                    height: 48 * emptyRows
                  }
                },
                _react2.default.createElement(_TableCell2.default, { colSpan: 6 })
              )
            ),
            _react2.default.createElement(
              _TableFooter2.default,
              null,
              _react2.default.createElement(
                _TableRow2.default,
                null,
                _react2.default.createElement(_TablePagination2.default, {
                  colSpan: 3,
                  count: data.length,
                  rowsPerPage: rowsPerPage,
                  page: page,
                  onChangePage: this.handleChangePage,
                  onChangeRowsPerPage: this.handleChangeRowsPerPage,
                  ActionsComponent: TablePaginationActionsWrapped
                })
              )
            )
          )
        )
      );
    }
  }]);

  return SongSearchResults;
}(_react2.default.Component);

exports.default = (0, _styles.withStyles)(styles)(SongSearchResults);
module.exports = exports.default;