'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _Paper = require('@material-ui/core/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Div = function Div(props) {
  return _react2.default.createElement(
    'div',
    { className: props.className + ' no-link' },
    props.children
  );
};

var CoverCard = function CoverCard(props) {
  // const coverArt = props.SubsonicSource.getCoverArtURL(
  //   props.coverArt,
  //   props.size
  // );
  var link = props.link;
  var LinkComponent = link ? _reactRouterDom.Link : Div;
  var className = 'cover-link';
  var category = props.category;

  category = category ? _react2.default.createElement(
    'div',
    { className: 'card-category' },
    category
  ) : category;

  return _react2.default.createElement(
    LinkComponent,
    { className: className, to: link },
    _react2.default.createElement(
      'div',
      { className: 'cover-card' },
      _react2.default.createElement(
        'div',
        { className: 'cover-art' },
        category,
        _react2.default.createElement('img', {
          crossOrigin: 'anonymous',
          src: props.SubsonicSource.getCoverArtURL(props.coverArt, props.size),
          alt: props.name
        })
      ),
      _react2.default.createElement(
        'div',
        { className: 'cover-text' },
        _react2.default.createElement(
          _Paper2.default,
          { square: true, className: 'cover-paper' },
          props.name
        )
      )
    )
  );
};

exports.default = CoverCard;
module.exports = exports.default;