'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.OldScrollToTopFab = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Fab = require('@material-ui/core/Fab');

var _Fab2 = _interopRequireDefault(_Fab);

var _VerticalAlignTop = require('@material-ui/icons/VerticalAlignTop');

var _VerticalAlignTop2 = _interopRequireDefault(_VerticalAlignTop);

var _styles = require('@material-ui/core/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var scrollToTop = function scrollToTop(props) {
  if (props.selector) {
    var x = document.querySelector(props.selector);
    x.scrollTo(0, 0);
  } else {
    document.body.scrollTop = document.documentElement.scrollTop = 0;
    if (window.scrollTo) window.scrollTo(0, 0);
  }
};

var styles = function styles(theme) {
  // console.warn(theme);
  return {
    fab: {
      position: 'fixed',
      zIndex: 100
    }
  };
};

var ScrollToTopFab = function ScrollToTopFab(props) {
  var theme = props.theme;

  var label = 'top',
      icon = _react2.default.createElement(_VerticalAlignTop2.default, null);
  // console.log(props);
  var coreProps = {
    'aria-label': label,
    onClick: props.scrollToTop || scrollToTop.bind(undefined, props),
    style: {
      bottom: props.bottom || theme.spacing(2) + 20,
      right: props.right || theme.spacing(2) + 35
    }
  };

  return _react2.default.createElement(
    _Fab2.default,
    _extends({}, coreProps, { className: props.classes.fab }),
    icon
  );
};

var OldScrollToTopFab = exports.OldScrollToTopFab = (0, _styles.withStyles)(styles)((0, _styles.withTheme)(ScrollToTopFab));

var NoScrollToTopFab = function NoScrollToTopFab() {
  return null;
};

exports.default = NoScrollToTopFab;