"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CredentialsStoreClass = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Dispatcher = require("../../Dispatcher");

var _Dispatcher2 = _interopRequireDefault(_Dispatcher);

var _v = require("uuid/v4");

var _v2 = _interopRequireDefault(_v);

var _SubsonicActions = require("../actions/SubsonicActions");

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

var _CredentialsActions = require("../actions/CredentialsActions");

var _CredentialsActions2 = _interopRequireDefault(_CredentialsActions);

var _SubsonicSource = require("../sources/SubsonicSource");

var _SubsonicSource2 = _interopRequireDefault(_SubsonicSource);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var persistEvents = ['doLogin', 'changeCurrent', 'saveCredentials', 'deleteCredentials', 'totalReset', 'importCredentials'];

var SubsonicDemo = {
  name: "Subsonic Demo",
  server: "http://demo.subsonic.org",
  username: "guest1",
  password: "guest",
  bitrate: "0"
};

var SubFireDemo = {
  name: "SubFire Demo",
  server: "https://subfiresuite.com/ampache",
  username: "guest",
  password: "guest1",
  bitrate: "0"
};

var CredentialsStoreClass = exports.CredentialsStoreClass = function () {
  function CredentialsStoreClass() {
    var _this = this;

    _classCallCheck(this, CredentialsStoreClass);

    var storageState = localStorage.getItem("subsonic.credentials");
    // console.log(storageState);
    if (storageState) {
      storageState = JSON.parse(storageState);
      // TODO:[JS] legacy load from subfire or subfirep credentials...
    } else {
      var demo = (0, _v2.default)();
      var creds = {};
      creds[demo] = SubFireDemo;
      storageState = {
        creds: creds,
        current: demo
      };
    }
    // console.log(storageState);
    this.creds = storageState.creds;
    this.current = storageState.current;
    this.isConnected = false;

    this.bindActions(_CredentialsActions2.default);
    this.bindAction(_SubsonicActions2.default.LOGIN_SUCCESS, this.loginSuccess);
    this.bindAction(_SubsonicActions2.default.LOGIN_FAILURE, this.loginFailure);

    this.on('afterEach', function (payload, state) {
      return _this.afterEach(payload, state);
    });
  }

  _createClass(CredentialsStoreClass, [{
    key: "loginSuccess",
    value: function loginSuccess() {
      this.isConnected = true;
    }
  }, {
    key: "loginFailure",
    value: function loginFailure() {
      this.isConnected = false;
    }
  }, {
    key: "afterEach",
    value: function afterEach(_ref) {
      var payload = _ref.payload,
          state = _ref.state;

      //console.log(payload);
      if (persistEvents.indexOf(payload.details.name) >= 0) {
        //console.log("after", payload, state);
        this.persistToStorage(state);
      }
    }
  }, {
    key: "persistToStorage",
    value: function persistToStorage(state) {
      //console.log('persisting', JSON.stringify(state));
      localStorage.setItem("subsonic.credentials", JSON.stringify(state));
    }
  }, {
    key: "doLogin",
    value: function doLogin() {
      //console.log('doLogin');
      var credentials = this.creds[this.current];
      if (_SubsonicSource2.default.isLoginNeeded(credentials)) {
        // console.log('attemting...');
        _SubsonicSource2.default.login(credentials).then(function () {
          // console.log('success');
          _SubsonicActions2.default.loginSuccess();
        }).catch(function (error) {
          console.warn('error', error);
          _SubsonicActions2.default.loginFailure();
        });
      }
    }
  }, {
    key: "importSubFirePlayerCredentials",
    value: function importSubFirePlayerCredentials() {
      var _this2 = this;

      var configs = JSON.parse(localStorage.getItem('configs'));
      var defaultConfig = localStorage.getItem('config');
      Object.keys(configs).forEach(function (key, idx) {
        var id = (0, _v2.default)();
        var creds = configs[key];
        if (key === defaultConfig) _this2.current = id;
        _this2.creds[id] = {
          name: key + " (SubFirePlayer Import)",
          server: creds.server,
          username: creds.username,
          password: creds.password,
          bitrate: creds.bitrate
        };
      });
    }
  }, {
    key: "importSubFireM1Credentials",
    value: function importSubFireM1Credentials() {
      var id = (0, _v2.default)();
      var creds = JSON.parse(localStorage.getItem('credentials'));
      this.creds[id] = {
        name: 'SubFire Mobile Import',
        server: creds.server,
        username: creds.username,
        password: creds.pwd,
        bitrate: "0"
      };
      this.current = id;
      _CredentialsActions2.default.doLogin.defer();
    }
  }, {
    key: "importCredentials",
    value: function importCredentials(newCreds) {
      var creds = this.creds;
      // todo: look for name overlaps
      this.creds = Object.assign({}, creds, newCreds.creds);
      this.current = newCreds.current;
      _CredentialsActions2.default.doLogin.defer();
    }
  }, {
    key: "changeCurrent",
    value: function changeCurrent(_ref2) {
      var _ref3 = _slicedToArray(_ref2, 2),
          current = _ref3[0],
          doLogin = _ref3[1];

      if (current !== this.current) {
        var currentCreds = this.creds[current];
        if (currentCreds) {
          this.current = current;
        }
      }
      if (doLogin) _CredentialsActions2.default.doLogin.defer();
    }
  }, {
    key: "saveCredentials",
    value: function saveCredentials(_ref4) {
      var _ref5 = _slicedToArray(_ref4, 3),
          id = _ref5[0],
          creds = _ref5[1],
          doLogin = _ref5[2];

      //console.log('saveCredentials', id, creds, doLogin);
      if (!id || id === '__new__') id = (0, _v2.default)();
      this.creds[id] = creds;
      this.current = id;
      if (doLogin) _CredentialsActions2.default.doLogin.defer();
    }
  }, {
    key: "deleteCredentials",
    value: function deleteCredentials(id) {
      if (id === this.current) return;
      delete this.creds[id];
    }
  }, {
    key: "totalReset",
    value: function totalReset() {
      var demo = (0, _v2.default)();
      var creds = {};
      creds[demo] = SubFireDemo;
      var storageState = {
        creds: creds,
        current: demo
      };
      // console.log(storageState);
      this.setState(storageState);
    }
  }]);

  return CredentialsStoreClass;
}();

exports.default = _Dispatcher2.default.createStore(CredentialsStoreClass, "CredentialsStore");