'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SubsonicStoreClass = exports.emptytrack = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
/* eslint no-unused-vars: 0 */

var _Dispatcher = require('../../Dispatcher');

var _Dispatcher2 = _interopRequireDefault(_Dispatcher);

var _SubsonicActions = require('../actions/SubsonicActions');

var _SubsonicActions2 = _interopRequireDefault(_SubsonicActions);

var _SubsonicSource = require('../sources/SubsonicSource');

var _SubsonicSource2 = _interopRequireDefault(_SubsonicSource);

var _utils = require('../../utils/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SubsonicStore = void 0;

var emptytrack = exports.emptytrack = {
  album: '',
  albumId: '-1',
  artist: '',
  year: null,
  coverArt: '-1',
  albumYear: 'restarting the play queue',
  contentType: 'audio/mp3',
  duration: 2,
  title: 'restarting...',
  track: 1,
  localPath: './silence2sec.mp3'
};

var SubsonicStoreClass = exports.SubsonicStoreClass = function () {
  function SubsonicStoreClass() {
    _classCallCheck(this, SubsonicStoreClass);

    this.exportPublicMethods({
      persistQueueLocally: this.persistQueueLocally
    });

    var initMusicFolder = localStorage.getItem('initMusicFolder') || -1;
    initMusicFolder *= 1;

    var currentPlaying = localStorage.getItem('subsonic.lastPlaying');
    if (currentPlaying) {
      var currentPlayingTime = localStorage.getItem('subsonic.lastPlaying.currentMediaTime') || '0';
      currentPlayingTime = 1 * currentPlayingTime;
      currentPlaying = JSON.parse(currentPlaying);
      window.bookmarkSeekTo = currentPlayingTime;
    } else {
      currentPlaying = {
        queue: [],
        idx: 0
      };
    }

    var initAlbumQuery = localStorage.getItem('initAlbumQuery') || 'newest';
    var initAlbumID3 = localStorage.getItem('initAlbumID3') === 'true';

    this.state = {
      isShowingMenu: false, // for applications that use it e.g., tv
      // only for visual state reference but all album queries need to send the id3 parameter now
      albumID3: initAlbumID3,

      chromecastAvailable: false,
      chromecastConnected: false,

      isConnected: false,

      postLoginRoute: 'playlists',

      lastLoadingTitle: null,

      allPlaylists: [],
      playlists: [],
      stations: [],
      browsingPlaylist: null,

      internetStations: [],

      playlist: null,
      playlistInfo: null,
      playlistEntries: [],
      playlistNeedsSave: false,
      sortRule: null,
      shufflePlaylist: false,

      musicFolder: initMusicFolder,
      musicFolders: [],

      musicDirectoryIndexes: [],
      musicDirectoryIndex: null,

      nowPlaying: [],
      // username: name, player: id
      following: null,

      albumQuery: initAlbumQuery,
      albumPage: 0,
      albumsPerPage: 64,
      albums: [],
      hasMoreAlbums: false,

      podcasts: null,

      bookmarkContext: null,
      bookmarks: [],
      bookmarksById: {},

      // not sure we'll use this...
      browsing: {
        type: null, // top-folder, musicDirectory, playlists, playlistSongs, artists, artistAlbums, artistAlbumSongs, getSongsQuery, search?
        contents: []
      },

      allArtistIndexes: [],
      artistIndexes: [],
      artistIndex: {},
      artist: null, // contains the full artist+album stuff
      album: null,
      albumsById: {},

      videos: [],

      searchMusicFolder: -1, // always All Music Folders at first
      searchAlbumResults: [],
      searchArtistResults: [],
      searchSongsResults: [],

      currentPlaying: currentPlaying,
      currentQueue: currentPlaying.queue || [],

      albumsAsGrid: true,

      isBusy: false
    };

    this.bindActions(_SubsonicActions2.default);
  }

  _createClass(SubsonicStoreClass, [{
    key: 'loginSuccess',
    value: function loginSuccess() {
      var _this = this;

      console.log('loginSuccess');
      this.refreshPlaylists();
      this.refreshInternetStations();
      this.fetchMusicFolders();
      this.getBookmarks();
      _SubsonicSource2.default.fetchAllArtists().then(function (res) {
        _this.setAllArtists(res || []);
        return _SubsonicSource2.default.fetchArtists(_this.state.musicFolder || null);
      }).then(function (res) {
        _this.setArtists(res.indexes || []);
        return _SubsonicSource2.default.fetchIndexes(_this.state.musicFolder || null);
      }).then(function (res) {
        _this.setMusicDirectoryIndexes(res.indexes || []);
      }).catch(function (err) {
        console.error(err);
      });

      this.mergeState({ isConnected: true, podcasts: null });
      _SubsonicActions2.default.snack.defer('Login Successful', {
        variant: 'success',
        autoHideDuration: 3000
      });
    }
  }, {
    key: 'loginFailure',
    value: function loginFailure() {
      console.log('loginFailure');
      this.mergeState({ isConnected: false });
      _SubsonicActions2.default.snack.defer('Login Failure, please try again?', {
        variant: 'error',
        autoHideDuration: 10000
      });
    }
  }, {
    key: 'mergeState',
    value: function mergeState(newValues) {
      var s = this.state,
          rv = Object.assign({}, s, newValues);
      this.setState(rv);

      if (newValues.currentPlaying) {
        delete window.bookmarkSeekTo;
        this.persistQueueLocally();
      }
    }
  }, {
    key: 'toggleMenu',
    value: function toggleMenu() {
      this.mergeState({ isShowingMenu: !this.state.isShowingMenu });
    }
  }, {
    key: 'toggleAlbumsAsGrid',
    value: function toggleAlbumsAsGrid() {
      this.mergeState({ albumsAsGrid: !this.state.albumsAsGrid });
    }
  }, {
    key: 'setPostLoginRoute',
    value: function setPostLoginRoute(route) {
      this.mergeState({ postLoginRoute: route });
    }
  }, {
    key: 'setChromecastAvailable',
    value: function setChromecastAvailable(chromecastAvailable) {
      this.mergeState({ chromecastAvailable: chromecastAvailable });
    }
  }, {
    key: 'setChromecastConnected',
    value: function setChromecastConnected(chromecastConnected) {
      this.mergeState({ chromecastConnected: chromecastConnected });
    }
  }, {
    key: 'setBusy',
    value: function setBusy(busy) {
      this.mergeState({ isBusy: busy });
    }
  }, {
    key: 'followUser',
    value: function followUser(following) {
      this.mergeState({ following: following });
    }

    // ----------------------- STATION ------------------------

  }, {
    key: 'selectStation',
    value: function selectStation(pl) {
      var _this2 = this;

      this.mergeState({ isBusy: true });
      window.fetcher = _SubsonicSource2.default.fetcher;
      pl = this.state.stations.find(function (p) {
        return p.id + '' === pl + '';
      });
      _SubsonicSource2.default.generateStation(pl).then(function (r) {
        _this2.populateStation(r);
      }).finally(function () {
        _this2.mergeState({ isBusy: false });
      });
    }
  }, {
    key: 'populateStation',
    value: function populateStation(data) {
      var entry = data && data.playlist ? data.playlist.entry || [] : [];
      this._storeCurrentQueue(entry);
    }
  }, {
    key: 'refreshInternetStations',
    value: function refreshInternetStations() {
      var _this3 = this;

      _SubsonicSource2.default.refreshInternetStations().then(function (r) {
        _this3.setInternetStations(r);
      }).finally(function () {});
    }
  }, {
    key: 'setInternetStations',
    value: function setInternetStations(data) {
      // console.warn('IS', data);
      this.mergeState({ internetStations: data });
    }
  }, {
    key: 'playInternetStation',
    value: function playInternetStation(data) {
      var station = {
        title: data.name,
        artist: '',
        album: data.homePageUrl,
        id: data.id,
        src: data.streamUrl
      };
      this._storeCurrentQueue([station]);
    }

    // ---------------------- NOW PLAYING -----------------------

  }, {
    key: 'getNowPlaying',
    value: function getNowPlaying() {
      var _this4 = this;

      _SubsonicSource2.default.getNowPlaying().then(function (r) {
        _this4.returnNowPlaying(r);
      }).finally(function () {});
    }
  }, {
    key: 'returnNowPlaying',
    value: function returnNowPlaying(np) {
      this.mergeState({
        nowPlaying: np.entry ? !Array.isArray(np.entry) ? [np.entry] : np.entry : []
      });
    }

    // ------------------------  VIDEOS -----------------------

  }, {
    key: 'getVideos',
    value: function getVideos() {
      var _this5 = this;

      this.mergeState({ isBusy: true });
      _SubsonicSource2.default.fetchVideos().then(function (r) {
        _this5.retrievedVideos(r);
      }).finally(function () {
        _this5.mergeState({ isBusy: false });
      });
    }
  }, {
    key: 'retrievedVideos',
    value: function retrievedVideos(res) {
      // console.log(res);
      this.mergeState({ videos: res });
    }

    // ---------------------- PLAYLISTS -----------------------

  }, {
    key: 'refreshPlaylists',
    value: function refreshPlaylists() {
      // console.log(SubsonicSource);
      _SubsonicSource2.default.refreshPlaylists().then(function (r) {
        // this needs to post through the action so that RemotesStore gets it.
        _SubsonicActions2.default.retrievedPlaylists(r);
      }).finally(function () {});
      this.mergeState({ playlist: null, sortRule: 'unsorted' });
    }
  }, {
    key: 'retrievedPlaylists',
    value: function retrievedPlaylists(_ref) {
      var allPlaylists = _ref.allPlaylists,
          playlists = _ref.playlists,
          stations = _ref.stations;

      // console.log("retrieved", arguments);
      allPlaylists = allPlaylists || [];
      playlists = playlists || [];
      stations = stations || [];

      this.mergeState({
        allPlaylists: allPlaylists,
        playlists: playlists,
        stations: stations,
        sortRule: 'unsorted'
      });
    }

    // ------------------------ PLAYLIST --------------------

  }, {
    key: 'selectPlaylist',
    value: function selectPlaylist(_ref2) {
      var _this6 = this;

      var _ref3 = _slicedToArray(_ref2, 2),
          id = _ref3[0],
          mode = _ref3[1];

      console.log('store selectPlaylist', id, mode);
      var shuffle = mode === 'shuffle';
      var loadOnly = mode === 'list';

      var playlist = this.state.allPlaylists.find(function (p) {
        return p.id + '' === id + '';
      });
      if (playlist) {
        this.mergeState({
          playlist: playlist,
          shufflePlaylist: shuffle,
          isBusy: true
        });
        _SubsonicSource2.default.fetchPlaylist(playlist.id).then(function (r) {
          _this6.populatePlaylist([r, loadOnly]);
        }).finally(function () {
          _this6.mergeState({ isBusy: false });
        });
      }
    }
  }, {
    key: 'populatePlaylist',
    value: function populatePlaylist(_ref4) {
      var _ref5 = _slicedToArray(_ref4, 2),
          _ref5$ = _ref5[0],
          playlist = _ref5$.playlist,
          entries = _ref5$.entries,
          loadOnly = _ref5[1];

      console.warn('populate', playlist, entries, this.state.shufflePlaylist, loadOnly);
      var playlistData = entries || [];
      var shufflePlaylist = this.state.shufflePlaylist;

      this.mergeState({
        playlistInfo: playlist,
        playlistEntries: playlistData,
        sortRule: 'unsorted',
        playlistNeedsSave: false
      });
      if (shufflePlaylist) {
        playlistData = (0, _utils.arrayShuffle)(playlistData);
      }
      if (!loadOnly) this._storeCurrentQueue(entries);
    }

    // these two *may* be used here, but i'm more likely to move
    // them over to the editor store instead

    // properties set by binding

  }, {
    key: 'sortFunction',
    value: function sortFunction(prop, dir, prop2, prop3, a, b) {
      var av = a[prop] || '';
      var bv = b[prop] || '';
      if (av < bv) return dir === 'asc' ? -1 : 1;
      if (av > bv) return dir === 'asc' ? 1 : -1;
      return prop2 ? this.sortFunction(prop2, dir, prop3, null, a, b) : 1;
    }
  }, {
    key: 'sortPlaylist',
    value: function sortPlaylist(rule) {
      var playlistData = this.state.playlistEntries;
      if (rule === 'unsorted' || !playlistData) {
        this.mergeState({ sortRule: rule, playlistNeedsSave: true });
        return;
      }
      var regex = /(.*) (.*)/;
      if (rule === 'shuffle') {
        playlistData = (0, _utils.arrayShuffle)(playlistData);
      } else {
        var a = regex.exec(rule);
        var prop = a[1];
        var dir = a[2];
        var prop2 = null;
        var prop3 = null;
        if (prop === 'album') {
          prop2 = 'track';
        }
        if (prop === 'artist') {
          prop2 = 'album';
          prop3 = 'track';
        }
        playlistData = playlistData.sort(this.sortFunction.bind(this, prop, dir, prop2, prop3));
      }
      this.mergeState({
        playlistEntries: playlistData,
        sortRule: rule === 'shuffle' ? 'unsorted' : rule,
        playlistNeedsSave: true
      });
    }

    // ------------------------ BROWSING PODCASTS --------------------

  }, {
    key: 'fetchPodcasts',
    value: function fetchPodcasts() {
      var _this7 = this;

      this.mergeState({ isBusy: true });
      _SubsonicSource2.default.fetchPodcasts().then(function (r) {
        _this7.returnPodcasts(r);
      }).finally(function () {
        _this7.mergeState({ isBusy: false });
      });
    }
  }, {
    key: 'returnPodcasts',
    value: function returnPodcasts(channels) {
      // console.warn('isBusy false coming podcasts', channels);
      this.mergeState({
        podcasts: channels || []
      });
    }
  }, {
    key: 'playPodcast',
    value: function playPodcast(stream) {
      // massage stream into 'song' format
      var pc = Object.assign({}, stream);
      pc.id = stream.streamId;
      this.startPlaying([pc, 0]);
    }

    // ----------------------- BROWSING ALBUM QUERY ----------------------

  }, {
    key: 'setAlbumQuery',
    value: function setAlbumQuery(_ref6) {
      var _ref7 = _slicedToArray(_ref6, 2),
          query = _ref7[0],
          id3 = _ref7[1];

      var s = this.state;
      // if (s.albumQuery === query && s.albums.length !== 0) return;
      s.albumQuery = query;
      s.albumPage = 0;
      s.albums = [];
      s.albumID3 = id3; // now just a setting for loader and ui to use, not an internal state
      this.mergeState(s);
      this.fetchAlbumPage([0, id3]);

      localStorage.setItem('initAlbumID3', id3);
      localStorage.setItem('initAlbumQuery', query || 'newest');
    }
  }, {
    key: 'fetchAlbumPage',
    value: function fetchAlbumPage(_ref8) {
      var _this8 = this;

      var _ref9 = _slicedToArray(_ref8, 2),
          page = _ref9[0],
          id3 = _ref9[1];

      console.log('fetching page', page);
      var s = this.state;
      s.albumPage = page;

      var offset = s.albumPage * s.albumsPerPage;
      var limit = s.albumsPerPage;

      var folder = s.musicFolder || -1;
      if (s.albumQuery.startsWith('pl-')) {
        var pl = s.allPlaylists.find(function (p) {
          return p.id = s.albumQuery.substr(3);
        });
        if (!pl) return;
        this.mergeState({ isBusy: true });
        _SubsonicSource2.default.fetchPlaylistAsAlbums(pl, offset, limit, folder, id3).then(function (r) {
          _this8.returnAlbumPage(r);
        }).finally(function () {
          _this8.mergeState({ isBusy: false });
        });
      } else {
        this.mergeState({ isBusy: true });
        _SubsonicSource2.default.fetchAlbums(s.albumQuery, offset, limit, folder, id3).then(function (r) {
          _this8.returnAlbumPage(r);
        }).finally(function () {
          _this8.mergeState({ isBusy: false });
        });
      }

      // pause fetching
      s.hasMoreAlbums = false;
      this.setState(s);
    }
  }, {
    key: 'returnAlbumPage',
    value: function returnAlbumPage(albums) {
      // console.warn(albums);
      if (Array.isArray(albums)) {
        albums = {
          albumList: albums
        };
      }
      var s = this.state;
      s.albums = s.albums.concat(albums.albumList);
      s.hasMoreAlbums = albums.albumList.length > 0 && s.albums.length < 400;
      this.setState(s);
    }
  }, {
    key: 'setMusicDirectory',
    value: function setMusicDirectory(id) {
      var _this9 = this;

      // console.log('setMusicDirectory', id);
      if (id) {
        this.mergeState({ isBusy: true });
        _SubsonicSource2.default.fetchMusicDirectory(id).then(function (r) {
          _this9.retrievedMusicDirectory(r);
        }).finally(function () {
          _this9.mergeState({ isBusy: false });
        });
      }
      this.mergeState({
        musicDirectoryId: id,
        musicDirectoryContents: null,
        isBusy: true
      });
    }
  }, {
    key: 'playMusicDirectorySongs',
    value: function playMusicDirectorySongs(_ref10) {
      var _this10 = this;

      var _ref11 = _slicedToArray(_ref10, 2),
          musicDirectory = _ref11[0],
          _ref11$ = _ref11[1],
          type = _ref11$ === undefined ? 'all' : _ref11$;

      console.log('playMusicDirectorySongs', musicDirectory, type);
      if ((typeof musicDirectory === 'undefined' ? 'undefined' : _typeof(musicDirectory)) !== 'object') {
        musicDirectory = {
          id: musicDirectory,
          name: musicDirectory
        };
      }
      this.mergeState({ isBusy: true });
      _SubsonicSource2.default.playMusicDirectorySongs(musicDirectory, type).then(function (r) {
        _this10._storeCurrentQueue(r);
      }).finally(function () {
        _this10.mergeState({ isBusy: false });
      });
    }
  }, {
    key: 'retrievedMusicDirectory',
    value: function retrievedMusicDirectory(_ref12) {
      var directory = _ref12.directory,
          children = _ref12.children;

      // console.log('retrievedMusicDirectory', dir, items, play);
      // TODO: music directory browsing when play is false
      var play = false;
      if (play) {
        children = children.filter(function (i) {
          return !i.isDir;
        });
        this._storeCurrentQueue(children);
      } else {
        this.mergeState({
          musicDirectory: directory,
          musicDirectoryContents: children,
          isBusy: false
        });
      }
    }
  }, {
    key: 'playSong',
    value: function playSong(id) {
      var _this11 = this;

      this.setState({ isBusy: true });
      _SubsonicSource2.default.fetchSong(id).then(function (r) {
        _this11.retrievedSong(r);
      }).finally(function () {
        _this11.mergeState({ isBusy: false });
      });
    }
  }, {
    key: 'retrievedSong',
    value: function retrievedSong(song) {
      this._storeCurrentQueue([song]);
    }

    // ------------------------ BROWSING ARTISTS/ALBUMS --------------------

  }, {
    key: 'setAllArtists',
    value: function setAllArtists(artists) {
      console.log('setAllArtists', artists);
      this.mergeState({ allArtistIndexes: artists });
    }
  }, {
    key: 'setArtists',
    value: function setArtists(artistIndexes) {
      console.log('setArtists', artistIndexes);
      artistIndexes = artistIndexes || [];
      if (!Array.isArray(artistIndexes)) artistIndexes = [artistIndexes];
      var artists = [];
      for (var i = 0; i < artistIndexes.length; ++i) {
        artists = artists.concat(artistIndexes[i].artist);
      }
      this.mergeState({
        artistIndexes: artistIndexes,
        artists: artists,
        artistIndex: null,
        artist: null,
        artistAlbums: null
      });
    }
  }, {
    key: 'setArtistIndex',
    value: function setArtistIndex(index) {
      console.log('new index', index);
      this.mergeState({ artistIndex: index, artist: null, artistAlbums: null });
    }
  }, {
    key: 'setArtist',
    value: function setArtist(artist) {
      var _this12 = this;

      // console.warn('setArtist', artist);
      this.mergeState({ artist: artist, artistAlbums: null, isBusy: true });
      if (artist) {
        this.mergeState({ isBusy: true });
        _SubsonicSource2.default.fetchArtist(artist.id).then(function (r) {
          _this12.setArtistAlbums(r);
        }).finally(function () {
          _this12.mergeState({ isBusy: false });
        });
      }
    }
  }, {
    key: 'setArtistAlbums',
    value: function setArtistAlbums(artistAlbums) {
      // console.warn('back, setting busy false');
      this.mergeState({
        artist: artistAlbums,
        artistAlbums: artistAlbums,
        isBusy: false
      });
    }
  }, {
    key: 'setAndPlayArtistSongs',
    value: function setAndPlayArtistSongs(_ref13) {
      var _this13 = this;

      var _ref14 = _slicedToArray(_ref13, 2),
          artist = _ref14[0],
          _ref14$ = _ref14[1],
          type = _ref14$ === undefined ? 'all' : _ref14$;

      this.setState({ isBusy: true });
      _SubsonicSource2.default.playArtistSongs(artist, type).then(function (r) {
        _this13._storeCurrentQueue(r);
      }).finally(function () {
        _this13.setState({ isBusy: false });
      });
    }
  }, {
    key: 'playArtistSongs',
    value: function playArtistSongs() {
      var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'all';

      this.setAndPlayArtistSongs([this.state.artist, type]);
    }
  }, {
    key: 'loadAlbum',
    value: function loadAlbum(_ref15) {
      var _ref16 = _slicedToArray(_ref15, 2),
          id = _ref16[0],
          id3 = _ref16[1];

      var s = this.state;
      if (id3) {
        this.setAlbum(id);
      } else {
        this.setMusicDirectory(id);
      }
    }
  }, {
    key: 'setAlbum',
    value: function setAlbum(id) {
      var _this14 = this;

      if (id) {
        this.mergeState({ isBusy: true });
        _SubsonicSource2.default.fetchAlbum(id).then(function (r) {
          _this14.retrievedAlbum(r);
        }).finally(function () {
          _this14.setState({ isBusy: false });
        });
      }
    }
  }, {
    key: 'retrievedAlbum',
    value: function retrievedAlbum(album) {
      console.log('retrievedAlbum', album);
      var albumsById = this.state.albumsById;
      albumsById[album.id + ''] = album;
      this.mergeState({
        albumsById: albumsById
      });
    }

    // ------------------------ BROWSING MUSIC FOLDERS --------------------

  }, {
    key: 'shuffleMusicFolder',
    value: function shuffleMusicFolder(folder) {
      var _this15 = this;

      console.log('event shuffleMusicFolder', folder, this.state.musicFolder);
      folder = folder || this.state.musicFolder || -1;
      this.mergeState({ isBusy: true });
      _SubsonicSource2.default.fetchRandomSongs(folder).then(function (r) {
        _this15._storeCurrentQueue(r);
      }).finally(function () {
        _this15.mergeState({ isBusy: false });
      });
    }
  }, {
    key: 'fetchMusicFolders',
    value: function fetchMusicFolders() {
      var _this16 = this;

      this.mergeState({ isBusy: true });
      _SubsonicSource2.default.fetchMusicFolders().then(function (r) {
        _this16.setMusicFolders(r);
      }).finally(function () {
        _this16.mergeState({ isBusy: false });
      });
    }
  }, {
    key: 'setMusicFolders',
    value: function setMusicFolders(musicFolders) {
      console.log('musicFolders', musicFolders);
      // TODO:[JS] add all music folders to the top
      var defaultFolder = {
        id: -1,
        name: 'All Music Folders'
      };
      musicFolders.unshift(defaultFolder);
      this.mergeState({
        musicFolders: musicFolders,
        musicFolder: this.state.musicFolder || defaultFolder.id
      });
    }
  }, {
    key: 'setMusicFolder',
    value: function setMusicFolder(musicFolder) {
      var _this17 = this;

      console.log('musicFolder', musicFolder);

      this.mergeState({
        musicFolder: musicFolder,
        musicDirectoryId: null,
        musicDirectoryContents: null,
        isBusy: true
      });
      // refresh the current state to the new folder selection
      _SubsonicSource2.default.fetchArtists(this.state.musicFolder || null).then(function (res) {
        _this17.setArtists(res.indexes || []);
        return _SubsonicSource2.default.fetchIndexes(_this17.state.musicFolder || null);
      }).then(function (res) {
        _this17.setMusicDirectoryIndexes(res.indexes || []);
        _SubsonicActions2.default.setAlbumQuery([_this17.state.albumQuery, _this17.state.albumID3]);
      }).finally(function () {
        _this17.mergeState({ isBusy: false });
      });
      localStorage.setItem('initMusicFolder', musicFolder || -1);
    }
  }, {
    key: 'setSearchMusicFolder',
    value: function setSearchMusicFolder(musicFolder) {
      console.log('searchMusicFolder', musicFolder);
      this.mergeState({ searchMusicFolder: musicFolder });
    }
  }, {
    key: 'setMusicDirectoryIndexes',
    value: function setMusicDirectoryIndexes(musicDirectoryIndexes) {
      var musicDirectories = [];
      if (!Array.isArray(musicDirectoryIndexes)) {
        musicDirectoryIndexes = [musicDirectoryIndexes];
      }
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = musicDirectoryIndexes[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var mdi = _step.value;

          musicDirectories = musicDirectories.concat(mdi.artist);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      this.mergeState({
        musicDirectoryIndexes: musicDirectoryIndexes,
        musicDirectoryIndex: null,
        musicDirectories: musicDirectories
      });
    }
  }, {
    key: 'setMusicDirectoryIndex',
    value: function setMusicDirectoryIndex(index) {
      this.mergeState({ musicDirectoryIndex: index });
    }
  }, {
    key: 'appendToPlayQueue',
    value: function appendToPlayQueue(entry) {
      var currentPlaying = Object.assign({}, this.state.currentPlaying);
      if (!Array.isArray(entry)) entry = [entry];
      if (currentPlaying.queue.length === 2 && currentPlaying.queue[1] === emptytrack) {
        currentPlaying.queue.pop(0);
      }
      currentPlaying.queue = currentPlaying.queue.concat(entry);
      if (currentPlaying.queue.length === 1) currentPlaying.queue = currentPlaying.queue.concat([emptytrack]);
      this.mergeState({ currentPlaying: currentPlaying });
    }

    // ------------- server play queue --------------

  }, {
    key: 'fetchPlayQueue',
    value: function fetchPlayQueue() {
      var _this18 = this;

      this.mergeState({ isBusy: true });
      console.log('getPlayQueue');
      _SubsonicSource2.default.fetchPlayQueue().then(function (r) {
        console.warn('fpq', r);
        window.bookmarkSeekTo = r.position / 1000;
        _this18._storeCurrentQueue(r.entry);
        _this18.mergeState({ playQueue: r });
      }).finally(function () {
        console.warn('fpq finally');
        _this18.mergeState({ isBusy: false });
      });
    }
  }, {
    key: 'savePlayQueue',
    value: function savePlayQueue(currentMediaTime) {
      var _state$currentPlaying = this.state.currentPlaying,
          queue = _state$currentPlaying.queue,
          idx = _state$currentPlaying.idx;

      _SubsonicSource2.default.savePlayQueue(queue, idx, currentMediaTime).then(function (r) {
        _SubsonicActions2.default.snack.defer('Queue Saved', {
          variant: 'success',
          autoHideDuration: 3000
        });
      });
    }

    // ------------- play queue ------------

  }, {
    key: 'startPlayingCurrentQueue',
    value: function startPlayingCurrentQueue() {
      this.startPlaying([this.state.currentQueue || [emptytrack], 0]);
    }
  }, {
    key: '_storeCurrentQueue',
    value: function _storeCurrentQueue(entry) {
      console.warn('_storeCurrentQueue', entry);
      this.mergeState({ currentQueue: entry });
    }
  }, {
    key: 'startPlaying',
    value: function startPlaying(_ref17) {
      var _ref18 = _slicedToArray(_ref17, 2),
          queue = _ref18[0],
          current = _ref18[1];

      console.warn('startPlaying', queue, current);
      var currentPlaying = this.state.currentPlaying;
      if (!Array.isArray(queue)) queue = [queue];
      if (queue.length === 1) queue.push(emptytrack);
      currentPlaying.queue = queue;

      var idx = (typeof current === 'undefined' ? 'undefined' : _typeof(current)) === 'object' ? current.id ? current.id : 0 : parseInt(current, 10);
      for (var i = 0; i < queue.length; ++i) {
        // console.log(i, pl[i].id, c, pl[i].id === c+"");
        if (queue[i].id + '' === idx + '') {
          idx = i;
          break;
        }
      }

      currentPlaying.idx = idx || 0;
      console.log('setting via start sp');
      this.mergeState({ currentPlaying: currentPlaying });
    }
  }, {
    key: 'playerNext',
    value: function playerNext() {
      var currentPlaying = this.state.currentPlaying;
      currentPlaying.idx++;

      console.log('playerNext', currentPlaying.idx, currentPlaying.queue.length, currentPlaying);

      if (currentPlaying.idx >= currentPlaying.queue.length) currentPlaying.idx = 0;
      this.mergeState({ currentPlaying: currentPlaying });
    }
  }, {
    key: 'playerSkip',
    value: function playerSkip() {
      var currentPlaying = this.state.currentPlaying;
      var a = currentPlaying.queue[currentPlaying.idx].albumId;
      var q = currentPlaying.queue;
      do {
        currentPlaying.idx++;
      } while (q[currentPlaying.idx] && q[currentPlaying.idx].albumId === a && currentPlaying.idx < q.length);
      if (!q[currentPlaying.idx] || currentPlaying.idx > q.length) currentPlaying.idx = 0;
      this.mergeState({ currentPlaying: currentPlaying });
    }
  }, {
    key: 'playerSkipToTrack',
    value: function playerSkipToTrack(entry) {
      var _entry = entry,
          bookmarkId = _entry.bookmarkId,
          position = _entry.position;

      var id = bookmarkId || entry.id;
      var currentPlaying = this.state.currentPlaying;
      var q = currentPlaying.queue;
      var match = false;
      for (var i = 0; i < q.length; ++i) {
        if (id * 1 === q[i].id * 1) {
          currentPlaying.idx = i;
          match = true;
        }
      }
      if (!match && this.state.bookmarksById && this.state.bookmarksById[bookmarkId]) {
        entry = this.state.bookmarksById[bookmarkId].entry;
        q.unshift(entry);
        currentPlaying.idx = 0;
      }
      this.mergeState({ currentPlaying: currentPlaying });
      // hack - need to pass this through, once it is loaded
      window.bookmarkSeekTo = parseInt(position || '0', 10) / 1000;
    }
  }, {
    key: 'playerSkipToIndex',
    value: function playerSkipToIndex(idx) {
      var currentPlaying = this.state.currentPlaying;
      currentPlaying.idx = idx;
      this.mergeState({ currentPlaying: currentPlaying });
    }
  }, {
    key: 'playerPrev',
    value: function playerPrev() {
      var currentPlaying = this.state.currentPlaying;
      currentPlaying.idx--;
      if (currentPlaying.idx === -1) currentPlaying.idx = currentPlaying.queue.length - 1;
      this.mergeState({ currentPlaying: currentPlaying });
    }
  }, {
    key: 'stopPlaying',
    value: function stopPlaying() {
      // const currentPlaying = this.state.currentPlaying;
      // currentPlaying.queue = [];
      // this.mergeState({currentPlaying: currentPlaying});
    }
  }, {
    key: 'shufflePlaying',
    value: function shufflePlaying() {
      var currentPlaying = this.state.currentPlaying;
      currentPlaying.queue = (0, _utils.arrayShuffle)(currentPlaying.queue);
      currentPlaying.idx = 0;
      this.mergeState({ currentPlaying: currentPlaying });
    }
  }, {
    key: 'setBookmarkContext',
    value: function setBookmarkContext(context) {
      // console.log('bookmark context', context);
      this.mergeState({ bookmarkContext: context });
    }
  }, {
    key: 'createBookmark',
    value: function createBookmark(_ref19) {
      var _this19 = this;

      var _ref20 = _slicedToArray(_ref19, 2),
          id = _ref20[0],
          position = _ref20[1];

      // assemble context as
      var context = Object.assign({}, this.state.bookmarkContext);
      var comment = JSON.stringify(context);
      _SubsonicSource2.default.createBookmark(id, position, comment).then(function () {
        _SubsonicActions2.default.snack.defer('Bookmark Saved', {
          variant: 'success',
          autoHideDuration: 3000
        });
        _this19.getBookmarks();
      });
    }
  }, {
    key: 'deleteBookmark',
    value: function deleteBookmark(id) {
      var _this20 = this;

      _SubsonicSource2.default.deleteBookmark(id).then(function () {
        _this20.getBookmarks();
      });
    }
  }, {
    key: 'getBookmarks',
    value: function getBookmarks() {
      var _this21 = this;

      this.mergeState({ isBusy: true });
      _SubsonicSource2.default.getBookmarks().then(function (res) {
        _this21.storeBookmarks(res);
      }).finally(function () {
        _this21.mergeState({ isBusy: false });
      });
    }
  }, {
    key: 'storeBookmarks',
    value: function storeBookmarks(bookmarks) {
      console.log('bookmarks', bookmarks, typeof bookmarks === 'undefined' ? 'undefined' : _typeof(bookmarks));
      bookmarks = bookmarks || [];
      if (!Array.isArray(bookmarks)) bookmarks = [bookmarks];
      var bookmarksById = bookmarks.reduce(function (bmi, b, i, a) {
        //console.log('reduce', bmi, 'b', b, 'i', i, 'a', a);
        bmi[b.entry.id] = b;
        return bmi;
      }, {});
      //console.log(bookmarks, bookmarksById);
      this.mergeState({
        bookmarks: bookmarks,
        bookmarksById: bookmarksById || {}
      });
    }
  }, {
    key: 'setOffline',
    value: function setOffline(offline) {
      this.mergeState({ offline: offline });
    }
  }, {
    key: 'setLoadingTitle',
    value: function setLoadingTitle(title) {
      this.mergeState({ lastLoadingTitle: title });
    }
  }, {
    key: 'doSearch',
    value: function doSearch(_ref21) {
      var _this22 = this;

      var searchType = _ref21.searchType,
          query = _ref21.query,
          nextPage = _ref21.nextPage,
          pageSize = _ref21.pageSize,
          id3 = _ref21.id3;

      if (!nextPage) {
        this.mergeState({
          searchArtistResults: [],
          searchAlbumResults: [],
          searchSongsResults: []
        });
      }
      var params = {
        artistCount: searchType === 'artist' ? pageSize : 0,
        artistOffset: searchType === 'artist' ? pageSize * nextPage : 0,
        albumCount: searchType === 'album' ? pageSize : 0,
        albumOffset: searchType === 'album' ? pageSize * nextPage : 0,
        songCount: searchType === 'song' ? pageSize : 0,
        songOffset: searchType === 'song' ? pageSize * nextPage : 0
      };
      var musicFolderId = this.state.searchMusicFolder;
      if (musicFolderId && musicFolderId + '' !== '-1') params.musicFolderId = musicFolderId;
      _SubsonicSource2.default.search(query, id3, params).then(function (r) {
        _this22.searchResults(r);
      }).finally(function () {});
    }
  }, {
    key: 'searchResults',
    value: function searchResults(res) {
      console.warn(res);
      this.mergeState({
        searchArtistResults: this.state.searchArtistResults.concat(res.artist),
        searchAlbumResults: this.state.searchAlbumResults.concat(res.album),
        searchSongsResults: this.state.searchSongsResults.concat(res.song)
      });
    }
  }, {
    key: 'persistQueueLocally',
    value: function persistQueueLocally() {
      window.localStorage.setItem('subsonic.lastPlaying', JSON.stringify(this.state.currentPlaying));
      window.localStorage.setItem('subsonic.lastPlaying.currentMediaTime', '' + this.state.currentMediaTime);
    }
  }, {
    key: 'setSnackerFunction',
    value: function setSnackerFunction(f) {
      // console.warn('snacker-f', f);
      this.mergeState(f);
    }
  }, {
    key: 'snack',
    value: function snack(_ref22) {
      var _ref23 = _slicedToArray(_ref22, 2),
          message = _ref23[0],
          options = _ref23[1];

      // console.log('snack', message, options, this.state.snack);
      // varient = varient || {};
      // varient.autoHideDuration = 50000;

      if (this.state.snack) {
        this.state.snack(message, options);
      }
    }
  }]);

  return SubsonicStoreClass;
}();

SubsonicStore = _Dispatcher2.default.createStore(SubsonicStoreClass, 'SubsonicStore');
exports.default = SubsonicStore;