import React from 'react';

class GradientBackground extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      currentGradient: 0
    };
  }

  shouldComponentUpdate(props, state) {
    return (
      props.showGradients !== this.props.showGradients ||
      props.gradients !== this.props.gradients ||
      state.currentGradient !== this.state.currentGradient
    );
  }

  nextGradient() {
    if (this.props.single) return;

    let currentGradient = this.state.currentGradient + 1;
    if (currentGradient > this.props.gradients.length) currentGradient = 0;
    this.setState({
      currentGradient: currentGradient
    });
    if (this.props.gradientChanged) this.props.gradientChanged();
  }

  componentDidMount() {
    this.timer = setInterval(this.nextGradient.bind(this), 12000);
  }

  UNSAFE_componentWillReceiveProps(nextProps) {
    if (
      nextProps.gradients !== this.props.gradients ||
      this.props.single !== nextProps.single
    ) {
      this.setState({
        currentGradient: 0
      });
    }
  }

  componentWillUnmount() {
    clearInterval(this.timer);
    document.getElementsByTagName('body')[0].style.background = '#000000';
  }

  render() {
    const { gradients, showGradients } = this.props;
    const { currentGradient } = this.state;
    const background =
      showGradients && gradients.length !== 0
        ? gradients[currentGradient]
        : '#000000';

    // console.log(gradients, showGradients, background);

    document.getElementsByTagName('body')[0].style.background = background;
    return <span />;
  }
}

export default GradientBackground;
