import React from 'react';
import { Gradients } from 'utils/colors';
import ColorActions from 'subfire/actions/ColorActions';

class GradientGeneratingImage extends React.Component {
  imageRef = img => {
    if (img) {
      img.onload = () => {
        var g = Gradients.createRandomGradients(img, 10, 30, true);
        if (this.props.gradientsLoaded) this.props.gradientsLoaded(g);
        ColorActions.setGradients(g);
      };
    }
  };

  render() {
    const style = {};
    if (this.props.size) {
      style.width = '100%';
      style.maxWidth = this.props.size;
      style.height = 'auto';
    }
    return (
      <img
        crossOrigin="anonymous"
        alt=""
        ref={this.imageRef}
        src={this.props.src}
        id={this.props.imageId}
        style={style}
        className={this.props.className}
      />
    );
  }
}

export default GradientGeneratingImage;

// http://jwshome.aboutjws.info:4040/rest/getCoverArt.view?id=25600&size=348&v=1.14.0&f=json&c=SubFireMobile&u=subfire&s=wxdntor&t=c4452abc7d637b0dc89fc326a0de9c64
