import React, { Component } from 'react';
import AltContainer from 'alt-container';
import ColorStore from '../../stores/ColorStore';

const ColorContainer = function(props) {
  return (
    <AltContainer
      stores={{
        colors: ColorStore,
        gradients: function(props) {
          return {
            store: ColorStore,
            value: ColorStore.getState().gradients
          };
        },
        palette: function(props) {
          return {
            store: ColorStore,
            value: ColorStore.getState().palette
          };
        }
      }}
    >
      {props.children}
    </AltContainer>
  );
};

export default ColorContainer;
