import React, { PureComponent } from 'react';
import Mousetrap from 'mousetrap';

class Navigator extends PureComponent {
  back = e => {
    window.history.back();
  };

  find = (code, element) => {
    const nav = this.props.navigation;
    var a = nav[code];
    var b = Object.getOwnPropertyNames(a).find(c => {
      return element.matches(c);
    });
    // console.warn(b, a, element);
    if (b) {
      // console.warn(a[b], typeof(a[b]), Array.isArray(a[b]));
      return Array.isArray(a[b]) ? a[b] : [a[b]];
    }
    return [];
  };

  navigate = e => {
    // console.warn('navigate', e.target.id, e.code);
    var nextId = this.find(e.code, e.target);
    // console.warn(nextId);
    var n = nextId.find(sel => {
      // console.warn(sel);
      return document.querySelector(sel);
    });
    // console.warn(n);
    if (n) {
      document.querySelector(n).focus();
    }
  };

  hackInitNavigation = e => {
    var d = document.querySelector(this.props.initialElementSelector);
    if (d) {
      console.warn('hackInitNavigation');
      d.focus();
    }
  };

  componentDidMount() {
    Mousetrap.bind('n a v', this.hackInitNavigation);
    Mousetrap.bind(['up', 'down', 'left', 'right'], this.navigate);
    Mousetrap.bind('esc', this.back);
    Mousetrap.bind('delete', this.back);
    Mousetrap.bind('backspace', this.back);
  }

  render() {
    return <React.Fragment>{this.props.children}</React.Fragment>;
  }
}

export default Navigator;
