import React from 'react';

import Card from '@material-ui/core/Card';
import CardContent from '@material-ui/core/CardContent';
import Typography from '@material-ui/core/Typography';

class MuppetPlayer extends React.Component {
  componentDidMount() {
    console.warn('mount');
  }

  componentWillUnmount() {
    console.warn('unmount');
    var elem = document.querySelector('#tunein-iframe');
    elem.parentNode.removeChild(elem);
  }

  shouldComponentUpdate() {
    return false;
  }

  render() {
    return (
      <React.Fragment>
        <Typography variant="h4">Muppet Central Radio</Typography>

        <Card>
          <CardContent>
            <div className="tunein-player">
              <iframe
                id="tunein-iframe"
                title="tunein"
                src="https://tunein.com/embed/player/s262576/"
                style={{ width: '100%', height: 100, border: 'none' }}
                scrolling="no"
              />
            </div>
          </CardContent>
        </Card>

        <Typography variant="subtitle2">
          Muppet Central Radio is provided through TuneIn. If there is enough
          interest, I may allow this to be more configurable for additional
          TuneIn stations, or perhaps auto-parse the Internet Stations feature
          to find them and auto-launch this.
        </Typography>
      </React.Fragment>
    );
  }
}

export default MuppetPlayer;
