import React from 'react';
import ActionButton from 'subsonic/components/controls/ActionButton';

import {
  PlayArrow,
  Pause,
  SkipNext,
  SkipPrevious,
  Redo,
  Shuffle
} from '@material-ui/icons';

import RemotesActions from 'subfire/actions/RemotesActions';

const play = () => {
  return RemotesActions.sendAction('play');
};
const pause = () => {
  return RemotesActions.sendAction('pause');
};
// const playOrPause = () => {
//   return RemotesActions.sendAction('playOrPause');
// };
const playerNext = () => {
  return RemotesActions.sendAction('playerNext');
};
const playerPrev = () => {
  return RemotesActions.sendAction('playerPrev');
};
const shufflePlaying = () => {
  return RemotesActions.sendAction('shufflePlaying');
};
const playerSkip = () => {
  return RemotesActions.sendAction('playerSkip');
};

export const PlayButton = props => {
  let label = 'play',
    icon = <PlayArrow className={props.iconClassName} />;
  // if (props.isPlaying) {
  //   label = "pause";
  //   icon = <Pause className={props.iconClassName}/>;
  // } else if (props.isLoading) {
  //   label = "loading";
  //   icon = <Update className={props.iconClassName}/>;
  // }
  // console.warn(props);
  const coreProps = {
    // action: props.actions ? props.actions.playOrPause : null,
    action: play,
    label: label,
    disabled: props.isLoading,
    fab: props.fab,
    color: props.color,
    standalone: props.standalone,
    buttonClassName: props.buttonClassName
  };
  return <ActionButton {...coreProps}>{icon}</ActionButton>;
};

export const PauseButton = props => {
  let label = 'pause',
    icon = <Pause className={props.iconClassName} />;
  // if (props.isPlaying) {
  //   label = "pause";
  //   icon = <Pause className={props.iconClassName}/>;
  // } else if (props.isLoading) {
  //   label = "loading";
  //   icon = <Update className={props.iconClassName}/>;
  // }
  // console.warn(props);
  const coreProps = {
    // action: props.actions ? props.actions.playOrPause : null,
    action: pause,
    label: label,
    disabled: props.isLoading,
    fab: props.fab,
    color: props.color,
    standalone: props.standalone,
    buttonClassName: props.buttonClassName
  };
  return <ActionButton {...coreProps}>{icon}</ActionButton>;
};

export const NextButton = props => {
  const icon = <SkipNext className={props.iconClassName} />;
  const coreProps = {
    action: playerNext,
    label: 'next',
    // disabled: props.isLoading,
    fab: props.fab,
    buttonClassName: props.buttonClassName
  };

  return <ActionButton {...coreProps}>{icon}</ActionButton>;
};

export const PrevButton = props => {
  const icon = <SkipPrevious className={props.iconClassName} />;
  const coreProps = {
    action: playerPrev,
    label: 'prev',
    // disabled: props.isLoading,
    fab: props.fab,
    buttonClassName: props.buttonClassName
  };

  return <ActionButton {...coreProps}>{icon}</ActionButton>;
};

export const ShuffleButton = props => {
  const icon = <Shuffle className={props.iconClassName} />;
  const coreProps = {
    action: shufflePlaying,
    label: 'shuffle',
    // disabled: props.isLoading,
    fab: props.fab,
    buttonClassName: props.buttonClassName
  };

  return <ActionButton {...coreProps}>{icon}</ActionButton>;
};

export const SkipAlbumButton = props => {
  const icon = <Redo className={props.iconClassName} />;
  const coreProps = {
    action: playerSkip,
    label: 'skip album',
    // disabled: props.isLoading,
    fab: props.fab,
    buttonClassName: props.buttonClassName
  };

  return <ActionButton {...coreProps}>{icon}</ActionButton>;
};
