import { Component } from 'react';
import RemotesActions from 'subfire/actions/RemotesActions';
import { withRouter } from 'react-router';

class RemoteConfigInit extends Component {
  static getDerivedStateFromProps(props, lastState) {
    const s = props.SubsonicSource;
    if (s && s.initialized) {
      const id = s.fetcher._s + '-' + s.fetcher._u;
      // console.log(lastState.initialized, id);
      if (id !== lastState.initialized) {
        lastState.initialized = false;
      }
    }
    return lastState;
  }

  constructor(props) {
    super(props);
    this.state = { initialized: false };
  }

  shouldComponentUpdate(nextProps, nextState) {
    return nextState.initialized === false;
  }

  componentDidUpdate() {
    if (this.state.initialized) return;
    if (!this.props.SubsonicSource || !this.props.SubsonicSource.initialized)
      return;
    RemotesActions.initRemoteState.defer(
      this.props.SubsonicSource,
      this.props.history
    );

    const s = this.props.SubsonicSource;
    const id = s.fetcher._s + '-' + s.fetcher._u;
    this.setState({
      initialized: id
    });
  }

  componentDidMount() {
    if (this.state.initialized) return;
    if (!this.props.SubsonicSource || !this.props.SubsonicSource.initialized)
      return;
    RemotesActions.initRemoteState.defer(
      this.props.SubsonicSource,
      this.props.history
    );

    const s = this.props.SubsonicSource;
    const id = s.fetcher._s + '-' + s.fetcher._u;
    this.setState({
      initialized: id
    });
  }

  render() {
    return null;
  }
}

export default withRouter(RemoteConfigInit);
