import React from 'react';
import RemoteSenderMenu from 'subfire/components/remotes/RemoteSenderMenu';
import {
  PlayButton,
  NextButton,
  PrevButton,
  SkipAlbumButton,
  PauseButton,
  ShuffleButton
} from 'subfire/components/remotes/MediaButtons';

import { withStyles } from '@material-ui/core/styles';

import Grid from '@material-ui/core/Grid';

const styles = theme => ({
  root: {
    width: '100%',
    maxWidth: 480
  },
  container: {}
});

class RemoteControl extends React.PureComponent {
  render() {
    const { classes, csProps, ...rsProps } = this.props;
    return (
      <div className={classes.root}>
        <Grid container spacing={24} className={classes.container}>
          <Grid item xs={12}>
            <RemoteSenderMenu variant="listItem" {...csProps} {...rsProps} />
          </Grid>
          <Grid item xs={4}>
            <PlayButton
              {...csProps}
              fab={true}
              standalone={false}
              color="primary"
            />
          </Grid>
          <Grid item xs={4}>
            <PauseButton
              {...csProps}
              fab={false}
              standalone={false}
              color="primary"
            />
          </Grid>
          <Grid item xs={4}>
            <SkipAlbumButton {...csProps} />
          </Grid>

          <Grid item xs={4}>
            <PrevButton
              {...csProps}
              buttonClassName="button-class"
              iconClassName="icon-class"
            />
          </Grid>
          <Grid item xs={4}>
            <NextButton {...csProps} />
          </Grid>
          <Grid item xs={4}>
            <ShuffleButton />
          </Grid>
        </Grid>
      </div>
    );
  }
}

export default withStyles(styles)(RemoteControl);
