import alt from 'Dispatcher';
import PreferenceActions, {
  backgroundTypes
} from '../actions/PreferenceActions';

let persisted = localStorage.getItem('subfire.preferences');
if (persisted) {
  persisted = JSON.parse(persisted);
} else {
  persisted = {
    backgroundType: backgroundTypes.fuzzyImage
  };
}

export class PreferenceStoreClass {
  constructor() {
    this.bindActions(PreferenceActions);
    this.backgroundType = persisted.backgroundType;

    this.on('afterEach', (payload, state) => this.afterEach(payload, state));
  }

  setBackgroundType(b) {
    this.backgroundType = b;
  }

  afterEach({ payload, state }) {
    if (payload.details.name.startsWith('setBackgroundType')) {
      localStorage.setItem('subfire.preferences', JSON.stringify(state));
    }
  }
}

export default alt.createStore(PreferenceStoreClass, 'PreferenceStore');
