import React, { Component } from 'react';

import List from '@material-ui/core/List';
import ListItem from '@material-ui/core/ListItem';
import ListItemText from '@material-ui/core/ListItemText';
import Typography from '@material-ui/core/Typography';
import { withStyles } from '@material-ui/core/styles';
import SubsonicActions from 'subsonic/actions/SubsonicActions';

const styles = theme => ({
  li: {
    listStyle: 'none'
  }
});

class LoadedSongsBrowser extends Component {
  handleSongClick = song => {
    if (this.props.remotes.remoteState === 'sender') {
      this.props.history.push('/loading/song/' + song.id);
    } else {
      SubsonicActions.startPlaying(song, 0);
      this.props.history.push('/player');
    }
  };

  render() {
    const currentQueue = this.props.subsonic.currentQueue || [],
      classes = this.props.classes || {};
    let songItems = '';
    songItems = currentQueue.map((s, i, cp) => (
      <ListItem
        classes={{ container: classes.li }}
        id={'songs-li-' + s.id}
        className={classes.songListItem}
        key={s.id}
        button={true}
        onClick={this.handleSongClick.bind(this, s)}
      >
        <ListItemText>
          {i + 1}. {s.title}
          <br />
          <Typography variant="caption">
            {s.artist}- {s.album}
          </Typography>
        </ListItemText>
      </ListItem>
    ));

    return <List className={classes.list}>{songItems}</List>;
  }
}

export default withStyles(styles)(LoadedSongsBrowser);
