import React, { Component } from 'react';

import SubsonicActions from 'subsonic/actions/SubsonicActions';

import Select from '@material-ui/core/Select';
import MenuItem from '@material-ui/core/MenuItem';
import FormControl from '@material-ui/core/FormControl';
import Input from '@material-ui/core/Input';
import InputLabel from '@material-ui/core/InputLabel';

class MusicFolderChooser extends Component {
  // props:
  // musicFolder (id)
  // musicFolders
  // musicFolderchnaged (optional)

  handleChange = evt => {
    if (this.props.musicFolderChanged) {
      this.props.musicFolderChanged(evt.target.value);
      return;
    }

    SubsonicActions.setMusicFolder(evt.target.value);
  };

  render() {
    const props = this.props;
    const { native } = props;
    const musicFolders = props.musicFolders || [];
    const folderItems = musicFolders.map(m => {
      if (native)
        return (
          <option key={m.id} value={m.id}>
            {m.name}
          </option>
        );
      return (
        <MenuItem key={m.id} value={m.id}>
          {m.name}
        </MenuItem>
      );
    });

    const value = (props.musicFolder || -1) * 1;
    //        <Switch label={label} defaultToggled={id3} onToggle={this.handleID3Change} />
    return (
      <FormControl fullWidth>
        <InputLabel htmlFor="folder-query-select">Music Folder</InputLabel>
        <Select
          native={props.native}
          value={value}
          onChange={this.handleChange}
          input={<Input name="folder-query" id="folder-query-select" />}
        >
          {folderItems}
        </Select>
      </FormControl>
    );
  }
}

export default MusicFolderChooser;
