import React, { Component } from 'react';

import Card from '@material-ui/core/Card';
import CardActions from '@material-ui/core/CardActions';
import CardContent from '@material-ui/core/CardContent';
import Button from '@material-ui/core/Button';

import Shuffle from '@material-ui/icons/Shuffle';

import MusicFolderChooser from 'subsonic/components/browsers/MusicFolderChooser';

class MusicFolderShuffler extends Component {
  shuffleClick = () => {
    var id = this.props.subsonic.musicFolder + '' || '-1';
    this.props.history.push('/loading/folderShuffle/' + id);
  };

  render() {
    const props = this.props;
    const styles = {};
    styles.backgroundColor = '#42424288';
    return (
      <Card style={styles}>
        <CardContent>
          <MusicFolderChooser native={this.props.native} {...props.subsonic} />
        </CardContent>
        <CardActions>
          <Button onClick={this.shuffleClick}>
            Shuffle <Shuffle style={{ marginLeft: '10px' }} />
          </Button>
        </CardActions>
      </Card>
    );
  }
}

export default MusicFolderShuffler;
