import React from 'react';
import AltContainer from 'alt-container';
import CredentialsStore from 'subsonic/stores/CredentialsStore';

const CredentialsContainer = function(props) {
  return (
    <AltContainer
      inject={{
        route: props.route
      }}
      stores={{
        credentials: CredentialsStore,
        current: function(props) {
          return {
            store: CredentialsStore,
            value: CredentialsStore.getState().creds[
              CredentialsStore.getState().current
            ]
          };
        }
      }}
    >
      {props.children}
    </AltContainer>
  );
};

export default CredentialsContainer;
