import React from 'react';
import AltContainer from 'alt-container';
import SubsonicStore from 'subsonic/stores/SubsonicStore';
import RemotesStore from 'subfire/stores/RemotesStore';
import SubsonicSource from 'subsonic/sources/SubsonicSource';

// const UpdateCheck = (props) => {
//   console.log('UpdateCheck', props);
//   return "<span/>";
// }

let lastSecond = -1;

const SubsonicContainer = function(props) {
  const inject = {
    SubsonicSource
  };
  if (props.route) inject.route = props.route;
  if (props.location) inject.location = props.location;
  if (props.match) inject.match = props.match;
  if (props.history) inject.history = props.history;

  if (props.csProps) {
    inject.csProps = props.csProps;
    const currentMediaTime = Math.floor(props.csProps.currentMediaTime || -1);
    if (currentMediaTime !== lastSecond) {
      SubsonicStore.state.currentMediaTime = currentMediaTime;
      SubsonicStore.persistQueueLocally();
      lastSecond = currentMediaTime;
    }
  }

  // returns subsonic as the data, route from the react-router match, and SubsonicSource only for the URL generators
  return (
    <AltContainer
      stores={{
        subsonic: SubsonicStore,
        remotes: RemotesStore
      }}
      inject={inject}
    >
      {props.children}
    </AltContainer>
  );
};

export default SubsonicContainer;
