import React from 'react';
import showNotification from 'utils/showNotification';
import SubsonicActions from 'subsonic/actions/SubsonicActions';

export default class Notification extends React.Component {
  constructor(props) {
    super(props);

    if (navigator.mediaSession) {
      navigator.mediaSession.setActionHandler(
        'previoustrack',
        SubsonicActions.playerPrev
      );
      navigator.mediaSession.setActionHandler(
        'nexttrack',
        SubsonicActions.playerNext
      );
    }
  }

  componentDidUpdate(lastProps) {
    const nextProps = this.props;
    console.log('notification update', lastProps, nextProps);
    let show = false;
    if (nextProps.isPlaying) {
      if (
        lastProps.song &&
        nextProps.song &&
        nextProps.song.id !== lastProps.song.id
      ) {
        show = true;
      } else if (!lastProps.isPlaying) {
        show = true;
      }
    }
    if (show) showNotification(nextProps.song, nextProps.mediaIcon);
  }

  shouldComponentUpdate(nextProps) {
    const lastProps = this.props;
    let show = false;
    if (nextProps.isPlaying) {
      if (
        lastProps.song &&
        nextProps.song &&
        nextProps.song.id !== lastProps.song.id
      ) {
        show = true;
      } else if (!lastProps.isPlaying) {
        show = true;
      }
    } else {
      return lastProps.isPlaying;
    }
    return show;
  }

  render() {
    return <React.Fragment />;
  }
}
