import React, { Component } from 'react';
import SubsonicActions from 'subsonic/actions/SubsonicActions';

class NowPlaying extends Component {
  static getDerivedStateFromProps(props, lastState) {
    const newState = {};
    const { following, nowPlaying } = props.subsonic;
    // console.log('following', following, nowPlaying);
    if (following && nowPlaying) {
      const lastSong =
        lastState && lastState.lastSong ? lastState.lastSong : { id: -1 };
      // console.log('last', lastSong);
      const currentSong = props.subsonic.currentPlaying.queue.length
        ? props.subsonic.currentPlaying.queue[props.subsonic.currentPlaying.idx]
        : { id: -1 };
      // console.log('currentSong', currentSong);
      const newSong = nowPlaying.find(np => {
        return (
          np.username === following.username &&
          np.playerId === following.playerId
        );
      });
      // console.log('newSong', newSong);
      if (
        newSong &&
        newSong.id !== lastSong.id &&
        newSong.id !== currentSong.id
      ) {
        // console.log('appending...');
        newState.lastSong = newSong;
        SubsonicActions.appendToPlayQueue.defer(newSong);
      }
    }
    return Object.assign({}, lastState, newState);
  }

  constructor(props) {
    super(props);
    // this.state = NowPlaying.getDerivedStateFromProps(props);
    this.state = {};
  }

  // componentWillReceiveProps(nextProps) {
  //   this.setState(NowPlaying.getDerivedStateFromProps(nextProps, this.state));
  // }

  shouldComponentUpdate(nextProps, nextState) {
    return false;
  }

  componentDidMount() {
    SubsonicActions.getNowPlaying.defer();
    this.interval = setInterval(SubsonicActions.getNowPlaying.defer, 10000);
  }

  componentWillUnmount() {
    clearInterval(this.interval);
  }

  render() {
    return <span />;
  }
}

export default NowPlaying;
