import React, { Component } from 'react';

import Slider from '@material-ui/core/Slider';

class RangeSlider extends Component {
  static getDerivedStateFromProps(props, state) {
    // console.log(
    //   'ds',
    //   props.currentMediaTime,
    //   state.seekValue,
    //   state.isDragging
    // );
    if (state.isDragging)
      return {
        seekValue: state.seekValue
      };
    return {
      seekValue: props.currentMediaTime
    };
  }

  constructor(props) {
    super(props);
    this.state = {
      isDragging: false
    };
  }

  sliderChange = (e, v) => {
    this.setState({ isDragging: true, seekValue: v }, () => {
      this.props.seekValueChange && this.props.seekValueChange(this.state);
    });
  };

  // sliderChangeStart = () => {
  //   console.warn('start');
  //   this.setState({ isDragging: true }, () => {
  //     this.props.seekValueChange && this.props.seekValueChange(this.state);
  //   });
  // };

  sliderChangeComplete = () => {
    if (this.props.actions && this.props.actions.seekTo) {
      this.props.actions.seekTo(this.state.seekValue);
    }
    this.setState({ isDragging: false }, () => {
      this.props.seekValueChange && this.props.seekValueChange(this.state);
    });
  };

  render() {
    const p = this.props;
    const duration = p.duration || 100;
    const durationString = p.duration ? p.durationString : '*:**';
    const horizontalLabels = {
      0: p.currentMediaTimeString
    };
    horizontalLabels[duration] = durationString;

    // it would be nice if this was in the slider already...hopefully mui's will get it right
    // const emptyClassName = this.state.seekValue ? '' : 'empty';
    // labels={horizontalLabels}
    return (
      <div
        style={{
          overflowX: 'hidden',
          height: 55,
          paddingTop: 20,
          paddingLeft: 20,
          paddingRight: 20
        }}
      >
        <Slider
          min={0}
          max={p.duration || 100}
          value={this.state.seekValue}
          onChange={this.sliderChange}
          onChangeCommitted={this.sliderChangeComplete}
        />
      </div>
    );
  }
}

export default RangeSlider;
