import React from 'react';
import { SnackbarProvider, withSnackbar } from 'notistack';
import SubsonicActions from 'subsonic/actions/SubsonicActions';
import { withStyles } from '@material-ui/core/styles';
import Button from '@material-ui/core/Button';

let _closeSnack;

class SnackBase extends React.Component {
  componentDidMount() {
    // console.warn("setSnackerFunction", this.props.enqueueSnackbar);
    SubsonicActions.setSnackerFunction({ snack: this.props.enqueueSnackbar });
    window.snack = this.props.enqueueSnackbar;
    _closeSnack = this.props.closeSnackbar;
  }

  render() {
    return <span />;
  }
}

const SnackBaseWithSnackbar = withSnackbar(SnackBase);

function Snacker(props) {
  const classes = props.classes;

  const action = key => (
    <Button
      style={{ color: '#ffffff' }}
      size="small"
      key={'snack-action-dismiss'}
      onClick={() => _closeSnack(key)}
    >
      Dismiss
    </Button>
  );

  return (
    <SnackbarProvider
      classes={{ anchorOriginBottomLeft: classes.anchorOriginBottomLeft }}
      action={action}
      maxSnack={3}
    >
      <SnackBaseWithSnackbar />
    </SnackbarProvider>
  );
}

const styles = theme => {
  if (window.isTV)
    return {
      anchorOriginBottomLeft: {
        paddingLeft: '5%',
        paddingBottom: '5%'
      }
    };
  else return {};
};

export default withStyles(styles)(Snacker);
