import React from 'react';
import { Link } from 'react-router-dom';

import Paper from '@material-ui/core/Paper';

const Div = props => {
  return <div className={props.className + ' no-link'}>{props.children}</div>;
};

const CoverCard = props => {
  // const coverArt = props.SubsonicSource.getCoverArtURL(
  //   props.coverArt,
  //   props.size
  // );
  const link = props.link;
  const LinkComponent = link ? Link : Div;
  const className = 'cover-link';
  let category = props.category;

  category = category ? (
    <div className="card-category">{category}</div>
  ) : (
    category
  );

  return (
    <LinkComponent className={className} to={link}>
      <div className="cover-card">
        <div className="cover-art">
          {category}
          <img
            crossOrigin="anonymous"
            src={props.SubsonicSource.getCoverArtURL(
              props.coverArt,
              props.size
            )}
            alt={props.name}
          />
        </div>
        <div className="cover-text">
          <Paper square className="cover-paper">
            {props.name}
          </Paper>
        </div>
      </div>
    </LinkComponent>
  );
};

export default CoverCard;
