import React from 'react';
import GridListTile from '@material-ui/core/GridListTile';
import GridListTileBar from '@material-ui/core/GridListTileBar';
import IconButton from '@material-ui/core/IconButton';
import PlayIcon from '@material-ui/icons/PlayArrow';

const CoverGridTile = props => {
  var PlayerRefLink = props.linkComponent;
  const className = props.normal ? '' : 'nowrap';
  const Icon = props.icon || PlayIcon;
  return (
    <GridListTile
      title={props.name + (props.subname ? ' - ' + props.subname : '')}
      style={props.style}
    >
      <img
        crossOrigin="anonymous"
        src={props.SubsonicSource.getCoverArtURL(props.coverArt, props.size)}
        alt={props.name}
        onClick={props.onClick}
      />
      <GridListTileBar
        title={props.name}
        subtitle={<span>{props.subname}</span>}
        className={className}
        actionIcon={
          <PlayerRefLink id={props.id} options={props.options}>
            <IconButton>
              <Icon />
            </IconButton>
          </PlayerRefLink>
        }
      />
    </GridListTile>
  );
};

export default CoverGridTile;
