import React from 'react';

import { withStyles } from '@material-ui/core/styles';
import Typography from '@material-ui/core/Typography';

const styles = theme => {
  return {
    '@media only screen and (min-width: 360px)': {
      flowText: {
        fontSize: '1.2rem'
      }
    },

    '@media only screen and (min-width: 390px)': {
      flowText: {
        fontSize: '1.224rem'
      }
    },

    '@media only screen and (min-width: 420px)': {
      flowText: {
        fontSize: '1.248rem'
      }
    },

    '@media only screen and (min-width: 450px)': {
      flowText: {
        fontSize: '1.272rem'
      }
    },

    '@media only screen and (min-width: 480px)': {
      flowText: {
        fontSize: '1.296rem'
      }
    },

    '@media only screen and (min-width: 510px)': {
      flowText: {
        fontSize: '1.32rem'
      }
    },

    '@media only screen and (min-width: 540px)': {
      flowText: {
        fontSize: '1.344rem'
      }
    },

    '@media only screen and (min-width: 570px)': {
      flowText: {
        fontSize: '1.368rem'
      }
    },

    '@media only screen and (min-width: 600px)': {
      flowText: {
        fontSize: '1.392rem'
      }
    },

    '@media only screen and (min-width: 630px)': {
      flowText: {
        fontSize: '1.416rem'
      }
    },

    '@media only screen and (min-width: 660px)': {
      flowText: {
        fontSize: '1.44rem'
      }
    },

    '@media only screen and (min-width: 690px)': {
      flowText: {
        fontSize: '1.464rem'
      }
    },

    '@media only screen and (min-width: 720px)': {
      flowText: {
        fontSize: '1.488rem'
      }
    },

    '@media only screen and (min-width: 750px)': {
      flowText: {
        fontSize: '1.512rem'
      }
    },

    '@media only screen and (min-width: 780px)': {
      flowText: {
        fontSize: '1.536rem'
      }
    },

    '@media only screen and (min-width: 810px)': {
      flowText: {
        fontSize: '1.56rem'
      }
    },

    '@media only screen and (min-width: 840px)': {
      flowText: {
        fontSize: '1.584rem'
      }
    },

    '@media only screen and (min-width: 870px)': {
      flowText: {
        fontSize: '1.608rem'
      }
    },

    '@media only screen and (min-width: 900px)': {
      flowText: {
        fontSize: '1.632rem'
      }
    },

    '@media only screen and (min-width: 930px)': {
      flowText: {
        fontSize: '1.656rem'
      }
    },

    '@media only screen and (min-width: 960px)': {
      flowText: {
        fontSize: '1.68rem'
      }
    },

    '@media only screen and (max-width: 360px)': {
      flowText: {
        fontSize: '1.2rem'
      }
    }
  };
};

const FlowText = props => {
  const { classes, children, ...p } = props;
  return (
    <Typography {...p} className={classes.flowText}>
      {children}
    </Typography>
  );
};

export default withStyles(styles)(FlowText);
