import React from 'react';

import Fab from '@material-ui/core/Fab';
import TopIcon from '@material-ui/icons/VerticalAlignTop';
import { withStyles, withTheme } from '@material-ui/core/styles';

var scrollToTop = props => {
  if (props.selector) {
    var x = document.querySelector(props.selector);
    x.scrollTo(0, 0);
  } else {
    document.body.scrollTop = document.documentElement.scrollTop = 0;
    if (window.scrollTo) window.scrollTo(0, 0);
  }
};

const styles = theme => {
  // console.warn(theme);
  return {
    fab: {
      position: 'fixed',
      zIndex: 100
    }
  };
};

const ScrollToTopFab = props => {
  const { theme } = props;
  let label = 'top',
    icon = <TopIcon />;
  // console.log(props);
  const coreProps = {
    'aria-label': label,
    onClick: props.scrollToTop || scrollToTop.bind(this, props),
    style: {
      bottom: props.bottom || theme.spacing(2) + 20,
      right: props.right || theme.spacing(2) + 35
    }
  };

  return (
    <Fab {...coreProps} className={props.classes.fab}>
      {icon}
    </Fab>
  );
};

export const OldScrollToTopFab = withStyles(styles)(
  withTheme(ScrollToTopFab)
);

const NoScrollToTopFab = () => null;

export default NoScrollToTopFab;
