import React, { Component } from 'react';

import SwipeableDrawer from '@material-ui/core/SwipeableDrawer';
import Button from '@material-ui/core/Button';
import ListSubheader from '@material-ui/core/ListSubheader';

import ArrowForward from '@material-ui/icons/ArrowForward';
import ArrowBack from '@material-ui/icons/ArrowBack';

import SongList from 'subsonic/components/browsers/SongList';

class SongListDrawer extends Component {
  scrollDownList = id => {
    const e = document.getElementById(id);
    if (e && e.scrollIntoView) {
      e.scrollIntoView();
    }
  };

  handleDrawer = () => {
    const idx = this.props.subsonic.currentPlaying.idx;
    setTimeout(() => {
      this.scrollDownList('songs-li-' + idx);
    }, 400);
    if (this.props.handleDrawer) this.props.handleDrawer();
  };

  handleClose = () => {
    if (this.props.handleClose) this.props.handleClose();
  };

  componentDidUpdate(prevProps, prevState, snapshot) {
    if (this.props.open && !prevProps.open) this.handleDrawer();
  }

  render() {
    const { classes, anchor, open, handleSongClick, subsonic } = this.props;
    const ArrowIcon = anchor === 'right' ? ArrowForward : ArrowBack;

    const arrow =
      anchor === 'right' ? (
        <React.Fragment>
          Close <ArrowIcon />
        </React.Fragment>
      ) : (
        <React.Fragment>
          <ArrowIcon /> Close
        </React.Fragment>
      );

    return (
      <SwipeableDrawer
        className={classes.drawer}
        anchor={anchor}
        open={open}
        onClose={this.handleClose}
        onOpen={this.handleDrawer}
      >
        <ListSubheader className={classes.closeButton}>
          <Button onClick={this.handleClose}>{arrow}</Button>
        </ListSubheader>
        {open ? (
          <SongList
            subsonic={subsonic}
            classes={classes}
            contents={subsonic.currentPlaying.queue}
            idx={subsonic.currentPlaying.idx}
            showCover={false}
            handleSongClick={handleSongClick}
          />
        ) : null}
      </SwipeableDrawer>
    );
  }
}

export default SongListDrawer;
