import React from 'react';

import Avatar from '@material-ui/core/Avatar';

import { withStyles } from '@material-ui/core/styles';
const styles = theme => ({
  avatar: {
    background: theme.palette.secondary.dark,
    color: '#ffffff'
  }
});

class SubsonicAvatar extends React.Component {
  static getDerivedStateFromProps(props, state) {
    const { SubsonicSource } = props;
    state = Object.assign({}, state);
    if (state.avatarURL !== SubsonicSource.fetcher.getAvatarURL()) {
      state.avatarURL = SubsonicSource.fetcher.getAvatarURL();
      state.avatarOK = true;
    }
    return state;
  }

  constructor(props) {
    super(props);
    this.state = {
      avatarOK: true
    };
  }

  handleAvatarError = () => {
    const { SubsonicSource } = this.props;
    const username = SubsonicSource.fetcher._u;
    // console.warn('avatar error', username, Boolean(username));
    this.setState({
      avatarOK: !Boolean(username)
    });
  };

  handleAvatarSuccess = () => {
    // console.warn('avatar fine');
    this.setState({ avatarOK: true });
  };

  render() {
    const { classes, SubsonicSource } = this.props;
    const { avatarOK } = this.state;

    const username = SubsonicSource.fetcher._u;
    const avatarURL =
      username && avatarOK !== false
        ? SubsonicSource.fetcher.getAvatarURL()
        : null;
    //      <IconButton className={classes.menuButton} onClick={this.handleMenu}>

    return (
      <Avatar
        className={classes.avatar}
        alt=""
        src={avatarURL}
        imgProps={{
          onError: this.handleAvatarError,
          onLoad: this.handleAvatarSuccess
        }}
      >
        {avatarOK || username.length === 0
          ? ''
          : username.substring(0, 1).toUpperCase()}
      </Avatar>
    );
  }
}

export default withStyles(styles)(SubsonicAvatar);
